/* Device.c generated by valac 0.56.17, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* This is a read-only class, set the properties via PulseAudioManager.*/

#include "sound.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <pulse/pulseaudio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_DEVICE_0_PROPERTY,
	SOUND_DEVICE_INPUT_PROPERTY,
	SOUND_DEVICE_ID_PROPERTY,
	SOUND_DEVICE_CARD_NAME_PROPERTY,
	SOUND_DEVICE_CARD_INDEX_PROPERTY,
	SOUND_DEVICE_DESCRIPTION_PROPERTY,
	SOUND_DEVICE_PORT_NAME_PROPERTY,
	SOUND_DEVICE_DISPLAY_NAME_PROPERTY,
	SOUND_DEVICE_FORM_FACTOR_PROPERTY,
	SOUND_DEVICE_ICON_NAME_PROPERTY,
	SOUND_DEVICE_PROFILES_PROPERTY,
	SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY,
	SOUND_DEVICE_SINK_NAME_PROPERTY,
	SOUND_DEVICE_SINK_INDEX_PROPERTY,
	SOUND_DEVICE_CARD_SINK_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY,
	SOUND_DEVICE_SOURCE_NAME_PROPERTY,
	SOUND_DEVICE_SOURCE_INDEX_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY,
	SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY,
	SOUND_DEVICE_IS_DEFAULT_PROPERTY,
	SOUND_DEVICE_IS_MUTED_PROPERTY,
	SOUND_DEVICE_VOLUME_PROPERTY,
	SOUND_DEVICE_BALANCE_PROPERTY,
	SOUND_DEVICE_NUM_PROPERTIES
};
static GParamSpec* sound_device_properties[SOUND_DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SOUND_DEVICE_REMOVED_SIGNAL,
	SOUND_DEVICE_NUM_SIGNALS
};
static guint sound_device_signals[SOUND_DEVICE_NUM_SIGNALS] = {0};

struct _SoundDevicePrivate {
	gboolean _input;
	gchar* _id;
	gchar* _card_name;
	guint32 _card_index;
	gchar* _description;
	gchar* _port_name;
	gchar* _display_name;
	gchar* _form_factor;
	gchar* _icon_name;
	GeeArrayList* _profiles;
	gchar* _card_active_profile_name;
	gchar* _sink_name;
	gint _sink_index;
	gchar* _card_sink_name;
	gchar* _card_sink_port_name;
	gint _card_sink_index;
	gchar* _source_name;
	gint _source_index;
	gchar* _card_source_name;
	gchar* _card_source_port_name;
	gint _card_source_index;
	gboolean _is_default;
	gboolean _is_muted;
	gdouble _volume;
	gfloat _balance;
};

static gint SoundDevice_private_offset;
static gpointer sound_device_parent_class = NULL;

static GObject * sound_device_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void sound_device_finalize (GObject * obj);
static GType sound_device_get_type_once (void);
static void _vala_sound_device_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sound_device_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_device_get_instance_private (SoundDevice* self)
{
	return G_STRUCT_MEMBER_P (self, SoundDevice_private_offset);
}

SoundDevice*
sound_device_construct (GType object_type,
                        const gchar* id,
                        guint32 card_index,
                        const gchar* port_name)
{
	SoundDevice * self = NULL;
#line 63 "../src/Device.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 63 "../src/Device.vala"
	g_return_val_if_fail (port_name != NULL, NULL);
#line 64 "../src/Device.vala"
	self = (SoundDevice*) g_object_new (object_type, "id", id, "card-index", card_index, "port-name", port_name, NULL);
#line 63 "../src/Device.vala"
	return self;
#line 154 "Device.c"
}

SoundDevice*
sound_device_new (const gchar* id,
                  guint32 card_index,
                  const gchar* port_name)
{
#line 63 "../src/Device.vala"
	return sound_device_construct (SOUND_TYPE_DEVICE, id, card_index, port_name);
#line 164 "Device.c"
}

gchar*
sound_device_get_nice_form_factor (SoundDevice* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 73 "../src/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 199 "Device.c"
	gchar* result;
#line 72 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 73 "../src/Device.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 73 "../src/Device.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("internal")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 213 "Device.c"
			default:
			{
				gchar* _tmp4_;
#line 75 "../src/Device.vala"
				_tmp4_ = g_strdup (_ ("Built-in"));
#line 75 "../src/Device.vala"
				result = _tmp4_;
#line 75 "../src/Device.vala"
				return result;
#line 223 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("speaker")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 229 "Device.c"
			default:
			{
				gchar* _tmp5_;
#line 77 "../src/Device.vala"
				_tmp5_ = g_strdup (_ ("Speaker"));
#line 77 "../src/Device.vala"
				result = _tmp5_;
#line 77 "../src/Device.vala"
				return result;
#line 239 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("handset")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 245 "Device.c"
			default:
			{
				gchar* _tmp6_;
#line 79 "../src/Device.vala"
				_tmp6_ = g_strdup (_ ("Handset"));
#line 79 "../src/Device.vala"
				result = _tmp6_;
#line 79 "../src/Device.vala"
				return result;
#line 255 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("tv")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 261 "Device.c"
			default:
			{
				gchar* _tmp7_;
#line 81 "../src/Device.vala"
				_tmp7_ = g_strdup (_ ("TV"));
#line 81 "../src/Device.vala"
				result = _tmp7_;
#line 81 "../src/Device.vala"
				return result;
#line 271 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("webcam")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 277 "Device.c"
			default:
			{
				gchar* _tmp8_;
#line 83 "../src/Device.vala"
				_tmp8_ = g_strdup (_ ("Webcam"));
#line 83 "../src/Device.vala"
				result = _tmp8_;
#line 83 "../src/Device.vala"
				return result;
#line 287 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("microphone")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 293 "Device.c"
			default:
			{
				gchar* _tmp9_;
#line 85 "../src/Device.vala"
				_tmp9_ = g_strdup (_ ("Microphone"));
#line 85 "../src/Device.vala"
				result = _tmp9_;
#line 85 "../src/Device.vala"
				return result;
#line 303 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("headset")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 309 "Device.c"
			default:
			{
				gchar* _tmp10_;
#line 87 "../src/Device.vala"
				_tmp10_ = g_strdup (_ ("Headset"));
#line 87 "../src/Device.vala"
				result = _tmp10_;
#line 87 "../src/Device.vala"
				return result;
#line 319 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("headphone")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 325 "Device.c"
			default:
			{
				gchar* _tmp11_;
#line 89 "../src/Device.vala"
				_tmp11_ = g_strdup (_ ("Headphone"));
#line 89 "../src/Device.vala"
				result = _tmp11_;
#line 89 "../src/Device.vala"
				return result;
#line 335 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("hands-free")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 341 "Device.c"
			default:
			{
				gchar* _tmp12_;
#line 91 "../src/Device.vala"
				_tmp12_ = g_strdup (_ ("Hands-Free"));
#line 91 "../src/Device.vala"
				result = _tmp12_;
#line 91 "../src/Device.vala"
				return result;
#line 351 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("car")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 357 "Device.c"
			default:
			{
				gchar* _tmp13_;
#line 93 "../src/Device.vala"
				_tmp13_ = g_strdup (_ ("Car"));
#line 93 "../src/Device.vala"
				result = _tmp13_;
#line 93 "../src/Device.vala"
				return result;
#line 367 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("hifi")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 373 "Device.c"
			default:
			{
				gchar* _tmp14_;
#line 95 "../src/Device.vala"
				_tmp14_ = g_strdup (_ ("HiFi"));
#line 95 "../src/Device.vala"
				result = _tmp14_;
#line 95 "../src/Device.vala"
				return result;
#line 383 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("computer")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 389 "Device.c"
			default:
			{
				gchar* _tmp15_;
#line 97 "../src/Device.vala"
				_tmp15_ = g_strdup (_ ("Computer"));
#line 97 "../src/Device.vala"
				result = _tmp15_;
#line 97 "../src/Device.vala"
				return result;
#line 399 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("portable")))) {
#line 73 "../src/Device.vala"
		switch (0) {
#line 405 "Device.c"
			default:
			{
				gchar* _tmp16_;
#line 99 "../src/Device.vala"
				_tmp16_ = g_strdup (_ ("Portable"));
#line 99 "../src/Device.vala"
				result = _tmp16_;
#line 99 "../src/Device.vala"
				return result;
#line 415 "Device.c"
			}
		}
	} else {
#line 73 "../src/Device.vala"
		switch (0) {
#line 421 "Device.c"
			default:
			{
				const gchar* _tmp17_ = NULL;
				gboolean _tmp18_;
				gchar* _tmp19_;
#line 101 "../src/Device.vala"
				_tmp18_ = self->priv->_input;
#line 101 "../src/Device.vala"
				if (_tmp18_) {
#line 101 "../src/Device.vala"
					_tmp17_ = _ ("Input");
#line 433 "Device.c"
				} else {
#line 101 "../src/Device.vala"
					_tmp17_ = _ ("Output");
#line 437 "Device.c"
				}
#line 101 "../src/Device.vala"
				_tmp19_ = g_strdup (_tmp17_);
#line 101 "../src/Device.vala"
				result = _tmp19_;
#line 101 "../src/Device.vala"
				return result;
#line 445 "Device.c"
			}
		}
	}
}

gchar*
sound_device_get_matching_profile (SoundDevice* self,
                                   SoundDevice* other_device)
{
	gchar* result;
#line 105 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../src/Device.vala"
	if (other_device != NULL) {
#line 460 "Device.c"
		{
			GeeArrayList* _profile_list = NULL;
			GeeArrayList* _tmp0_;
			gint _profile_size = 0;
			GeeArrayList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			gint _profile_index = 0;
#line 107 "../src/Device.vala"
			_tmp0_ = self->priv->_profiles;
#line 107 "../src/Device.vala"
			_profile_list = _tmp0_;
#line 107 "../src/Device.vala"
			_tmp1_ = _profile_list;
#line 107 "../src/Device.vala"
			_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 107 "../src/Device.vala"
			_tmp3_ = _tmp2_;
#line 107 "../src/Device.vala"
			_profile_size = _tmp3_;
#line 107 "../src/Device.vala"
			_profile_index = -1;
#line 107 "../src/Device.vala"
			while (TRUE) {
#line 485 "Device.c"
				gint _tmp4_;
				gint _tmp5_;
				gchar* profile = NULL;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				GeeArrayList* _tmp8_;
				const gchar* _tmp9_;
#line 107 "../src/Device.vala"
				_profile_index = _profile_index + 1;
#line 107 "../src/Device.vala"
				_tmp4_ = _profile_index;
#line 107 "../src/Device.vala"
				_tmp5_ = _profile_size;
#line 107 "../src/Device.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 107 "../src/Device.vala"
					break;
#line 503 "Device.c"
				}
#line 107 "../src/Device.vala"
				_tmp6_ = _profile_list;
#line 107 "../src/Device.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _profile_index);
#line 107 "../src/Device.vala"
				profile = (gchar*) _tmp7_;
#line 108 "../src/Device.vala"
				_tmp8_ = other_device->priv->_profiles;
#line 108 "../src/Device.vala"
				_tmp9_ = profile;
#line 108 "../src/Device.vala"
				if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, _tmp9_)) {
#line 109 "../src/Device.vala"
					result = profile;
#line 109 "../src/Device.vala"
					return result;
#line 521 "Device.c"
				}
#line 107 "../src/Device.vala"
				_g_free0 (profile);
#line 525 "Device.c"
			}
		}
	}
#line 114 "../src/Device.vala"
	result = NULL;
#line 114 "../src/Device.vala"
	return result;
#line 533 "Device.c"
}

gboolean
sound_device_get_input (SoundDevice* self)
{
	gboolean result;
#line 28 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 28 "../src/Device.vala"
	result = self->priv->_input;
#line 28 "../src/Device.vala"
	return result;
#line 546 "Device.c"
}

void
sound_device_set_input (SoundDevice* self,
                        gboolean value)
{
	gboolean old_value;
#line 28 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Device.vala"
	old_value = sound_device_get_input (self);
#line 28 "../src/Device.vala"
	if (old_value != value) {
#line 28 "../src/Device.vala"
		self->priv->_input = value;
#line 28 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY]);
#line 564 "Device.c"
	}
}

const gchar*
sound_device_get_id (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/Device.vala"
	_tmp0_ = self->priv->_id;
#line 29 "../src/Device.vala"
	result = _tmp0_;
#line 29 "../src/Device.vala"
	return result;
#line 581 "Device.c"
}

static void
sound_device_set_id (SoundDevice* self,
                     const gchar* value)
{
	gchar* old_value;
#line 29 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Device.vala"
	old_value = sound_device_get_id (self);
#line 29 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 595 "Device.c"
		gchar* _tmp0_;
#line 29 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/Device.vala"
		_g_free0 (self->priv->_id);
#line 29 "../src/Device.vala"
		self->priv->_id = _tmp0_;
#line 29 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_ID_PROPERTY]);
#line 605 "Device.c"
	}
}

const gchar*
sound_device_get_card_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Device.vala"
	_tmp0_ = self->priv->_card_name;
#line 30 "../src/Device.vala"
	result = _tmp0_;
#line 30 "../src/Device.vala"
	return result;
#line 622 "Device.c"
}

void
sound_device_set_card_name (SoundDevice* self,
                            const gchar* value)
{
	gchar* old_value;
#line 30 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Device.vala"
	old_value = sound_device_get_card_name (self);
#line 30 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 636 "Device.c"
		gchar* _tmp0_;
#line 30 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Device.vala"
		_g_free0 (self->priv->_card_name);
#line 30 "../src/Device.vala"
		self->priv->_card_name = _tmp0_;
#line 30 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_NAME_PROPERTY]);
#line 646 "Device.c"
	}
}

guint32
sound_device_get_card_index (SoundDevice* self)
{
	guint32 result;
#line 31 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 31 "../src/Device.vala"
	result = self->priv->_card_index;
#line 31 "../src/Device.vala"
	return result;
#line 660 "Device.c"
}

static void
sound_device_set_card_index (SoundDevice* self,
                             guint32 value)
{
	guint32 old_value;
#line 31 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Device.vala"
	old_value = sound_device_get_card_index (self);
#line 31 "../src/Device.vala"
	if (old_value != value) {
#line 31 "../src/Device.vala"
		self->priv->_card_index = value;
#line 31 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_INDEX_PROPERTY]);
#line 678 "Device.c"
	}
}

const gchar*
sound_device_get_description (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/Device.vala"
	_tmp0_ = self->priv->_description;
#line 32 "../src/Device.vala"
	result = _tmp0_;
#line 32 "../src/Device.vala"
	return result;
#line 695 "Device.c"
}

void
sound_device_set_description (SoundDevice* self,
                              const gchar* value)
{
	gchar* old_value;
#line 32 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Device.vala"
	old_value = sound_device_get_description (self);
#line 32 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 709 "Device.c"
		gchar* _tmp0_;
#line 32 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/Device.vala"
		_g_free0 (self->priv->_description);
#line 32 "../src/Device.vala"
		self->priv->_description = _tmp0_;
#line 32 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_DESCRIPTION_PROPERTY]);
#line 719 "Device.c"
	}
}

const gchar*
sound_device_get_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Device.vala"
	_tmp0_ = self->priv->_port_name;
#line 33 "../src/Device.vala"
	result = _tmp0_;
#line 33 "../src/Device.vala"
	return result;
#line 736 "Device.c"
}

static void
sound_device_set_port_name (SoundDevice* self,
                            const gchar* value)
{
	gchar* old_value;
#line 33 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Device.vala"
	old_value = sound_device_get_port_name (self);
#line 33 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 750 "Device.c"
		gchar* _tmp0_;
#line 33 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/Device.vala"
		_g_free0 (self->priv->_port_name);
#line 33 "../src/Device.vala"
		self->priv->_port_name = _tmp0_;
#line 33 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_PORT_NAME_PROPERTY]);
#line 760 "Device.c"
	}
}

const gchar*
sound_device_get_display_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 34 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Device.vala"
	_tmp0_ = self->priv->_display_name;
#line 34 "../src/Device.vala"
	result = _tmp0_;
#line 34 "../src/Device.vala"
	return result;
#line 777 "Device.c"
}

void
sound_device_set_display_name (SoundDevice* self,
                               const gchar* value)
{
	gchar* old_value;
#line 34 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Device.vala"
	old_value = sound_device_get_display_name (self);
#line 34 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 791 "Device.c"
		gchar* _tmp0_;
#line 34 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 34 "../src/Device.vala"
		_g_free0 (self->priv->_display_name);
#line 34 "../src/Device.vala"
		self->priv->_display_name = _tmp0_;
#line 34 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY]);
#line 801 "Device.c"
	}
}

const gchar*
sound_device_get_form_factor (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 35 "../src/Device.vala"
	result = _tmp0_;
#line 35 "../src/Device.vala"
	return result;
#line 818 "Device.c"
}

void
sound_device_set_form_factor (SoundDevice* self,
                              const gchar* value)
{
	gchar* old_value;
#line 35 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Device.vala"
	old_value = sound_device_get_form_factor (self);
#line 35 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 832 "Device.c"
		gchar* _tmp0_;
#line 35 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Device.vala"
		_g_free0 (self->priv->_form_factor);
#line 35 "../src/Device.vala"
		self->priv->_form_factor = _tmp0_;
#line 35 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY]);
#line 842 "Device.c"
	}
}

const gchar*
sound_device_get_icon_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Device.vala"
	_tmp0_ = self->priv->_icon_name;
#line 36 "../src/Device.vala"
	result = _tmp0_;
#line 36 "../src/Device.vala"
	return result;
#line 859 "Device.c"
}

void
sound_device_set_icon_name (SoundDevice* self,
                            const gchar* value)
{
	gchar* old_value;
#line 36 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Device.vala"
	old_value = sound_device_get_icon_name (self);
#line 36 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 873 "Device.c"
		gchar* _tmp0_;
#line 36 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../src/Device.vala"
		_g_free0 (self->priv->_icon_name);
#line 36 "../src/Device.vala"
		self->priv->_icon_name = _tmp0_;
#line 36 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_ICON_NAME_PROPERTY]);
#line 883 "Device.c"
	}
}

GeeArrayList*
sound_device_get_profiles (SoundDevice* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 37 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Device.vala"
	_tmp0_ = self->priv->_profiles;
#line 37 "../src/Device.vala"
	result = _tmp0_;
#line 37 "../src/Device.vala"
	return result;
#line 900 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 37 "../src/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 908 "Device.c"
}

void
sound_device_set_profiles (SoundDevice* self,
                           GeeArrayList* value)
{
	GeeArrayList* old_value;
#line 37 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Device.vala"
	old_value = sound_device_get_profiles (self);
#line 37 "../src/Device.vala"
	if (old_value != value) {
#line 922 "Device.c"
		GeeArrayList* _tmp0_;
#line 37 "../src/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 37 "../src/Device.vala"
		_g_object_unref0 (self->priv->_profiles);
#line 37 "../src/Device.vala"
		self->priv->_profiles = _tmp0_;
#line 37 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_PROFILES_PROPERTY]);
#line 932 "Device.c"
	}
}

const gchar*
sound_device_get_card_active_profile_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 38 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 38 "../src/Device.vala"
	_tmp0_ = self->priv->_card_active_profile_name;
#line 38 "../src/Device.vala"
	result = _tmp0_;
#line 38 "../src/Device.vala"
	return result;
#line 949 "Device.c"
}

void
sound_device_set_card_active_profile_name (SoundDevice* self,
                                           const gchar* value)
{
	gchar* old_value;
#line 38 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Device.vala"
	old_value = sound_device_get_card_active_profile_name (self);
#line 38 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 963 "Device.c"
		gchar* _tmp0_;
#line 38 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 38 "../src/Device.vala"
		_g_free0 (self->priv->_card_active_profile_name);
#line 38 "../src/Device.vala"
		self->priv->_card_active_profile_name = _tmp0_;
#line 38 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY]);
#line 973 "Device.c"
	}
}

const gchar*
sound_device_get_sink_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/Device.vala"
	_tmp0_ = self->priv->_sink_name;
#line 41 "../src/Device.vala"
	result = _tmp0_;
#line 41 "../src/Device.vala"
	return result;
#line 990 "Device.c"
}

void
sound_device_set_sink_name (SoundDevice* self,
                            const gchar* value)
{
	gchar* old_value;
#line 41 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Device.vala"
	old_value = sound_device_get_sink_name (self);
#line 41 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1004 "Device.c"
		gchar* _tmp0_;
#line 41 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 41 "../src/Device.vala"
		_g_free0 (self->priv->_sink_name);
#line 41 "../src/Device.vala"
		self->priv->_sink_name = _tmp0_;
#line 41 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SINK_NAME_PROPERTY]);
#line 1014 "Device.c"
	}
}

gint
sound_device_get_sink_index (SoundDevice* self)
{
	gint result;
#line 42 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 42 "../src/Device.vala"
	result = self->priv->_sink_index;
#line 42 "../src/Device.vala"
	return result;
#line 1028 "Device.c"
}

void
sound_device_set_sink_index (SoundDevice* self,
                             gint value)
{
	gint old_value;
#line 42 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Device.vala"
	old_value = sound_device_get_sink_index (self);
#line 42 "../src/Device.vala"
	if (old_value != value) {
#line 42 "../src/Device.vala"
		self->priv->_sink_index = value;
#line 42 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SINK_INDEX_PROPERTY]);
#line 1046 "Device.c"
	}
}

const gchar*
sound_device_get_card_sink_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 43 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Device.vala"
	_tmp0_ = self->priv->_card_sink_name;
#line 43 "../src/Device.vala"
	result = _tmp0_;
#line 43 "../src/Device.vala"
	return result;
#line 1063 "Device.c"
}

void
sound_device_set_card_sink_name (SoundDevice* self,
                                 const gchar* value)
{
	gchar* old_value;
#line 43 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Device.vala"
	old_value = sound_device_get_card_sink_name (self);
#line 43 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1077 "Device.c"
		gchar* _tmp0_;
#line 43 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 43 "../src/Device.vala"
		_g_free0 (self->priv->_card_sink_name);
#line 43 "../src/Device.vala"
		self->priv->_card_sink_name = _tmp0_;
#line 43 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_NAME_PROPERTY]);
#line 1087 "Device.c"
	}
}

const gchar*
sound_device_get_card_sink_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/Device.vala"
	_tmp0_ = self->priv->_card_sink_port_name;
#line 44 "../src/Device.vala"
	result = _tmp0_;
#line 44 "../src/Device.vala"
	return result;
#line 1104 "Device.c"
}

void
sound_device_set_card_sink_port_name (SoundDevice* self,
                                      const gchar* value)
{
	gchar* old_value;
#line 44 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/Device.vala"
	old_value = sound_device_get_card_sink_port_name (self);
#line 44 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1118 "Device.c"
		gchar* _tmp0_;
#line 44 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 44 "../src/Device.vala"
		_g_free0 (self->priv->_card_sink_port_name);
#line 44 "../src/Device.vala"
		self->priv->_card_sink_port_name = _tmp0_;
#line 44 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY]);
#line 1128 "Device.c"
	}
}

gint
sound_device_get_card_sink_index (SoundDevice* self)
{
	gint result;
#line 45 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/Device.vala"
	result = self->priv->_card_sink_index;
#line 45 "../src/Device.vala"
	return result;
#line 1142 "Device.c"
}

void
sound_device_set_card_sink_index (SoundDevice* self,
                                  gint value)
{
	gint old_value;
#line 45 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Device.vala"
	old_value = sound_device_get_card_sink_index (self);
#line 45 "../src/Device.vala"
	if (old_value != value) {
#line 45 "../src/Device.vala"
		self->priv->_card_sink_index = value;
#line 45 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY]);
#line 1160 "Device.c"
	}
}

const gchar*
sound_device_get_source_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 48 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Device.vala"
	_tmp0_ = self->priv->_source_name;
#line 48 "../src/Device.vala"
	result = _tmp0_;
#line 48 "../src/Device.vala"
	return result;
#line 1177 "Device.c"
}

void
sound_device_set_source_name (SoundDevice* self,
                              const gchar* value)
{
	gchar* old_value;
#line 48 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/Device.vala"
	old_value = sound_device_get_source_name (self);
#line 48 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1191 "Device.c"
		gchar* _tmp0_;
#line 48 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 48 "../src/Device.vala"
		_g_free0 (self->priv->_source_name);
#line 48 "../src/Device.vala"
		self->priv->_source_name = _tmp0_;
#line 48 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SOURCE_NAME_PROPERTY]);
#line 1201 "Device.c"
	}
}

gint
sound_device_get_source_index (SoundDevice* self)
{
	gint result;
#line 49 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../src/Device.vala"
	result = self->priv->_source_index;
#line 49 "../src/Device.vala"
	return result;
#line 1215 "Device.c"
}

void
sound_device_set_source_index (SoundDevice* self,
                               gint value)
{
	gint old_value;
#line 49 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Device.vala"
	old_value = sound_device_get_source_index (self);
#line 49 "../src/Device.vala"
	if (old_value != value) {
#line 49 "../src/Device.vala"
		self->priv->_source_index = value;
#line 49 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_SOURCE_INDEX_PROPERTY]);
#line 1233 "Device.c"
	}
}

const gchar*
sound_device_get_card_source_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/Device.vala"
	_tmp0_ = self->priv->_card_source_name;
#line 50 "../src/Device.vala"
	result = _tmp0_;
#line 50 "../src/Device.vala"
	return result;
#line 1250 "Device.c"
}

void
sound_device_set_card_source_name (SoundDevice* self,
                                   const gchar* value)
{
	gchar* old_value;
#line 50 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/Device.vala"
	old_value = sound_device_get_card_source_name (self);
#line 50 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1264 "Device.c"
		gchar* _tmp0_;
#line 50 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/Device.vala"
		_g_free0 (self->priv->_card_source_name);
#line 50 "../src/Device.vala"
		self->priv->_card_source_name = _tmp0_;
#line 50 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY]);
#line 1274 "Device.c"
	}
}

const gchar*
sound_device_get_card_source_port_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 51 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/Device.vala"
	_tmp0_ = self->priv->_card_source_port_name;
#line 51 "../src/Device.vala"
	result = _tmp0_;
#line 51 "../src/Device.vala"
	return result;
#line 1291 "Device.c"
}

void
sound_device_set_card_source_port_name (SoundDevice* self,
                                        const gchar* value)
{
	gchar* old_value;
#line 51 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/Device.vala"
	old_value = sound_device_get_card_source_port_name (self);
#line 51 "../src/Device.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1305 "Device.c"
		gchar* _tmp0_;
#line 51 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 51 "../src/Device.vala"
		_g_free0 (self->priv->_card_source_port_name);
#line 51 "../src/Device.vala"
		self->priv->_card_source_port_name = _tmp0_;
#line 51 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY]);
#line 1315 "Device.c"
	}
}

gint
sound_device_get_card_source_index (SoundDevice* self)
{
	gint result;
#line 52 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "../src/Device.vala"
	result = self->priv->_card_source_index;
#line 52 "../src/Device.vala"
	return result;
#line 1329 "Device.c"
}

void
sound_device_set_card_source_index (SoundDevice* self,
                                    gint value)
{
	gint old_value;
#line 52 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Device.vala"
	old_value = sound_device_get_card_source_index (self);
#line 52 "../src/Device.vala"
	if (old_value != value) {
#line 52 "../src/Device.vala"
		self->priv->_card_source_index = value;
#line 52 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY]);
#line 1347 "Device.c"
	}
}

gboolean
sound_device_get_is_default (SoundDevice* self)
{
	gboolean result;
#line 55 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/Device.vala"
	result = self->priv->_is_default;
#line 55 "../src/Device.vala"
	return result;
#line 1361 "Device.c"
}

void
sound_device_set_is_default (SoundDevice* self,
                             gboolean value)
{
	gboolean old_value;
#line 55 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/Device.vala"
	old_value = sound_device_get_is_default (self);
#line 55 "../src/Device.vala"
	if (old_value != value) {
#line 55 "../src/Device.vala"
		self->priv->_is_default = value;
#line 55 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY]);
#line 1379 "Device.c"
	}
}

gboolean
sound_device_get_is_muted (SoundDevice* self)
{
	gboolean result;
#line 56 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/Device.vala"
	result = self->priv->_is_muted;
#line 56 "../src/Device.vala"
	return result;
#line 1393 "Device.c"
}

void
sound_device_set_is_muted (SoundDevice* self,
                           gboolean value)
{
	gboolean old_value;
#line 56 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/Device.vala"
	old_value = sound_device_get_is_muted (self);
#line 56 "../src/Device.vala"
	if (old_value != value) {
#line 56 "../src/Device.vala"
		self->priv->_is_muted = value;
#line 56 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY]);
#line 1411 "Device.c"
	}
}

gdouble
sound_device_get_volume (SoundDevice* self)
{
	gdouble result;
#line 57 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 57 "../src/Device.vala"
	result = self->priv->_volume;
#line 57 "../src/Device.vala"
	return result;
#line 1425 "Device.c"
}

void
sound_device_set_volume (SoundDevice* self,
                         gdouble value)
{
	gdouble old_value;
#line 57 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/Device.vala"
	old_value = sound_device_get_volume (self);
#line 57 "../src/Device.vala"
	if (old_value != value) {
#line 57 "../src/Device.vala"
		self->priv->_volume = value;
#line 57 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY]);
#line 1443 "Device.c"
	}
}

gfloat
sound_device_get_balance (SoundDevice* self)
{
	gfloat result;
#line 58 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 58 "../src/Device.vala"
	result = self->priv->_balance;
#line 58 "../src/Device.vala"
	return result;
#line 1457 "Device.c"
}

void
sound_device_set_balance (SoundDevice* self,
                          gfloat value)
{
	gfloat old_value;
#line 58 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 58 "../src/Device.vala"
	old_value = sound_device_get_balance (self);
#line 58 "../src/Device.vala"
	if (old_value != value) {
#line 58 "../src/Device.vala"
		self->priv->_balance = value;
#line 58 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY]);
#line 1475 "Device.c"
	}
}

static GObject *
sound_device_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundDevice * self;
	GeeLinkedList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 67 "../src/Device.vala"
	parent_class = G_OBJECT_CLASS (sound_device_parent_class);
#line 67 "../src/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 67 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 68 "../src/Device.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL);
#line 68 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 68 "../src/Device.vala"
	self->volume_operations = _tmp0_;
#line 69 "../src/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 69 "../src/Device.vala"
	_tmp2_ = _tmp1_;
#line 69 "../src/Device.vala"
	sound_device_set_profiles (self, _tmp2_);
#line 69 "../src/Device.vala"
	_g_object_unref0 (_tmp2_);
#line 67 "../src/Device.vala"
	return obj;
#line 1512 "Device.c"
}

static void
sound_device_class_init (SoundDeviceClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/Device.vala"
	sound_device_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Device.vala"
	g_type_class_adjust_private_offset (klass, &SoundDevice_private_offset);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_device_get_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_device_set_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_device_constructor;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_device_finalize;
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_INPUT_PROPERTY, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY] = g_param_spec_boolean ("input", "input", "input", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_ID_PROPERTY, sound_device_properties[SOUND_DEVICE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_NAME_PROPERTY] = g_param_spec_string ("card-name", "card-name", "card-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_INDEX_PROPERTY] = g_param_spec_uint ("card-index", "card-index", "card-index", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_DESCRIPTION_PROPERTY, sound_device_properties[SOUND_DEVICE_DESCRIPTION_PROPERTY] = g_param_spec_string ("description", "description", "description", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_PORT_NAME_PROPERTY] = g_param_spec_string ("port-name", "port-name", "port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_DISPLAY_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_FORM_FACTOR_PROPERTY, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY] = g_param_spec_string ("form-factor", "form-factor", "form-factor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_ICON_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_ICON_NAME_PROPERTY] = g_param_spec_string ("icon-name", "icon-name", "icon-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_PROFILES_PROPERTY, sound_device_properties[SOUND_DEVICE_PROFILES_PROPERTY] = g_param_spec_object ("profiles", "profiles", "profiles", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY] = g_param_spec_string ("card-active-profile-name", "card-active-profile-name", "card-active-profile-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SINK_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_SINK_NAME_PROPERTY] = g_param_spec_string ("sink-name", "sink-name", "sink-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SINK_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_SINK_INDEX_PROPERTY] = g_param_spec_int ("sink-index", "sink-index", "sink-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_NAME_PROPERTY] = g_param_spec_string ("card-sink-name", "card-sink-name", "card-sink-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY] = g_param_spec_string ("card-sink-port-name", "card-sink-port-name", "card-sink-port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY] = g_param_spec_int ("card-sink-index", "card-sink-index", "card-sink-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SOURCE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_SOURCE_NAME_PROPERTY] = g_param_spec_string ("source-name", "source-name", "source-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_SOURCE_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_SOURCE_INDEX_PROPERTY] = g_param_spec_int ("source-index", "source-index", "source-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY] = g_param_spec_string ("card-source-name", "card-source-name", "card-source-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY] = g_param_spec_string ("card-source-port-name", "card-source-port-name", "card-source-port-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY] = g_param_spec_int ("card-source-index", "card-source-index", "card-source-index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_DEFAULT_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_MUTED_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY] = g_param_spec_boolean ("is-muted", "is-muted", "is-muted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_VOLUME_PROPERTY, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_BALANCE_PROPERTY, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY] = g_param_spec_float ("balance", "balance", "balance", -G_MAXFLOAT, G_MAXFLOAT, (gfloat) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	sound_device_signals[SOUND_DEVICE_REMOVED_SIGNAL] = g_signal_new ("removed", SOUND_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1583 "Device.c"
}

static void
sound_device_instance_init (SoundDevice * self,
                            gpointer klass)
{
#line 24 "../src/Device.vala"
	self->priv = sound_device_get_instance_private (self);
#line 28 "../src/Device.vala"
	self->priv->_input = TRUE;
#line 55 "../src/Device.vala"
	self->priv->_is_default = FALSE;
#line 56 "../src/Device.vala"
	self->priv->_is_muted = FALSE;
#line 57 "../src/Device.vala"
	self->priv->_volume = (gdouble) 0;
#line 58 "../src/Device.vala"
	self->priv->_balance = (gfloat) 0;
#line 1602 "Device.c"
}

static void
sound_device_finalize (GObject * obj)
{
	SoundDevice * self;
#line 24 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 29 "../src/Device.vala"
	_g_free0 (self->priv->_id);
#line 30 "../src/Device.vala"
	_g_free0 (self->priv->_card_name);
#line 32 "../src/Device.vala"
	_g_free0 (self->priv->_description);
#line 33 "../src/Device.vala"
	_g_free0 (self->priv->_port_name);
#line 34 "../src/Device.vala"
	_g_free0 (self->priv->_display_name);
#line 35 "../src/Device.vala"
	_g_free0 (self->priv->_form_factor);
#line 36 "../src/Device.vala"
	_g_free0 (self->priv->_icon_name);
#line 37 "../src/Device.vala"
	_g_object_unref0 (self->priv->_profiles);
#line 38 "../src/Device.vala"
	_g_free0 (self->priv->_card_active_profile_name);
#line 41 "../src/Device.vala"
	_g_free0 (self->priv->_sink_name);
#line 43 "../src/Device.vala"
	_g_free0 (self->priv->_card_sink_name);
#line 44 "../src/Device.vala"
	_g_free0 (self->priv->_card_sink_port_name);
#line 48 "../src/Device.vala"
	_g_free0 (self->priv->_source_name);
#line 50 "../src/Device.vala"
	_g_free0 (self->priv->_card_source_name);
#line 51 "../src/Device.vala"
	_g_free0 (self->priv->_card_source_port_name);
#line 61 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (sound_device_parent_class)->finalize (obj);
#line 1645 "Device.c"
}

static GType
sound_device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDevice), 0, (GInstanceInitFunc) sound_device_instance_init, NULL };
	GType sound_device_type_id;
	sound_device_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundDevice", &g_define_type_info, 0);
	SoundDevice_private_offset = g_type_add_instance_private (sound_device_type_id, sizeof (SoundDevicePrivate));
	return sound_device_type_id;
}

GType
sound_device_get_type (void)
{
	static volatile gsize sound_device_type_id__once = 0;
	if (g_once_init_enter (&sound_device_type_id__once)) {
		GType sound_device_type_id;
		sound_device_type_id = sound_device_get_type_once ();
		g_once_init_leave (&sound_device_type_id__once, sound_device_type_id);
	}
	return sound_device_type_id__once;
}

static void
_vala_sound_device_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_input (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ID_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_id (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_uint (value, sound_device_get_card_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DESCRIPTION_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_description (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_display_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_form_factor (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ICON_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_icon_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PROFILES_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_object (value, sound_device_get_profiles (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_active_profile_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_sink_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_sink_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_sink_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_sink_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_card_sink_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_source_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_source_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_source_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_card_source_port_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_int (value, sound_device_get_card_source_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_default (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_muted (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_double (value, sound_device_get_volume (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_float (value, sound_device_get_balance (self));
#line 24 "../src/Device.vala"
		break;
#line 1830 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 1836 "Device.c"
	}
}

static void
_vala_sound_device_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_input (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ID_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_id (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_index (self, g_value_get_uint (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DESCRIPTION_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_description (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_display_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_form_factor (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_ICON_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_icon_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PROFILES_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_profiles (self, g_value_get_object (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_ACTIVE_PROFILE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_active_profile_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_sink_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_sink_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SINK_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_sink_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_source_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_source_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_PORT_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_port_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_CARD_SOURCE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_card_source_index (self, g_value_get_int (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_default (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_muted (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_volume (self, g_value_get_double (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_balance (self, g_value_get_float (value));
#line 24 "../src/Device.vala"
		break;
#line 2000 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 2006 "Device.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

