/* InputPanel.c generated by valac 0.56.17, the Vala compiler
 * generated from InputPanel.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.0-or-later
 * SPDX-FileCopyrightText: 2016-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "sound.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <granite.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_INPUT_PANEL_0_PROPERTY,
	SOUND_INPUT_PANEL_NUM_PROPERTIES
};
static GParamSpec* sound_input_panel_properties[SOUND_INPUT_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block12Data Block12Data;

struct _SoundInputPanelPrivate {
	SoundDevice* default_device;
	GRecMutex __lock_default_device;
	GtkLevelBar* level_bar;
	GtkListBox* devices_listbox;
	GtkScale* volume_scale;
	GtkSwitch* volume_switch;
	SoundInputDeviceMonitor* device_monitor;
	SoundPulseAudioManager* pam;
};

struct _Block12Data {
	int _ref_count_;
	SoundInputPanel* self;
	SoundDevice* device;
};

static gint SoundInputPanel_private_offset;
static gpointer sound_input_panel_parent_class = NULL;

static void sound_input_panel_disconnect_signals (SoundInputPanel* self);
static void sound_input_panel_volume_switch_changed (SoundInputPanel* self);
static void _sound_input_panel_volume_switch_changed_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void sound_input_panel_volume_scale_value_changed (SoundInputPanel* self);
static void _sound_input_panel_volume_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                            gpointer self);
static void sound_input_panel_connect_signals (SoundInputPanel* self);
static void sound_input_panel_default_changed (SoundInputPanel* self);
static void sound_input_panel_device_notify (SoundInputPanel* self,
                                      GParamSpec* pspec);
static void _sound_input_panel_device_notify_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void sound_input_panel_add_device (SoundInputPanel* self,
                                   SoundDevice* device);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
static void __lambda21_ (Block12Data* _data12_);
static void ___lambda21__sound_device_row_set_as_default (SoundDeviceRow* _sender,
                                                   gpointer self);
static GObject * sound_input_panel_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
static void _sound_input_panel___lambda22_ (SoundInputPanel* self,
                                     GtkListBoxRow* row);
static void __sound_input_panel___lambda22__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                 GtkListBoxRow* row,
                                                                 gpointer self);
static void _sound_input_panel___lambda23_ (SoundInputPanel* self,
                                     gfloat fraction);
static void __sound_input_panel___lambda23__sound_input_device_monitor_update_fraction (SoundInputDeviceMonitor* _sender,
                                                                                 gfloat fraction,
                                                                                 gpointer self);
static void _sound_input_panel_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                         SoundDevice* dev,
                                                                         gpointer self);
static void _sound_input_panel___lambda24_ (SoundInputPanel* self);
static void __sound_input_panel___lambda24__g_object_notify (GObject* _sender,
                                                      GParamSpec* pspec,
                                                      gpointer self);
static void sound_input_panel_finalize (GObject * obj);
static GType sound_input_panel_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_input_panel_get_instance_private (SoundInputPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SoundInputPanel_private_offset);
}

void
sound_input_panel_set_visibility (SoundInputPanel* self,
                                  gboolean is_visible)
{
#line 95 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/InputPanel.vala"
	if (is_visible) {
#line 121 "InputPanel.c"
		SoundInputDeviceMonitor* _tmp0_;
#line 97 "../src/InputPanel.vala"
		_tmp0_ = self->priv->device_monitor;
#line 97 "../src/InputPanel.vala"
		sound_input_device_monitor_start_record (_tmp0_);
#line 127 "InputPanel.c"
	} else {
		SoundInputDeviceMonitor* _tmp1_;
#line 99 "../src/InputPanel.vala"
		_tmp1_ = self->priv->device_monitor;
#line 99 "../src/InputPanel.vala"
		sound_input_device_monitor_stop_record (_tmp1_);
#line 134 "InputPanel.c"
	}
}

static void
_sound_input_panel_volume_switch_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 104 "../src/InputPanel.vala"
	sound_input_panel_volume_switch_changed ((SoundInputPanel*) self);
#line 145 "InputPanel.c"
}

static void
_sound_input_panel_volume_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                       gpointer self)
{
#line 105 "../src/InputPanel.vala"
	sound_input_panel_volume_scale_value_changed ((SoundInputPanel*) self);
#line 154 "InputPanel.c"
}

static void
sound_input_panel_disconnect_signals (SoundInputPanel* self)
{
	GtkSwitch* _tmp0_;
	guint _tmp1_;
	GQuark _tmp2_;
	GtkScale* _tmp3_;
	guint _tmp4_;
#line 103 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/InputPanel.vala"
	_tmp0_ = self->priv->volume_switch;
#line 104 "../src/InputPanel.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
#line 104 "../src/InputPanel.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _sound_input_panel_volume_switch_changed_g_object_notify, self);
#line 105 "../src/InputPanel.vala"
	_tmp3_ = self->priv->volume_scale;
#line 105 "../src/InputPanel.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp4_, NULL, FALSE);
#line 105 "../src/InputPanel.vala"
	g_signal_handlers_disconnect_matched ((GtkRange*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _sound_input_panel_volume_scale_value_changed_gtk_range_value_changed, self);
#line 179 "InputPanel.c"
}

static void
sound_input_panel_connect_signals (SoundInputPanel* self)
{
	GtkSwitch* _tmp0_;
	GtkScale* _tmp1_;
#line 108 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 109 "../src/InputPanel.vala"
	_tmp0_ = self->priv->volume_switch;
#line 109 "../src/InputPanel.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) _sound_input_panel_volume_switch_changed_g_object_notify, self, 0);
#line 110 "../src/InputPanel.vala"
	_tmp1_ = self->priv->volume_scale;
#line 110 "../src/InputPanel.vala"
	g_signal_connect_object ((GtkRange*) _tmp1_, "value-changed", (GCallback) _sound_input_panel_volume_scale_value_changed_gtk_range_value_changed, self, 0);
#line 197 "InputPanel.c"
}

static void
sound_input_panel_volume_scale_value_changed (SoundInputPanel* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	GtkScale* _tmp2_;
#line 113 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/InputPanel.vala"
	sound_input_panel_disconnect_signals (self);
#line 115 "../src/InputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 115 "../src/InputPanel.vala"
	_tmp1_ = self->priv->default_device;
#line 115 "../src/InputPanel.vala"
	_tmp2_ = self->priv->volume_scale;
#line 115 "../src/InputPanel.vala"
	sound_pulse_audio_manager_change_device_volume (_tmp0_, _tmp1_, gtk_range_get_value ((GtkRange*) _tmp2_));
#line 116 "../src/InputPanel.vala"
	sound_input_panel_connect_signals (self);
#line 220 "InputPanel.c"
}

static void
sound_input_panel_volume_switch_changed (SoundInputPanel* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 119 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/InputPanel.vala"
	sound_input_panel_disconnect_signals (self);
#line 121 "../src/InputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 121 "../src/InputPanel.vala"
	_tmp1_ = self->priv->default_device;
#line 121 "../src/InputPanel.vala"
	_tmp2_ = self->priv->volume_switch;
#line 121 "../src/InputPanel.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 121 "../src/InputPanel.vala"
	_tmp4_ = _tmp3_;
#line 121 "../src/InputPanel.vala"
	sound_pulse_audio_manager_change_device_mute (_tmp0_, _tmp1_, !_tmp4_);
#line 122 "../src/InputPanel.vala"
	sound_input_panel_connect_signals (self);
#line 249 "InputPanel.c"
}

static void
_sound_input_panel_device_notify_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 129 "../src/InputPanel.vala"
	sound_input_panel_device_notify ((SoundInputPanel*) self, pspec);
#line 259 "InputPanel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../src/InputPanel.vala"
	return self ? g_object_ref (self) : NULL;
#line 267 "InputPanel.c"
}

static void
sound_input_panel_default_changed (SoundInputPanel* self)
{
	GError* _inner_error0_ = NULL;
#line 125 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/InputPanel.vala"
	sound_input_panel_disconnect_signals (self);
#line 278 "InputPanel.c"
	{
		SoundDevice* _tmp0_;
#line 127 "../src/InputPanel.vala"
		_tmp0_ = self->priv->default_device;
#line 127 "../src/InputPanel.vala"
		g_rec_mutex_lock (&self->priv->__lock_default_device);
#line 285 "InputPanel.c"
		{
			SoundDevice* _tmp1_;
			SoundPulseAudioManager* _tmp4_;
			SoundDevice* _tmp5_;
			SoundDevice* _tmp6_;
			SoundDevice* _tmp7_;
			SoundDevice* _tmp8_;
#line 128 "../src/InputPanel.vala"
			_tmp1_ = self->priv->default_device;
#line 128 "../src/InputPanel.vala"
			if (_tmp1_ != NULL) {
#line 297 "InputPanel.c"
				SoundDevice* _tmp2_;
				guint _tmp3_;
#line 129 "../src/InputPanel.vala"
				_tmp2_ = self->priv->default_device;
#line 129 "../src/InputPanel.vala"
				g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp3_, NULL, FALSE);
#line 129 "../src/InputPanel.vala"
				g_signal_handlers_disconnect_matched ((GObject*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _sound_input_panel_device_notify_g_object_notify, self);
#line 306 "InputPanel.c"
			}
#line 132 "../src/InputPanel.vala"
			_tmp4_ = self->priv->pam;
#line 132 "../src/InputPanel.vala"
			_tmp5_ = sound_pulse_audio_manager_get_default_input (_tmp4_);
#line 132 "../src/InputPanel.vala"
			_tmp6_ = _tmp5_;
#line 132 "../src/InputPanel.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 132 "../src/InputPanel.vala"
			_g_object_unref0 (self->priv->default_device);
#line 132 "../src/InputPanel.vala"
			self->priv->default_device = _tmp7_;
#line 133 "../src/InputPanel.vala"
			_tmp8_ = self->priv->default_device;
#line 133 "../src/InputPanel.vala"
			if (_tmp8_ != NULL) {
#line 324 "InputPanel.c"
				SoundInputDeviceMonitor* _tmp9_;
				SoundDevice* _tmp10_;
				GtkSwitch* _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				SoundDevice* _tmp14_;
				gboolean _tmp15_;
				gboolean _tmp16_;
				GtkScale* _tmp18_;
				SoundDevice* _tmp19_;
				gdouble _tmp20_;
				gdouble _tmp21_;
				SoundDevice* _tmp22_;
#line 134 "../src/InputPanel.vala"
				_tmp9_ = self->priv->device_monitor;
#line 134 "../src/InputPanel.vala"
				_tmp10_ = self->priv->default_device;
#line 134 "../src/InputPanel.vala"
				sound_input_device_monitor_set_device (_tmp9_, _tmp10_);
#line 135 "../src/InputPanel.vala"
				_tmp11_ = self->priv->volume_switch;
#line 135 "../src/InputPanel.vala"
				_tmp12_ = gtk_switch_get_active (_tmp11_);
#line 135 "../src/InputPanel.vala"
				_tmp13_ = _tmp12_;
#line 135 "../src/InputPanel.vala"
				_tmp14_ = self->priv->default_device;
#line 135 "../src/InputPanel.vala"
				_tmp15_ = sound_device_get_is_muted (_tmp14_);
#line 135 "../src/InputPanel.vala"
				_tmp16_ = _tmp15_;
#line 135 "../src/InputPanel.vala"
				if (_tmp13_ == _tmp16_) {
#line 358 "InputPanel.c"
					GtkSwitch* _tmp17_;
#line 136 "../src/InputPanel.vala"
					_tmp17_ = self->priv->volume_switch;
#line 136 "../src/InputPanel.vala"
					g_signal_emit_by_name (_tmp17_, "activate");
#line 364 "InputPanel.c"
				}
#line 138 "../src/InputPanel.vala"
				_tmp18_ = self->priv->volume_scale;
#line 138 "../src/InputPanel.vala"
				_tmp19_ = self->priv->default_device;
#line 138 "../src/InputPanel.vala"
				_tmp20_ = sound_device_get_volume (_tmp19_);
#line 138 "../src/InputPanel.vala"
				_tmp21_ = _tmp20_;
#line 138 "../src/InputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp18_, _tmp21_);
#line 139 "../src/InputPanel.vala"
				_tmp22_ = self->priv->default_device;
#line 139 "../src/InputPanel.vala"
				g_signal_connect_object ((GObject*) _tmp22_, "notify", (GCallback) _sound_input_panel_device_notify_g_object_notify, self, 0);
#line 380 "InputPanel.c"
			}
		}
		__finally0:
		{
			SoundDevice* _tmp23_;
#line 127 "../src/InputPanel.vala"
			_tmp23_ = self->priv->default_device;
#line 127 "../src/InputPanel.vala"
			g_rec_mutex_unlock (&self->priv->__lock_default_device);
#line 390 "InputPanel.c"
		}
#line 127 "../src/InputPanel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 127 "../src/InputPanel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 127 "../src/InputPanel.vala"
			g_clear_error (&_inner_error0_);
#line 127 "../src/InputPanel.vala"
			return;
#line 400 "InputPanel.c"
		}
	}
#line 143 "../src/InputPanel.vala"
	sound_input_panel_connect_signals (self);
#line 405 "InputPanel.c"
}

static void
sound_input_panel_device_notify (SoundInputPanel* self,
                                 GParamSpec* pspec)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 148 "../src/InputPanel.vala"
	static GQuark _tmp2_label0 = 0;
#line 148 "../src/InputPanel.vala"
	static GQuark _tmp2_label1 = 0;
#line 146 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 146 "../src/InputPanel.vala"
	g_return_if_fail (pspec != NULL);
#line 147 "../src/InputPanel.vala"
	sound_input_panel_disconnect_signals (self);
#line 148 "../src/InputPanel.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 148 "../src/InputPanel.vala"
	_tmp1_ = _tmp0_;
#line 148 "../src/InputPanel.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 148 "../src/InputPanel.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("is-muted")))) {
#line 148 "../src/InputPanel.vala"
		switch (0) {
#line 435 "InputPanel.c"
			default:
			{
				GtkSwitch* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
				SoundDevice* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
				GtkScale* _tmp11_;
				SoundDevice* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 150 "../src/InputPanel.vala"
				_tmp4_ = self->priv->volume_switch;
#line 150 "../src/InputPanel.vala"
				_tmp5_ = gtk_switch_get_active (_tmp4_);
#line 150 "../src/InputPanel.vala"
				_tmp6_ = _tmp5_;
#line 150 "../src/InputPanel.vala"
				_tmp7_ = self->priv->default_device;
#line 150 "../src/InputPanel.vala"
				_tmp8_ = sound_device_get_is_muted (_tmp7_);
#line 150 "../src/InputPanel.vala"
				_tmp9_ = _tmp8_;
#line 150 "../src/InputPanel.vala"
				if (_tmp6_ == _tmp9_) {
#line 462 "InputPanel.c"
					GtkSwitch* _tmp10_;
#line 151 "../src/InputPanel.vala"
					_tmp10_ = self->priv->volume_switch;
#line 151 "../src/InputPanel.vala"
					g_signal_emit_by_name (_tmp10_, "activate");
#line 468 "InputPanel.c"
				}
#line 154 "../src/InputPanel.vala"
				_tmp11_ = self->priv->volume_scale;
#line 154 "../src/InputPanel.vala"
				_tmp12_ = self->priv->default_device;
#line 154 "../src/InputPanel.vala"
				_tmp13_ = sound_device_get_is_muted (_tmp12_);
#line 154 "../src/InputPanel.vala"
				_tmp14_ = _tmp13_;
#line 154 "../src/InputPanel.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, !_tmp14_);
#line 155 "../src/InputPanel.vala"
				break;
#line 482 "InputPanel.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("volume")))) {
#line 148 "../src/InputPanel.vala"
		switch (0) {
#line 488 "InputPanel.c"
			default:
			{
				GtkScale* _tmp15_;
				SoundDevice* _tmp16_;
				gdouble _tmp17_;
				gdouble _tmp18_;
#line 157 "../src/InputPanel.vala"
				_tmp15_ = self->priv->volume_scale;
#line 157 "../src/InputPanel.vala"
				_tmp16_ = self->priv->default_device;
#line 157 "../src/InputPanel.vala"
				_tmp17_ = sound_device_get_volume (_tmp16_);
#line 157 "../src/InputPanel.vala"
				_tmp18_ = _tmp17_;
#line 157 "../src/InputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp15_, _tmp18_);
#line 158 "../src/InputPanel.vala"
				break;
#line 507 "InputPanel.c"
			}
		}
	}
#line 161 "../src/InputPanel.vala"
	sound_input_panel_connect_signals (self);
#line 513 "InputPanel.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 164 "../src/InputPanel.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 164 "../src/InputPanel.vala"
	return _data12_;
#line 523 "InputPanel.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 164 "../src/InputPanel.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 533 "InputPanel.c"
		SoundInputPanel* self;
#line 164 "../src/InputPanel.vala"
		self = _data12_->self;
#line 164 "../src/InputPanel.vala"
		_g_object_unref0 (_data12_->device);
#line 164 "../src/InputPanel.vala"
		_g_object_unref0 (self);
#line 164 "../src/InputPanel.vala"
		g_slice_free (Block12Data, _data12_);
#line 543 "InputPanel.c"
	}
}

static void
__lambda21_ (Block12Data* _data12_)
{
	SoundInputPanel* self;
	SoundPulseAudioManager* _tmp0_;
#line 177 "../src/InputPanel.vala"
	self = _data12_->self;
#line 178 "../src/InputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 178 "../src/InputPanel.vala"
	sound_pulse_audio_manager_set_default_device (_tmp0_, _data12_->device, NULL, NULL);
#line 558 "InputPanel.c"
}

static void
___lambda21__sound_device_row_set_as_default (SoundDeviceRow* _sender,
                                              gpointer self)
{
#line 177 "../src/InputPanel.vala"
	__lambda21_ (self);
#line 567 "InputPanel.c"
}

static void
sound_input_panel_add_device (SoundInputPanel* self,
                              SoundDevice* device)
{
	Block12Data* _data12_;
	SoundDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundDeviceRow* device_row = NULL;
	SoundDeviceRow* _tmp3_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkListBoxRow* _tmp7_;
	SoundDeviceRow* _tmp10_;
	GtkListBox* _tmp11_;
	SoundDeviceRow* _tmp12_;
	SoundDeviceRow* _tmp13_;
#line 164 "../src/InputPanel.vala"
	g_return_if_fail (self != NULL);
#line 164 "../src/InputPanel.vala"
	g_return_if_fail (device != NULL);
#line 164 "../src/InputPanel.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 164 "../src/InputPanel.vala"
	_data12_->_ref_count_ = 1;
#line 164 "../src/InputPanel.vala"
	_data12_->self = g_object_ref (self);
#line 164 "../src/InputPanel.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 164 "../src/InputPanel.vala"
	_g_object_unref0 (_data12_->device);
#line 164 "../src/InputPanel.vala"
	_data12_->device = _tmp0_;
#line 165 "../src/InputPanel.vala"
	_tmp1_ = sound_device_get_input (_data12_->device);
#line 165 "../src/InputPanel.vala"
	_tmp2_ = _tmp1_;
#line 165 "../src/InputPanel.vala"
	if (!_tmp2_) {
#line 166 "../src/InputPanel.vala"
		block12_data_unref (_data12_);
#line 166 "../src/InputPanel.vala"
		_data12_ = NULL;
#line 166 "../src/InputPanel.vala"
		return;
#line 617 "InputPanel.c"
	}
#line 169 "../src/InputPanel.vala"
	_tmp3_ = sound_device_row_new (_data12_->device);
#line 169 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp3_);
#line 169 "../src/InputPanel.vala"
	device_row = _tmp3_;
#line 170 "../src/InputPanel.vala"
	_tmp4_ = self->priv->devices_listbox;
#line 170 "../src/InputPanel.vala"
	_tmp5_ = gtk_list_box_get_row_at_index (_tmp4_, 0);
#line 170 "../src/InputPanel.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 170 "../src/InputPanel.vala"
	row = _tmp6_;
#line 171 "../src/InputPanel.vala"
	_tmp7_ = row;
#line 171 "../src/InputPanel.vala"
	if (_tmp7_ != NULL) {
#line 637 "InputPanel.c"
		SoundDeviceRow* _tmp8_;
		GtkListBoxRow* _tmp9_;
#line 172 "../src/InputPanel.vala"
		_tmp8_ = device_row;
#line 172 "../src/InputPanel.vala"
		_tmp9_ = row;
#line 172 "../src/InputPanel.vala"
		sound_device_row_link_to_row (_tmp8_, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow));
#line 646 "InputPanel.c"
	}
#line 175 "../src/InputPanel.vala"
	_tmp10_ = device_row;
#line 175 "../src/InputPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 176 "../src/InputPanel.vala"
	_tmp11_ = self->priv->devices_listbox;
#line 176 "../src/InputPanel.vala"
	_tmp12_ = device_row;
#line 176 "../src/InputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 177 "../src/InputPanel.vala"
	_tmp13_ = device_row;
#line 177 "../src/InputPanel.vala"
	g_signal_connect_data (_tmp13_, "set-as-default", (GCallback) ___lambda21__sound_device_row_set_as_default, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 164 "../src/InputPanel.vala"
	_g_object_unref0 (row);
#line 164 "../src/InputPanel.vala"
	_g_object_unref0 (device_row);
#line 164 "../src/InputPanel.vala"
	block12_data_unref (_data12_);
#line 164 "../src/InputPanel.vala"
	_data12_ = NULL;
#line 670 "InputPanel.c"
}

SoundInputPanel*
sound_input_panel_construct (GType object_type)
{
	SoundInputPanel * self = NULL;
#line 8 "../src/InputPanel.vala"
	self = (SoundInputPanel*) g_object_new (object_type, NULL);
#line 8 "../src/InputPanel.vala"
	return self;
#line 681 "InputPanel.c"
}

SoundInputPanel*
sound_input_panel_new (void)
{
#line 8 "../src/InputPanel.vala"
	return sound_input_panel_construct (SOUND_TYPE_INPUT_PANEL);
#line 689 "InputPanel.c"
}

static void
_sound_input_panel___lambda22_ (SoundInputPanel* self,
                                GtkListBoxRow* row)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
#line 33 "../src/InputPanel.vala"
	g_return_if_fail (row != NULL);
#line 34 "../src/InputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 34 "../src/InputPanel.vala"
	_tmp1_ = sound_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (row, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow));
#line 34 "../src/InputPanel.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/InputPanel.vala"
	sound_pulse_audio_manager_set_default_device (_tmp0_, _tmp2_, NULL, NULL);
#line 709 "InputPanel.c"
}

static void
__sound_input_panel___lambda22__gtk_list_box_row_activated (GtkListBox* _sender,
                                                            GtkListBoxRow* row,
                                                            gpointer self)
{
#line 33 "../src/InputPanel.vala"
	_sound_input_panel___lambda22_ ((SoundInputPanel*) self, row);
#line 719 "InputPanel.c"
}

static void
_sound_input_panel___lambda23_ (SoundInputPanel* self,
                                gfloat fraction)
{
	GtkLevelBar* _tmp0_;
#line 83 "../src/InputPanel.vala"
	_tmp0_ = self->priv->level_bar;
#line 83 "../src/InputPanel.vala"
	gtk_level_bar_set_value (_tmp0_, (gdouble) fraction);
#line 731 "InputPanel.c"
}

static void
__sound_input_panel___lambda23__sound_input_device_monitor_update_fraction (SoundInputDeviceMonitor* _sender,
                                                                            gfloat fraction,
                                                                            gpointer self)
{
#line 82 "../src/InputPanel.vala"
	_sound_input_panel___lambda23_ ((SoundInputPanel*) self, fraction);
#line 741 "InputPanel.c"
}

static void
_sound_input_panel_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                    SoundDevice* dev,
                                                                    gpointer self)
{
#line 87 "../src/InputPanel.vala"
	sound_input_panel_add_device ((SoundInputPanel*) self, dev);
#line 751 "InputPanel.c"
}

static void
_sound_input_panel___lambda24_ (SoundInputPanel* self)
{
#line 89 "../src/InputPanel.vala"
	sound_input_panel_default_changed (self);
#line 759 "InputPanel.c"
}

static void
__sound_input_panel___lambda24__g_object_notify (GObject* _sender,
                                                 GParamSpec* pspec,
                                                 gpointer self)
{
#line 88 "../src/InputPanel.vala"
	_sound_input_panel___lambda24_ ((SoundInputPanel*) self);
#line 769 "InputPanel.c"
}

static GObject *
sound_input_panel_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundInputPanel * self;
	GraniteWidgetsAlertView* no_device_grid = NULL;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GtkListBox* _tmp5_;
	GtkScrolledWindow* scrolled = NULL;
	GtkListBox* _tmp6_;
	GtkWidget* _tmp7_;
	GtkScrolledWindow* _tmp8_ = NULL;
	GtkFrame* devices_frame = NULL;
	GtkScrolledWindow* _tmp9_;
	GtkWidget* _tmp10_;
	GtkFrame* _tmp11_ = NULL;
	GraniteHeaderLabel* volume_label = NULL;
	GraniteHeaderLabel* _tmp12_;
	GtkScale* _tmp13_ = NULL;
	GtkScale* _tmp14_;
	GtkScale* _tmp15_;
	GtkSwitch* _tmp16_ = NULL;
	GtkLevelBar* _tmp17_;
	GtkLevelBar* _tmp18_;
	GtkStyleContext* _tmp19_;
	GtkLevelBar* _tmp20_;
	GtkLevelBar* _tmp21_;
	GtkLevelBar* _tmp22_;
	GtkGrid* volume_grid = NULL;
	GtkGrid* _tmp23_ = NULL;
	GtkGrid* _tmp24_;
	GraniteHeaderLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLevelBar* _tmp27_;
	GtkGrid* _tmp28_;
	GtkScale* _tmp29_;
	GtkGrid* _tmp30_;
	GtkSwitch* _tmp31_;
	GtkFrame* _tmp32_;
	GtkGrid* _tmp33_;
	SoundInputDeviceMonitor* _tmp34_;
	SoundInputDeviceMonitor* _tmp35_;
	SoundPulseAudioManager* _tmp36_;
	SoundPulseAudioManager* _tmp37_;
	SoundPulseAudioManager* _tmp38_;
#line 17 "../src/InputPanel.vala"
	parent_class = G_OBJECT_CLASS (sound_input_panel_parent_class);
#line 17 "../src/InputPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 17 "../src/InputPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INPUT_PANEL, SoundInputPanel);
#line 18 "../src/InputPanel.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 12);
#line 20 "../src/InputPanel.vala"
	_tmp0_ = granite_widgets_alert_view_new (_ ("No Connected Audio Devices Detected"), _ ("Check that all cables are securely attached and audio input devices ar" \
"e powered on."), "audio-input-microphone-symbolic");
#line 20 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 20 "../src/InputPanel.vala"
	no_device_grid = _tmp0_;
#line 25 "../src/InputPanel.vala"
	_tmp1_ = no_device_grid;
#line 25 "../src/InputPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 27 "../src/InputPanel.vala"
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
#line 27 "../src/InputPanel.vala"
	gtk_list_box_set_activate_on_single_click (_tmp2_, TRUE);
#line 27 "../src/InputPanel.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
#line 27 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 27 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->devices_listbox);
#line 27 "../src/InputPanel.vala"
	self->priv->devices_listbox = _tmp2_;
#line 31 "../src/InputPanel.vala"
	_tmp3_ = self->priv->devices_listbox;
#line 31 "../src/InputPanel.vala"
	_tmp4_ = no_device_grid;
#line 31 "../src/InputPanel.vala"
	gtk_list_box_set_placeholder (_tmp3_, (GtkWidget*) _tmp4_);
#line 33 "../src/InputPanel.vala"
	_tmp5_ = self->priv->devices_listbox;
#line 33 "../src/InputPanel.vala"
	g_signal_connect_object (_tmp5_, "row-activated", (GCallback) __sound_input_panel___lambda22__gtk_list_box_row_activated, self, 0);
#line 37 "../src/InputPanel.vala"
	_tmp6_ = self->priv->devices_listbox;
#line 37 "../src/InputPanel.vala"
	_tmp7_ = _g_object_ref0 ((GtkWidget*) _tmp6_);
#line 37 "../src/InputPanel.vala"
	_tmp8_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 37 "../src/InputPanel.vala"
	g_object_set ((GtkContainer*) _tmp8_, "child", _tmp7_, NULL);
#line 37 "../src/InputPanel.vala"
	_g_object_unref0 (_tmp7_);
#line 37 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp8_);
#line 37 "../src/InputPanel.vala"
	scrolled = _tmp8_;
#line 41 "../src/InputPanel.vala"
	_tmp9_ = scrolled;
#line 41 "../src/InputPanel.vala"
	_tmp10_ = _g_object_ref0 ((GtkWidget*) _tmp9_);
#line 41 "../src/InputPanel.vala"
	_tmp11_ = (GtkFrame*) gtk_frame_new (NULL);
#line 41 "../src/InputPanel.vala"
	g_object_set ((GtkContainer*) _tmp11_, "child", _tmp10_, NULL);
#line 41 "../src/InputPanel.vala"
	_g_object_unref0 (_tmp10_);
#line 41 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp11_);
#line 41 "../src/InputPanel.vala"
	devices_frame = _tmp11_;
#line 45 "../src/InputPanel.vala"
	_tmp12_ = granite_header_label_new (_ ("Input Volume"));
#line 45 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp12_);
#line 45 "../src/InputPanel.vala"
	volume_label = _tmp12_;
#line 47 "../src/InputPanel.vala"
	_tmp13_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 5);
#line 47 "../src/InputPanel.vala"
	gtk_scale_set_draw_value (_tmp13_, FALSE);
#line 47 "../src/InputPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, TRUE);
#line 47 "../src/InputPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp13_, 3);
#line 47 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp13_);
#line 47 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 47 "../src/InputPanel.vala"
	self->priv->volume_scale = _tmp13_;
#line 53 "../src/InputPanel.vala"
	_tmp14_ = self->priv->volume_scale;
#line 53 "../src/InputPanel.vala"
	gtk_scale_add_mark (_tmp14_, (gdouble) 10, GTK_POS_BOTTOM, _ ("Unamplified"));
#line 54 "../src/InputPanel.vala"
	_tmp15_ = self->priv->volume_scale;
#line 54 "../src/InputPanel.vala"
	gtk_scale_add_mark (_tmp15_, (gdouble) 80, GTK_POS_BOTTOM, _ ("100%"));
#line 56 "../src/InputPanel.vala"
	_tmp16_ = (GtkSwitch*) gtk_switch_new ();
#line 56 "../src/InputPanel.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_START);
#line 56 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp16_);
#line 56 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->volume_switch);
#line 56 "../src/InputPanel.vala"
	self->priv->volume_switch = _tmp16_;
#line 60 "../src/InputPanel.vala"
	_tmp17_ = (GtkLevelBar*) gtk_level_bar_new_for_interval (0.0, 1.0);
#line 60 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp17_);
#line 60 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->level_bar);
#line 60 "../src/InputPanel.vala"
	self->priv->level_bar = _tmp17_;
#line 61 "../src/InputPanel.vala"
	_tmp18_ = self->priv->level_bar;
#line 61 "../src/InputPanel.vala"
	_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 61 "../src/InputPanel.vala"
	gtk_style_context_add_class (_tmp19_, "inverted");
#line 63 "../src/InputPanel.vala"
	_tmp20_ = self->priv->level_bar;
#line 63 "../src/InputPanel.vala"
	gtk_level_bar_add_offset_value (_tmp20_, "low", 0.8);
#line 64 "../src/InputPanel.vala"
	_tmp21_ = self->priv->level_bar;
#line 64 "../src/InputPanel.vala"
	gtk_level_bar_add_offset_value (_tmp21_, "high", 0.95);
#line 65 "../src/InputPanel.vala"
	_tmp22_ = self->priv->level_bar;
#line 65 "../src/InputPanel.vala"
	gtk_level_bar_add_offset_value (_tmp22_, "full", 1.0);
#line 67 "../src/InputPanel.vala"
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
#line 67 "../src/InputPanel.vala"
	gtk_grid_set_column_spacing (_tmp23_, 12);
#line 67 "../src/InputPanel.vala"
	gtk_grid_set_row_spacing (_tmp23_, 3);
#line 67 "../src/InputPanel.vala"
	g_object_ref_sink (_tmp23_);
#line 67 "../src/InputPanel.vala"
	volume_grid = _tmp23_;
#line 71 "../src/InputPanel.vala"
	_tmp24_ = volume_grid;
#line 71 "../src/InputPanel.vala"
	_tmp25_ = volume_label;
#line 71 "../src/InputPanel.vala"
	gtk_grid_attach (_tmp24_, (GtkWidget*) _tmp25_, 0, 0, 1, 1);
#line 72 "../src/InputPanel.vala"
	_tmp26_ = volume_grid;
#line 72 "../src/InputPanel.vala"
	_tmp27_ = self->priv->level_bar;
#line 72 "../src/InputPanel.vala"
	gtk_grid_attach (_tmp26_, (GtkWidget*) _tmp27_, 0, 1, 1, 1);
#line 73 "../src/InputPanel.vala"
	_tmp28_ = volume_grid;
#line 73 "../src/InputPanel.vala"
	_tmp29_ = self->priv->volume_scale;
#line 73 "../src/InputPanel.vala"
	gtk_grid_attach (_tmp28_, (GtkWidget*) _tmp29_, 0, 2, 1, 1);
#line 74 "../src/InputPanel.vala"
	_tmp30_ = volume_grid;
#line 74 "../src/InputPanel.vala"
	_tmp31_ = self->priv->volume_switch;
#line 74 "../src/InputPanel.vala"
	gtk_grid_attach (_tmp30_, (GtkWidget*) _tmp31_, 1, 1, 1, 2);
#line 76 "../src/InputPanel.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 77 "../src/InputPanel.vala"
	gtk_box_set_spacing ((GtkBox*) self, 18);
#line 78 "../src/InputPanel.vala"
	_tmp32_ = devices_frame;
#line 78 "../src/InputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 79 "../src/InputPanel.vala"
	_tmp33_ = volume_grid;
#line 79 "../src/InputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp33_);
#line 81 "../src/InputPanel.vala"
	_tmp34_ = sound_input_device_monitor_new ();
#line 81 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->device_monitor);
#line 81 "../src/InputPanel.vala"
	self->priv->device_monitor = _tmp34_;
#line 82 "../src/InputPanel.vala"
	_tmp35_ = self->priv->device_monitor;
#line 82 "../src/InputPanel.vala"
	g_signal_connect_object (_tmp35_, "update-fraction", (GCallback) __sound_input_panel___lambda23__sound_input_device_monitor_update_fraction, self, 0);
#line 86 "../src/InputPanel.vala"
	_tmp36_ = sound_pulse_audio_manager_get_default ();
#line 86 "../src/InputPanel.vala"
	self->priv->pam = _tmp36_;
#line 87 "../src/InputPanel.vala"
	_tmp37_ = self->priv->pam;
#line 87 "../src/InputPanel.vala"
	g_signal_connect_object (_tmp37_, "new-device", (GCallback) _sound_input_panel_add_device_sound_pulse_audio_manager_new_device, self, 0);
#line 88 "../src/InputPanel.vala"
	_tmp38_ = self->priv->pam;
#line 88 "../src/InputPanel.vala"
	g_signal_connect_object ((GObject*) _tmp38_, "notify::default-input", (GCallback) __sound_input_panel___lambda24__g_object_notify, self, 0);
#line 92 "../src/InputPanel.vala"
	sound_input_panel_connect_signals (self);
#line 17 "../src/InputPanel.vala"
	_g_object_unref0 (volume_grid);
#line 17 "../src/InputPanel.vala"
	_g_object_unref0 (volume_label);
#line 17 "../src/InputPanel.vala"
	_g_object_unref0 (devices_frame);
#line 17 "../src/InputPanel.vala"
	_g_object_unref0 (scrolled);
#line 17 "../src/InputPanel.vala"
	_g_object_unref0 (no_device_grid);
#line 17 "../src/InputPanel.vala"
	return obj;
#line 1038 "InputPanel.c"
}

static void
sound_input_panel_class_init (SoundInputPanelClass * klass,
                              gpointer klass_data)
{
#line 8 "../src/InputPanel.vala"
	sound_input_panel_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/InputPanel.vala"
	g_type_class_adjust_private_offset (klass, &SoundInputPanel_private_offset);
#line 8 "../src/InputPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_input_panel_constructor;
#line 8 "../src/InputPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_input_panel_finalize;
#line 1053 "InputPanel.c"
}

static void
sound_input_panel_instance_init (SoundInputPanel * self,
                                 gpointer klass)
{
#line 8 "../src/InputPanel.vala"
	self->priv = sound_input_panel_get_instance_private (self);
#line 9 "../src/InputPanel.vala"
	g_rec_mutex_init (&self->priv->__lock_default_device);
#line 9 "../src/InputPanel.vala"
	self->priv->default_device = NULL;
#line 1066 "InputPanel.c"
}

static void
sound_input_panel_finalize (GObject * obj)
{
	SoundInputPanel * self;
#line 8 "../src/InputPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_INPUT_PANEL, SoundInputPanel);
#line 9 "../src/InputPanel.vala"
	g_rec_mutex_clear (&self->priv->__lock_default_device);
#line 9 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->default_device);
#line 10 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->level_bar);
#line 11 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->devices_listbox);
#line 12 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 13 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->volume_switch);
#line 14 "../src/InputPanel.vala"
	_g_object_unref0 (self->priv->device_monitor);
#line 8 "../src/InputPanel.vala"
	G_OBJECT_CLASS (sound_input_panel_parent_class)->finalize (obj);
#line 1091 "InputPanel.c"
}

static GType
sound_input_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundInputPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_input_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundInputPanel), 0, (GInstanceInitFunc) sound_input_panel_instance_init, NULL };
	GType sound_input_panel_type_id;
	sound_input_panel_type_id = g_type_register_static (gtk_box_get_type (), "SoundInputPanel", &g_define_type_info, 0);
	SoundInputPanel_private_offset = g_type_add_instance_private (sound_input_panel_type_id, sizeof (SoundInputPanelPrivate));
	return sound_input_panel_type_id;
}

GType
sound_input_panel_get_type (void)
{
	static volatile gsize sound_input_panel_type_id__once = 0;
	if (g_once_init_enter (&sound_input_panel_type_id__once)) {
		GType sound_input_panel_type_id;
		sound_input_panel_type_id = sound_input_panel_get_type_once ();
		g_once_init_leave (&sound_input_panel_type_id__once, sound_input_panel_type_id);
	}
	return sound_input_panel_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

