/* OutputPanel.c generated by valac 0.56.17, the Vala compiler
 * generated from OutputPanel.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.0-or-later
 * SPDX-FileCopyrightText: 2016-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "sound.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <canberra.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include <canberra-gtk.h>
#include <locale.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_OUTPUT_PANEL_0_PROPERTY,
	SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY,
	SOUND_OUTPUT_PANEL_NUM_PROPERTIES
};
static GParamSpec* sound_output_panel_properties[SOUND_OUTPUT_PANEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block10Data Block10Data;
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))
typedef struct _Block11Data Block11Data;

struct _SoundOutputPanelPrivate {
	gboolean _screen_reader_active;
	SoundDevice* default_device;
	GRecMutex __lock_default_device;
	GtkListBox* devices_listbox;
	GtkScale* balance_scale;
	GtkScale* volume_scale;
	GtkSwitch* volume_switch;
	guint notify_timeout_id;
	ca_context* ca_context;
	SoundPulseAudioManager* pam;
	GSettings* media_keys_settings;
	gchar* _screenreader_shortcut_label;
};

struct _Block10Data {
	int _ref_count_;
	SoundOutputPanel* self;
	SoundDevice* device;
};

struct _Block11Data {
	int _ref_count_;
	SoundOutputPanel* self;
	GtkSwitch* screen_reader_switch;
	GtkLabel* screen_reader_description_label;
};

static gint SoundOutputPanel_private_offset;
static gpointer sound_output_panel_parent_class = NULL;

static void sound_output_panel_default_changed (SoundOutputPanel* self);
static void sound_output_panel_disconnect_signals (SoundOutputPanel* self);
static void sound_output_panel_device_notify (SoundOutputPanel* self,
                                       GParamSpec* pspec);
static void _sound_output_panel_device_notify_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static void sound_output_panel_connect_signals (SoundOutputPanel* self);
static void sound_output_panel_volume_switch_changed (SoundOutputPanel* self);
static void _sound_output_panel_volume_switch_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void sound_output_panel_volume_scale_value_changed (SoundOutputPanel* self);
static void _sound_output_panel_volume_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                             gpointer self);
static void sound_output_panel_balance_scale_value_changed (SoundOutputPanel* self);
static void _sound_output_panel_balance_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                              gpointer self);
static void sound_output_panel_add_device (SoundOutputPanel* self,
                                    SoundDevice* device);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void __lambda25_ (Block10Data* _data10_);
static void ___lambda25__sound_device_row_set_as_default (SoundDeviceRow* _sender,
                                                   gpointer self);
static void sound_output_panel_notify_change (SoundOutputPanel* self);
static gboolean __lambda26_ (SoundOutputPanel* self);
static gboolean ___lambda26__gsource_func (gpointer self);
static const gchar* sound_output_panel_get_screenreader_shortcut_label (SoundOutputPanel* self);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static GObject * sound_output_panel_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static gboolean _sound_output_panel___lambda27_ (Block11Data* _data11_);
static gboolean __sound_output_panel___lambda27__gbinding_transform_func (GBinding* binding,
                                                                   GValue* from_value,
                                                                   GValue* to_value,
                                                                   gpointer self);
static void _sound_output_panel_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                          SoundDevice* dev,
                                                                          gpointer self);
static void _sound_output_panel_default_changed_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _sound_output_panel___lambda28_ (SoundOutputPanel* self,
                                      GtkListBoxRow* row);
static void __sound_output_panel___lambda28__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                  GtkListBoxRow* row,
                                                                  gpointer self);
static void _sound_output_panel___lambda29_ (Block11Data* _data11_);
static void __sound_output_panel___lambda29__g_settings_changed (GSettings* _sender,
                                                          const gchar* key,
                                                          gpointer self);
static gboolean _sound_output_panel___lambda30_ (SoundOutputPanel* self,
                                          GdkEventButton* e);
static gboolean __sound_output_panel___lambda30__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                           GdkEventButton* event,
                                                                           gpointer self);
static gboolean _sound_output_panel___lambda31_ (SoundOutputPanel* self,
                                          GdkEventScroll* e);
static gboolean __sound_output_panel___lambda31__gtk_widget_scroll_event (GtkWidget* _sender,
                                                                   GdkEventScroll* event,
                                                                   gpointer self);
static void sound_output_panel_finalize (GObject * obj);
static GType sound_output_panel_get_type_once (void);
static void _vala_sound_output_panel_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_sound_output_panel_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_output_panel_get_instance_private (SoundOutputPanel* self)
{
	return G_STRUCT_MEMBER_P (self, SoundOutputPanel_private_offset);
}

static void
_sound_output_panel_device_notify_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 205 "../src/OutputPanel.vala"
	sound_output_panel_device_notify ((SoundOutputPanel*) self, pspec);
#line 181 "OutputPanel.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 208 "../src/OutputPanel.vala"
	return self ? g_object_ref (self) : NULL;
#line 189 "OutputPanel.c"
}

static void
sound_output_panel_default_changed (SoundOutputPanel* self)
{
	GError* _inner_error0_ = NULL;
#line 201 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 202 "../src/OutputPanel.vala"
	sound_output_panel_disconnect_signals (self);
#line 200 "OutputPanel.c"
	{
		SoundDevice* _tmp0_;
#line 203 "../src/OutputPanel.vala"
		_tmp0_ = self->priv->default_device;
#line 203 "../src/OutputPanel.vala"
		g_rec_mutex_lock (&self->priv->__lock_default_device);
#line 207 "OutputPanel.c"
		{
			SoundDevice* _tmp1_;
			SoundPulseAudioManager* _tmp4_;
			SoundDevice* _tmp5_;
			SoundDevice* _tmp6_;
			SoundDevice* _tmp7_;
			SoundDevice* _tmp8_;
#line 204 "../src/OutputPanel.vala"
			_tmp1_ = self->priv->default_device;
#line 204 "../src/OutputPanel.vala"
			if (_tmp1_ != NULL) {
#line 219 "OutputPanel.c"
				SoundDevice* _tmp2_;
				guint _tmp3_;
#line 205 "../src/OutputPanel.vala"
				_tmp2_ = self->priv->default_device;
#line 205 "../src/OutputPanel.vala"
				g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp3_, NULL, FALSE);
#line 205 "../src/OutputPanel.vala"
				g_signal_handlers_disconnect_matched ((GObject*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _sound_output_panel_device_notify_g_object_notify, self);
#line 228 "OutputPanel.c"
			}
#line 208 "../src/OutputPanel.vala"
			_tmp4_ = self->priv->pam;
#line 208 "../src/OutputPanel.vala"
			_tmp5_ = sound_pulse_audio_manager_get_default_output (_tmp4_);
#line 208 "../src/OutputPanel.vala"
			_tmp6_ = _tmp5_;
#line 208 "../src/OutputPanel.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 208 "../src/OutputPanel.vala"
			_g_object_unref0 (self->priv->default_device);
#line 208 "../src/OutputPanel.vala"
			self->priv->default_device = _tmp7_;
#line 209 "../src/OutputPanel.vala"
			_tmp8_ = self->priv->default_device;
#line 209 "../src/OutputPanel.vala"
			if (_tmp8_ != NULL) {
#line 246 "OutputPanel.c"
				GtkSwitch* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
				SoundDevice* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				GtkScale* _tmp16_;
				SoundDevice* _tmp17_;
				gdouble _tmp18_;
				gdouble _tmp19_;
				GtkScale* _tmp20_;
				SoundDevice* _tmp21_;
				gfloat _tmp22_;
				gfloat _tmp23_;
				SoundDevice* _tmp24_;
#line 210 "../src/OutputPanel.vala"
				_tmp9_ = self->priv->volume_switch;
#line 210 "../src/OutputPanel.vala"
				_tmp10_ = gtk_switch_get_active (_tmp9_);
#line 210 "../src/OutputPanel.vala"
				_tmp11_ = _tmp10_;
#line 210 "../src/OutputPanel.vala"
				_tmp12_ = self->priv->default_device;
#line 210 "../src/OutputPanel.vala"
				_tmp13_ = sound_device_get_is_muted (_tmp12_);
#line 210 "../src/OutputPanel.vala"
				_tmp14_ = _tmp13_;
#line 210 "../src/OutputPanel.vala"
				if (_tmp11_ == _tmp14_) {
#line 276 "OutputPanel.c"
					GtkSwitch* _tmp15_;
#line 211 "../src/OutputPanel.vala"
					_tmp15_ = self->priv->volume_switch;
#line 211 "../src/OutputPanel.vala"
					g_signal_emit_by_name (_tmp15_, "activate");
#line 282 "OutputPanel.c"
				}
#line 213 "../src/OutputPanel.vala"
				_tmp16_ = self->priv->volume_scale;
#line 213 "../src/OutputPanel.vala"
				_tmp17_ = self->priv->default_device;
#line 213 "../src/OutputPanel.vala"
				_tmp18_ = sound_device_get_volume (_tmp17_);
#line 213 "../src/OutputPanel.vala"
				_tmp19_ = _tmp18_;
#line 213 "../src/OutputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp16_, _tmp19_);
#line 214 "../src/OutputPanel.vala"
				_tmp20_ = self->priv->balance_scale;
#line 214 "../src/OutputPanel.vala"
				_tmp21_ = self->priv->default_device;
#line 214 "../src/OutputPanel.vala"
				_tmp22_ = sound_device_get_balance (_tmp21_);
#line 214 "../src/OutputPanel.vala"
				_tmp23_ = _tmp22_;
#line 214 "../src/OutputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp20_, (gdouble) _tmp23_);
#line 215 "../src/OutputPanel.vala"
				_tmp24_ = self->priv->default_device;
#line 215 "../src/OutputPanel.vala"
				g_signal_connect_object ((GObject*) _tmp24_, "notify", (GCallback) _sound_output_panel_device_notify_g_object_notify, self, 0);
#line 308 "OutputPanel.c"
			}
		}
		__finally0:
		{
			SoundDevice* _tmp25_;
#line 203 "../src/OutputPanel.vala"
			_tmp25_ = self->priv->default_device;
#line 203 "../src/OutputPanel.vala"
			g_rec_mutex_unlock (&self->priv->__lock_default_device);
#line 318 "OutputPanel.c"
		}
#line 203 "../src/OutputPanel.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../src/OutputPanel.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../src/OutputPanel.vala"
			g_clear_error (&_inner_error0_);
#line 203 "../src/OutputPanel.vala"
			return;
#line 328 "OutputPanel.c"
		}
	}
#line 219 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 333 "OutputPanel.c"
}

static void
_sound_output_panel_volume_switch_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 223 "../src/OutputPanel.vala"
	sound_output_panel_volume_switch_changed ((SoundOutputPanel*) self);
#line 343 "OutputPanel.c"
}

static void
_sound_output_panel_volume_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                        gpointer self)
{
#line 224 "../src/OutputPanel.vala"
	sound_output_panel_volume_scale_value_changed ((SoundOutputPanel*) self);
#line 352 "OutputPanel.c"
}

static void
_sound_output_panel_balance_scale_value_changed_gtk_range_value_changed (GtkRange* _sender,
                                                                         gpointer self)
{
#line 225 "../src/OutputPanel.vala"
	sound_output_panel_balance_scale_value_changed ((SoundOutputPanel*) self);
#line 361 "OutputPanel.c"
}

static void
sound_output_panel_disconnect_signals (SoundOutputPanel* self)
{
	GtkSwitch* _tmp0_;
	guint _tmp1_;
	GQuark _tmp2_;
	GtkScale* _tmp3_;
	guint _tmp4_;
	GtkScale* _tmp5_;
	guint _tmp6_;
#line 222 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->volume_switch;
#line 223 "../src/OutputPanel.vala"
	g_signal_parse_name ("notify::active", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
#line 223 "../src/OutputPanel.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _sound_output_panel_volume_switch_changed_g_object_notify, self);
#line 224 "../src/OutputPanel.vala"
	_tmp3_ = self->priv->volume_scale;
#line 224 "../src/OutputPanel.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp4_, NULL, FALSE);
#line 224 "../src/OutputPanel.vala"
	g_signal_handlers_disconnect_matched ((GtkRange*) _tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _sound_output_panel_volume_scale_value_changed_gtk_range_value_changed, self);
#line 225 "../src/OutputPanel.vala"
	_tmp5_ = self->priv->balance_scale;
#line 225 "../src/OutputPanel.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp6_, NULL, FALSE);
#line 225 "../src/OutputPanel.vala"
	g_signal_handlers_disconnect_matched ((GtkRange*) _tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _sound_output_panel_balance_scale_value_changed_gtk_range_value_changed, self);
#line 394 "OutputPanel.c"
}

static void
sound_output_panel_connect_signals (SoundOutputPanel* self)
{
	GtkSwitch* _tmp0_;
	GtkScale* _tmp1_;
	GtkScale* _tmp2_;
#line 228 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->volume_switch;
#line 229 "../src/OutputPanel.vala"
	g_signal_connect_object ((GObject*) _tmp0_, "notify::active", (GCallback) _sound_output_panel_volume_switch_changed_g_object_notify, self, 0);
#line 230 "../src/OutputPanel.vala"
	_tmp1_ = self->priv->volume_scale;
#line 230 "../src/OutputPanel.vala"
	g_signal_connect_object ((GtkRange*) _tmp1_, "value-changed", (GCallback) _sound_output_panel_volume_scale_value_changed_gtk_range_value_changed, self, 0);
#line 231 "../src/OutputPanel.vala"
	_tmp2_ = self->priv->balance_scale;
#line 231 "../src/OutputPanel.vala"
	g_signal_connect_object ((GtkRange*) _tmp2_, "value-changed", (GCallback) _sound_output_panel_balance_scale_value_changed_gtk_range_value_changed, self, 0);
#line 417 "OutputPanel.c"
}

static void
sound_output_panel_volume_scale_value_changed (SoundOutputPanel* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	GtkScale* _tmp2_;
#line 234 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/OutputPanel.vala"
	sound_output_panel_disconnect_signals (self);
#line 236 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 236 "../src/OutputPanel.vala"
	_tmp1_ = self->priv->default_device;
#line 236 "../src/OutputPanel.vala"
	_tmp2_ = self->priv->volume_scale;
#line 236 "../src/OutputPanel.vala"
	sound_pulse_audio_manager_change_device_volume (_tmp0_, _tmp1_, (gdouble) ((gfloat) gtk_range_get_value ((GtkRange*) _tmp2_)));
#line 237 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 440 "OutputPanel.c"
}

static void
sound_output_panel_balance_scale_value_changed (SoundOutputPanel* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	GtkScale* _tmp2_;
#line 240 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 241 "../src/OutputPanel.vala"
	sound_output_panel_disconnect_signals (self);
#line 242 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 242 "../src/OutputPanel.vala"
	_tmp1_ = self->priv->default_device;
#line 242 "../src/OutputPanel.vala"
	_tmp2_ = self->priv->balance_scale;
#line 242 "../src/OutputPanel.vala"
	sound_pulse_audio_manager_change_device_balance (_tmp0_, _tmp1_, (gfloat) gtk_range_get_value ((GtkRange*) _tmp2_));
#line 243 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 463 "OutputPanel.c"
}

static void
sound_output_panel_volume_switch_changed (SoundOutputPanel* self)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 246 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 247 "../src/OutputPanel.vala"
	sound_output_panel_disconnect_signals (self);
#line 248 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 248 "../src/OutputPanel.vala"
	_tmp1_ = self->priv->default_device;
#line 248 "../src/OutputPanel.vala"
	_tmp2_ = self->priv->volume_switch;
#line 248 "../src/OutputPanel.vala"
	_tmp3_ = gtk_switch_get_active (_tmp2_);
#line 248 "../src/OutputPanel.vala"
	_tmp4_ = _tmp3_;
#line 248 "../src/OutputPanel.vala"
	sound_pulse_audio_manager_change_device_mute (_tmp0_, _tmp1_, !_tmp4_);
#line 249 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 492 "OutputPanel.c"
}

static void
sound_output_panel_device_notify (SoundOutputPanel* self,
                                  GParamSpec* pspec)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 254 "../src/OutputPanel.vala"
	static GQuark _tmp2_label0 = 0;
#line 254 "../src/OutputPanel.vala"
	static GQuark _tmp2_label1 = 0;
#line 254 "../src/OutputPanel.vala"
	static GQuark _tmp2_label2 = 0;
#line 252 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/OutputPanel.vala"
	g_return_if_fail (pspec != NULL);
#line 253 "../src/OutputPanel.vala"
	sound_output_panel_disconnect_signals (self);
#line 254 "../src/OutputPanel.vala"
	_tmp0_ = g_param_spec_get_name (pspec);
#line 254 "../src/OutputPanel.vala"
	_tmp1_ = _tmp0_;
#line 254 "../src/OutputPanel.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 254 "../src/OutputPanel.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("is-muted")))) {
#line 254 "../src/OutputPanel.vala"
		switch (0) {
#line 524 "OutputPanel.c"
			default:
			{
				GtkSwitch* _tmp4_;
				gboolean _tmp5_;
				gboolean _tmp6_;
				SoundDevice* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
				GtkScale* _tmp11_;
				SoundDevice* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				GtkScale* _tmp15_;
				SoundDevice* _tmp16_;
				gboolean _tmp17_;
				gboolean _tmp18_;
#line 256 "../src/OutputPanel.vala"
				_tmp4_ = self->priv->volume_switch;
#line 256 "../src/OutputPanel.vala"
				_tmp5_ = gtk_switch_get_active (_tmp4_);
#line 256 "../src/OutputPanel.vala"
				_tmp6_ = _tmp5_;
#line 256 "../src/OutputPanel.vala"
				_tmp7_ = self->priv->default_device;
#line 256 "../src/OutputPanel.vala"
				_tmp8_ = sound_device_get_is_muted (_tmp7_);
#line 256 "../src/OutputPanel.vala"
				_tmp9_ = _tmp8_;
#line 256 "../src/OutputPanel.vala"
				if (_tmp6_ == _tmp9_) {
#line 555 "OutputPanel.c"
					GtkSwitch* _tmp10_;
#line 257 "../src/OutputPanel.vala"
					_tmp10_ = self->priv->volume_switch;
#line 257 "../src/OutputPanel.vala"
					g_signal_emit_by_name (_tmp10_, "activate");
#line 561 "OutputPanel.c"
				}
#line 260 "../src/OutputPanel.vala"
				_tmp11_ = self->priv->balance_scale;
#line 260 "../src/OutputPanel.vala"
				_tmp12_ = self->priv->default_device;
#line 260 "../src/OutputPanel.vala"
				_tmp13_ = sound_device_get_is_muted (_tmp12_);
#line 260 "../src/OutputPanel.vala"
				_tmp14_ = _tmp13_;
#line 260 "../src/OutputPanel.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, !_tmp14_);
#line 261 "../src/OutputPanel.vala"
				_tmp15_ = self->priv->volume_scale;
#line 261 "../src/OutputPanel.vala"
				_tmp16_ = self->priv->default_device;
#line 261 "../src/OutputPanel.vala"
				_tmp17_ = sound_device_get_is_muted (_tmp16_);
#line 261 "../src/OutputPanel.vala"
				_tmp18_ = _tmp17_;
#line 261 "../src/OutputPanel.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, !_tmp18_);
#line 262 "../src/OutputPanel.vala"
				break;
#line 585 "OutputPanel.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("volume")))) {
#line 254 "../src/OutputPanel.vala"
		switch (0) {
#line 591 "OutputPanel.c"
			default:
			{
				GtkScale* _tmp19_;
				SoundDevice* _tmp20_;
				gdouble _tmp21_;
				gdouble _tmp22_;
#line 264 "../src/OutputPanel.vala"
				_tmp19_ = self->priv->volume_scale;
#line 264 "../src/OutputPanel.vala"
				_tmp20_ = self->priv->default_device;
#line 264 "../src/OutputPanel.vala"
				_tmp21_ = sound_device_get_volume (_tmp20_);
#line 264 "../src/OutputPanel.vala"
				_tmp22_ = _tmp21_;
#line 264 "../src/OutputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp19_, _tmp22_);
#line 265 "../src/OutputPanel.vala"
				break;
#line 610 "OutputPanel.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("balance")))) {
#line 254 "../src/OutputPanel.vala"
		switch (0) {
#line 616 "OutputPanel.c"
			default:
			{
				GtkScale* _tmp23_;
				SoundDevice* _tmp24_;
				gfloat _tmp25_;
				gfloat _tmp26_;
#line 267 "../src/OutputPanel.vala"
				_tmp23_ = self->priv->balance_scale;
#line 267 "../src/OutputPanel.vala"
				_tmp24_ = self->priv->default_device;
#line 267 "../src/OutputPanel.vala"
				_tmp25_ = sound_device_get_balance (_tmp24_);
#line 267 "../src/OutputPanel.vala"
				_tmp26_ = _tmp25_;
#line 267 "../src/OutputPanel.vala"
				gtk_range_set_value ((GtkRange*) _tmp23_, (gdouble) _tmp26_);
#line 268 "../src/OutputPanel.vala"
				break;
#line 635 "OutputPanel.c"
			}
		}
	}
#line 271 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 641 "OutputPanel.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 274 "../src/OutputPanel.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 274 "../src/OutputPanel.vala"
	return _data10_;
#line 651 "OutputPanel.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 274 "../src/OutputPanel.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 661 "OutputPanel.c"
		SoundOutputPanel* self;
#line 274 "../src/OutputPanel.vala"
		self = _data10_->self;
#line 274 "../src/OutputPanel.vala"
		_g_object_unref0 (_data10_->device);
#line 274 "../src/OutputPanel.vala"
		_g_object_unref0 (self);
#line 274 "../src/OutputPanel.vala"
		g_slice_free (Block10Data, _data10_);
#line 671 "OutputPanel.c"
	}
}

static void
__lambda25_ (Block10Data* _data10_)
{
	SoundOutputPanel* self;
	SoundPulseAudioManager* _tmp0_;
#line 287 "../src/OutputPanel.vala"
	self = _data10_->self;
#line 288 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 288 "../src/OutputPanel.vala"
	sound_pulse_audio_manager_set_default_device (_tmp0_, _data10_->device, NULL, NULL);
#line 686 "OutputPanel.c"
}

static void
___lambda25__sound_device_row_set_as_default (SoundDeviceRow* _sender,
                                              gpointer self)
{
#line 287 "../src/OutputPanel.vala"
	__lambda25_ (self);
#line 695 "OutputPanel.c"
}

static void
sound_output_panel_add_device (SoundOutputPanel* self,
                               SoundDevice* device)
{
	Block10Data* _data10_;
	SoundDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SoundDeviceRow* device_row = NULL;
	SoundDeviceRow* _tmp3_;
	GtkListBoxRow* row = NULL;
	GtkListBox* _tmp4_;
	GtkListBoxRow* _tmp5_;
	GtkListBoxRow* _tmp6_;
	GtkListBoxRow* _tmp7_;
	SoundDeviceRow* _tmp10_;
	GtkListBox* _tmp11_;
	SoundDeviceRow* _tmp12_;
	SoundDeviceRow* _tmp13_;
#line 274 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/OutputPanel.vala"
	g_return_if_fail (device != NULL);
#line 274 "../src/OutputPanel.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 274 "../src/OutputPanel.vala"
	_data10_->_ref_count_ = 1;
#line 274 "../src/OutputPanel.vala"
	_data10_->self = g_object_ref (self);
#line 274 "../src/OutputPanel.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 274 "../src/OutputPanel.vala"
	_g_object_unref0 (_data10_->device);
#line 274 "../src/OutputPanel.vala"
	_data10_->device = _tmp0_;
#line 275 "../src/OutputPanel.vala"
	_tmp1_ = sound_device_get_input (_data10_->device);
#line 275 "../src/OutputPanel.vala"
	_tmp2_ = _tmp1_;
#line 275 "../src/OutputPanel.vala"
	if (_tmp2_) {
#line 276 "../src/OutputPanel.vala"
		block10_data_unref (_data10_);
#line 276 "../src/OutputPanel.vala"
		_data10_ = NULL;
#line 276 "../src/OutputPanel.vala"
		return;
#line 745 "OutputPanel.c"
	}
#line 279 "../src/OutputPanel.vala"
	_tmp3_ = sound_device_row_new (_data10_->device);
#line 279 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp3_);
#line 279 "../src/OutputPanel.vala"
	device_row = _tmp3_;
#line 280 "../src/OutputPanel.vala"
	_tmp4_ = self->priv->devices_listbox;
#line 280 "../src/OutputPanel.vala"
	_tmp5_ = gtk_list_box_get_row_at_index (_tmp4_, 0);
#line 280 "../src/OutputPanel.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 280 "../src/OutputPanel.vala"
	row = _tmp6_;
#line 281 "../src/OutputPanel.vala"
	_tmp7_ = row;
#line 281 "../src/OutputPanel.vala"
	if (_tmp7_ != NULL) {
#line 765 "OutputPanel.c"
		SoundDeviceRow* _tmp8_;
		GtkListBoxRow* _tmp9_;
#line 282 "../src/OutputPanel.vala"
		_tmp8_ = device_row;
#line 282 "../src/OutputPanel.vala"
		_tmp9_ = row;
#line 282 "../src/OutputPanel.vala"
		sound_device_row_link_to_row (_tmp8_, G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow));
#line 774 "OutputPanel.c"
	}
#line 285 "../src/OutputPanel.vala"
	_tmp10_ = device_row;
#line 285 "../src/OutputPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 286 "../src/OutputPanel.vala"
	_tmp11_ = self->priv->devices_listbox;
#line 286 "../src/OutputPanel.vala"
	_tmp12_ = device_row;
#line 286 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 287 "../src/OutputPanel.vala"
	_tmp13_ = device_row;
#line 287 "../src/OutputPanel.vala"
	g_signal_connect_data (_tmp13_, "set-as-default", (GCallback) ___lambda25__sound_device_row_set_as_default, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 274 "../src/OutputPanel.vala"
	_g_object_unref0 (row);
#line 274 "../src/OutputPanel.vala"
	_g_object_unref0 (device_row);
#line 274 "../src/OutputPanel.vala"
	block10_data_unref (_data10_);
#line 274 "../src/OutputPanel.vala"
	_data10_ = NULL;
#line 798 "OutputPanel.c"
}

static gboolean
__lambda26_ (SoundOutputPanel* self)
{
	ca_proplist* props = NULL;
	ca_proplist* _tmp0_ = NULL;
	ca_context* _tmp1_;
	gboolean result;
#line 299 "../src/OutputPanel.vala"
	ca_proplist_create (&_tmp0_);
#line 299 "../src/OutputPanel.vala"
	_ca_proplist_destroy0 (props);
#line 299 "../src/OutputPanel.vala"
	props = _tmp0_;
#line 300 "../src/OutputPanel.vala"
	ca_proplist_sets (props, CA_PROP_CANBERRA_CACHE_CONTROL, "volatile");
#line 301 "../src/OutputPanel.vala"
	ca_proplist_sets (props, CA_PROP_EVENT_ID, "audio-volume-change");
#line 302 "../src/OutputPanel.vala"
	_tmp1_ = self->priv->ca_context;
#line 302 "../src/OutputPanel.vala"
	ca_context_play_full (_tmp1_, (guint32) 0, props, NULL, NULL);
#line 304 "../src/OutputPanel.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 305 "../src/OutputPanel.vala"
	result = FALSE;
#line 305 "../src/OutputPanel.vala"
	_ca_proplist_destroy0 (props);
#line 305 "../src/OutputPanel.vala"
	return result;
#line 830 "OutputPanel.c"
}

static gboolean
___lambda26__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda26_ ((SoundOutputPanel*) self);
#line 297 "../src/OutputPanel.vala"
	return result;
#line 840 "OutputPanel.c"
}

static void
sound_output_panel_notify_change (SoundOutputPanel* self)
{
#line 292 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/OutputPanel.vala"
	if (self->priv->notify_timeout_id > ((guint) 0)) {
#line 294 "../src/OutputPanel.vala"
		return;
#line 852 "OutputPanel.c"
	}
#line 297 "../src/OutputPanel.vala"
	self->priv->notify_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda26__gsource_func, g_object_ref (self), g_object_unref);
#line 856 "OutputPanel.c"
}

SoundOutputPanel*
sound_output_panel_construct (GType object_type)
{
	SoundOutputPanel * self = NULL;
#line 8 "../src/OutputPanel.vala"
	self = (SoundOutputPanel*) g_object_new (object_type, NULL);
#line 8 "../src/OutputPanel.vala"
	return self;
#line 867 "OutputPanel.c"
}

SoundOutputPanel*
sound_output_panel_new (void)
{
#line 8 "../src/OutputPanel.vala"
	return sound_output_panel_construct (SOUND_TYPE_OUTPUT_PANEL);
#line 875 "OutputPanel.c"
}

gboolean
sound_output_panel_get_screen_reader_active (SoundOutputPanel* self)
{
	gboolean result;
#line 9 "../src/OutputPanel.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 9 "../src/OutputPanel.vala"
	result = self->priv->_screen_reader_active;
#line 9 "../src/OutputPanel.vala"
	return result;
#line 888 "OutputPanel.c"
}

void
sound_output_panel_set_screen_reader_active (SoundOutputPanel* self,
                                             gboolean value)
{
	gboolean old_value;
#line 9 "../src/OutputPanel.vala"
	g_return_if_fail (self != NULL);
#line 9 "../src/OutputPanel.vala"
	old_value = sound_output_panel_get_screen_reader_active (self);
#line 9 "../src/OutputPanel.vala"
	if (old_value != value) {
#line 9 "../src/OutputPanel.vala"
		self->priv->_screen_reader_active = value;
#line 9 "../src/OutputPanel.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_output_panel_properties[SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY]);
#line 906 "OutputPanel.c"
	}
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 26 "../src/OutputPanel.vala"
	if ((*length) == (*size)) {
#line 26 "../src/OutputPanel.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 26 "../src/OutputPanel.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 922 "OutputPanel.c"
	}
#line 26 "../src/OutputPanel.vala"
	(*array)[(*length)++] = value;
#line 26 "../src/OutputPanel.vala"
	(*array)[*length] = NULL;
#line 928 "OutputPanel.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 942 "OutputPanel.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 946 "OutputPanel.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 952 "OutputPanel.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 957 "OutputPanel.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 963 "OutputPanel.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 967 "OutputPanel.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 971 "OutputPanel.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 975 "OutputPanel.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 979 "OutputPanel.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 983 "OutputPanel.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 998 "OutputPanel.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 1007 "OutputPanel.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 1014 "OutputPanel.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 1020 "OutputPanel.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 1028 "OutputPanel.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 1032 "OutputPanel.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 1038 "OutputPanel.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 1043 "OutputPanel.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 1049 "OutputPanel.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 1053 "OutputPanel.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 1057 "OutputPanel.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 1063 "OutputPanel.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 1069 "OutputPanel.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 1081 "OutputPanel.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 1085 "OutputPanel.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 1089 "OutputPanel.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 1094 "OutputPanel.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 1102 "OutputPanel.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 1120 "OutputPanel.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1126 "OutputPanel.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1130 "OutputPanel.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1138 "OutputPanel.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1147 "OutputPanel.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1156 "OutputPanel.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1162 "OutputPanel.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1170 "OutputPanel.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1182 "OutputPanel.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1188 "OutputPanel.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1192 "OutputPanel.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1200 "OutputPanel.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1211 "OutputPanel.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1220 "OutputPanel.c"
	}
}

static const gchar*
sound_output_panel_get_screenreader_shortcut_label (SoundOutputPanel* self)
{
	const gchar* result;
	gchar** granite_accel_strings = NULL;
	gint granite_accel_strings_length1;
	gint _granite_accel_strings_size_;
	GSettings* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
#line 23 "../src/OutputPanel.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/OutputPanel.vala"
	granite_accel_strings = NULL;
#line 24 "../src/OutputPanel.vala"
	granite_accel_strings_length1 = 0;
#line 24 "../src/OutputPanel.vala"
	_granite_accel_strings_size_ = granite_accel_strings_length1;
#line 25 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->media_keys_settings;
#line 25 "../src/OutputPanel.vala"
	_tmp2_ = _tmp1_ = g_settings_get_strv (_tmp0_, "screenreader");
#line 1252 "OutputPanel.c"
	{
		gchar** key_collection = NULL;
		gint key_collection_length1 = 0;
		gint _key_collection_size_ = 0;
		gint key_it = 0;
#line 25 "../src/OutputPanel.vala"
		key_collection = _tmp2_;
#line 25 "../src/OutputPanel.vala"
		key_collection_length1 = _vala_array_length (_tmp1_);
#line 25 "../src/OutputPanel.vala"
		for (key_it = 0; key_it < key_collection_length1; key_it = key_it + 1) {
#line 1264 "OutputPanel.c"
			const gchar* key = NULL;
#line 25 "../src/OutputPanel.vala"
			key = key_collection[key_it];
#line 1268 "OutputPanel.c"
			{
				const gchar* _tmp3_;
				gchar* _tmp4_;
#line 26 "../src/OutputPanel.vala"
				_tmp3_ = key;
#line 26 "../src/OutputPanel.vala"
				_tmp4_ = granite_accel_to_string (_tmp3_);
#line 26 "../src/OutputPanel.vala"
				_vala_array_add2 (&granite_accel_strings, &granite_accel_strings_length1, &_granite_accel_strings_size_, _tmp4_);
#line 1278 "OutputPanel.c"
			}
		}
#line 25 "../src/OutputPanel.vala"
		key_collection = (_vala_array_free (key_collection, key_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1283 "OutputPanel.c"
	}
#line 29 "../src/OutputPanel.vala"
	_tmp5_ = granite_accel_strings;
#line 29 "../src/OutputPanel.vala"
	_tmp5__length1 = granite_accel_strings_length1;
#line 29 "../src/OutputPanel.vala"
	_tmp6_ = _vala_g_strjoinv (_ (", "), _tmp5_, (gint) _tmp5__length1);
#line 29 "../src/OutputPanel.vala"
	_tmp7_ = _tmp6_;
#line 29 "../src/OutputPanel.vala"
	_tmp8_ = g_strdup_printf (_ ("Provide audio descriptions for items on the screen. %s"), _tmp7_);
#line 29 "../src/OutputPanel.vala"
	_g_free0 (self->priv->_screenreader_shortcut_label);
#line 29 "../src/OutputPanel.vala"
	self->priv->_screenreader_shortcut_label = _tmp8_;
#line 29 "../src/OutputPanel.vala"
	_g_free0 (_tmp7_);
#line 33 "../src/OutputPanel.vala"
	_tmp9_ = self->priv->_screenreader_shortcut_label;
#line 33 "../src/OutputPanel.vala"
	result = _tmp9_;
#line 33 "../src/OutputPanel.vala"
	granite_accel_strings = (_vala_array_free (granite_accel_strings, granite_accel_strings_length1, (GDestroyNotify) g_free), NULL);
#line 33 "../src/OutputPanel.vala"
	return result;
#line 1309 "OutputPanel.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 37 "../src/OutputPanel.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 37 "../src/OutputPanel.vala"
	return _data11_;
#line 1319 "OutputPanel.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 37 "../src/OutputPanel.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 1329 "OutputPanel.c"
		SoundOutputPanel* self;
#line 37 "../src/OutputPanel.vala"
		self = _data11_->self;
#line 37 "../src/OutputPanel.vala"
		_g_object_unref0 (_data11_->screen_reader_description_label);
#line 37 "../src/OutputPanel.vala"
		_g_object_unref0 (_data11_->screen_reader_switch);
#line 37 "../src/OutputPanel.vala"
		_g_object_unref0 (self);
#line 37 "../src/OutputPanel.vala"
		g_slice_free (Block11Data, _data11_);
#line 1341 "OutputPanel.c"
	}
}

static gboolean
_sound_output_panel___lambda27_ (Block11Data* _data11_)
{
	SoundOutputPanel* self;
	gboolean _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 155 "../src/OutputPanel.vala"
	self = _data11_->self;
#line 156 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->_screen_reader_active;
#line 156 "../src/OutputPanel.vala"
	_tmp1_ = _data11_->screen_reader_switch;
#line 156 "../src/OutputPanel.vala"
	_tmp2_ = gtk_switch_get_active (_tmp1_);
#line 156 "../src/OutputPanel.vala"
	_tmp3_ = _tmp2_;
#line 156 "../src/OutputPanel.vala"
	if (_tmp0_ != _tmp3_) {
#line 1365 "OutputPanel.c"
		GtkSwitch* _tmp4_;
#line 157 "../src/OutputPanel.vala"
		_tmp4_ = _data11_->screen_reader_switch;
#line 157 "../src/OutputPanel.vala"
		g_signal_emit_by_name (_tmp4_, "activate");
#line 1371 "OutputPanel.c"
	}
}

static gboolean
__sound_output_panel___lambda27__gbinding_transform_func (GBinding* binding,
                                                          GValue* from_value,
                                                          GValue* to_value,
                                                          gpointer self)
{
	gboolean result;
	result = _sound_output_panel___lambda27_ (self);
#line 155 "../src/OutputPanel.vala"
	return result;
#line 1385 "OutputPanel.c"
}

static void
_sound_output_panel_add_device_sound_pulse_audio_manager_new_device (SoundPulseAudioManager* _sender,
                                                                     SoundDevice* dev,
                                                                     gpointer self)
{
#line 162 "../src/OutputPanel.vala"
	sound_output_panel_add_device ((SoundOutputPanel*) self, dev);
#line 1395 "OutputPanel.c"
}

static void
_sound_output_panel_default_changed_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 163 "../src/OutputPanel.vala"
	sound_output_panel_default_changed ((SoundOutputPanel*) self);
#line 1405 "OutputPanel.c"
}

static void
_sound_output_panel___lambda28_ (SoundOutputPanel* self,
                                 GtkListBoxRow* row)
{
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	SoundDevice* _tmp2_;
#line 180 "../src/OutputPanel.vala"
	g_return_if_fail (row != NULL);
#line 181 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->pam;
#line 181 "../src/OutputPanel.vala"
	_tmp1_ = sound_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (row, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow));
#line 181 "../src/OutputPanel.vala"
	_tmp2_ = _tmp1_;
#line 181 "../src/OutputPanel.vala"
	sound_pulse_audio_manager_set_default_device (_tmp0_, _tmp2_, NULL, NULL);
#line 1425 "OutputPanel.c"
}

static void
__sound_output_panel___lambda28__gtk_list_box_row_activated (GtkListBox* _sender,
                                                             GtkListBoxRow* row,
                                                             gpointer self)
{
#line 180 "../src/OutputPanel.vala"
	_sound_output_panel___lambda28_ ((SoundOutputPanel*) self, row);
#line 1435 "OutputPanel.c"
}

static void
_sound_output_panel___lambda29_ (Block11Data* _data11_)
{
	SoundOutputPanel* self;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 184 "../src/OutputPanel.vala"
	self = _data11_->self;
#line 185 "../src/OutputPanel.vala"
	_tmp0_ = _data11_->screen_reader_description_label;
#line 185 "../src/OutputPanel.vala"
	_tmp1_ = sound_output_panel_get_screenreader_shortcut_label (self);
#line 185 "../src/OutputPanel.vala"
	_tmp2_ = _tmp1_;
#line 185 "../src/OutputPanel.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 1455 "OutputPanel.c"
}

static void
__sound_output_panel___lambda29__g_settings_changed (GSettings* _sender,
                                                     const gchar* key,
                                                     gpointer self)
{
#line 184 "../src/OutputPanel.vala"
	_sound_output_panel___lambda29_ (self);
#line 1465 "OutputPanel.c"
}

static gboolean
_sound_output_panel___lambda30_ (SoundOutputPanel* self,
                                 GdkEventButton* e)
{
	gboolean result;
#line 188 "../src/OutputPanel.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 189 "../src/OutputPanel.vala"
	sound_output_panel_notify_change (self);
#line 190 "../src/OutputPanel.vala"
	result = FALSE;
#line 190 "../src/OutputPanel.vala"
	return result;
#line 1481 "OutputPanel.c"
}

static gboolean
__sound_output_panel___lambda30__gtk_widget_button_release_event (GtkWidget* _sender,
                                                                  GdkEventButton* event,
                                                                  gpointer self)
{
	gboolean result;
	result = _sound_output_panel___lambda30_ ((SoundOutputPanel*) self, event);
#line 188 "../src/OutputPanel.vala"
	return result;
#line 1493 "OutputPanel.c"
}

static gboolean
_sound_output_panel___lambda31_ (SoundOutputPanel* self,
                                 GdkEventScroll* e)
{
	GtkScale* _tmp0_;
	gboolean result;
#line 193 "../src/OutputPanel.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 194 "../src/OutputPanel.vala"
	_tmp0_ = self->priv->volume_scale;
#line 194 "../src/OutputPanel.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp0_) < ((gdouble) 100)) {
#line 195 "../src/OutputPanel.vala"
		sound_output_panel_notify_change (self);
#line 1510 "OutputPanel.c"
	}
#line 197 "../src/OutputPanel.vala"
	result = FALSE;
#line 197 "../src/OutputPanel.vala"
	return result;
#line 1516 "OutputPanel.c"
}

static gboolean
__sound_output_panel___lambda31__gtk_widget_scroll_event (GtkWidget* _sender,
                                                          GdkEventScroll* event,
                                                          gpointer self)
{
	gboolean result;
	result = _sound_output_panel___lambda31_ ((SoundOutputPanel*) self, event);
#line 193 "../src/OutputPanel.vala"
	return result;
#line 1528 "OutputPanel.c"
}

static GObject *
sound_output_panel_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundOutputPanel * self;
	Block11Data* _data11_;
	GraniteWidgetsAlertView* no_device_grid = NULL;
	GraniteWidgetsAlertView* _tmp0_;
	GraniteWidgetsAlertView* _tmp1_;
	GtkListBox* _tmp2_ = NULL;
	GtkListBox* _tmp3_;
	GraniteWidgetsAlertView* _tmp4_;
	GtkScrolledWindow* scrolled = NULL;
	GtkListBox* _tmp5_;
	GtkWidget* _tmp6_;
	GtkScrolledWindow* _tmp7_ = NULL;
	GtkFrame* devices_frame = NULL;
	GtkScrolledWindow* _tmp8_;
	GtkWidget* _tmp9_;
	GtkFrame* _tmp10_ = NULL;
	GraniteHeaderLabel* volume_label = NULL;
	GraniteHeaderLabel* _tmp11_;
	GtkScale* _tmp12_ = NULL;
	GtkScale* _tmp13_;
	GtkAdjustment* _tmp14_;
	GtkAdjustment* _tmp15_;
	GtkSwitch* _tmp16_ = NULL;
	GtkScale* _tmp17_ = NULL;
	GtkScale* _tmp18_;
	GtkAdjustment* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkScale* _tmp21_;
	GtkScale* _tmp22_;
	GtkScale* _tmp23_;
	GraniteHeaderLabel* alerts_label = NULL;
	GraniteHeaderLabel* _tmp24_;
	GtkCheckButton* audio_alert_check = NULL;
	GtkCheckButton* _tmp25_ = NULL;
	GtkCheckButton* visual_alert_check = NULL;
	GtkCheckButton* _tmp26_ = NULL;
	GtkLabel* alerts_info = NULL;
	GtkLabel* _tmp27_ = NULL;
	GtkLabel* _tmp28_;
	GtkStyleContext* _tmp29_;
	SoundTestPopover* test_popover = NULL;
	SoundTestPopover* _tmp30_;
	GtkMenuButton* test_button = NULL;
	gchar* _tmp31_;
	SoundTestPopover* _tmp32_;
	GtkPopover* _tmp33_;
	GtkMenuButton* _tmp34_ = NULL;
	GraniteHeaderLabel* screen_reader_label = NULL;
	GraniteHeaderLabel* _tmp35_;
	GtkSwitch* _tmp36_ = NULL;
	GSettings* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	GtkLabel* _tmp40_ = NULL;
	GtkLabel* _tmp41_;
	GtkStyleContext* _tmp42_;
	GtkGrid* output_grid = NULL;
	GtkGrid* _tmp43_ = NULL;
	GtkGrid* _tmp44_;
	GraniteHeaderLabel* _tmp45_;
	GtkGrid* _tmp46_;
	GtkScale* _tmp47_;
	GtkGrid* _tmp48_;
	GtkSwitch* _tmp49_;
	GtkGrid* _tmp50_;
	GtkScale* _tmp51_;
	GtkBox* alerts_box = NULL;
	GtkBox* _tmp52_;
	GtkBox* _tmp53_;
	GraniteHeaderLabel* _tmp54_;
	GtkBox* _tmp55_;
	GtkLabel* _tmp56_;
	GtkBox* _tmp57_;
	GtkCheckButton* _tmp58_;
	GtkBox* _tmp59_;
	GtkCheckButton* _tmp60_;
	GtkGrid* screen_reader_grid = NULL;
	GtkGrid* _tmp61_ = NULL;
	GtkGrid* _tmp62_;
	GraniteHeaderLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GtkLabel* _tmp65_;
	GtkGrid* _tmp66_;
	GtkSwitch* _tmp67_;
	GtkFrame* _tmp68_;
	GtkGrid* _tmp69_;
	GtkBox* _tmp70_;
	GtkGrid* _tmp71_;
	GtkMenuButton* _tmp72_;
	GSettings* applications_settings = NULL;
	GSettings* _tmp73_;
	GSettings* _tmp74_;
	GtkSwitch* _tmp75_;
	SoundPulseAudioManager* _tmp76_;
	SoundPulseAudioManager* _tmp77_;
	SoundPulseAudioManager* _tmp78_;
	GSettings* sound_settings = NULL;
	GSettings* _tmp79_;
	GSettings* _tmp80_;
	GtkCheckButton* _tmp81_;
	GSettings* wm_settings = NULL;
	GSettings* _tmp82_;
	GSettings* _tmp83_;
	GtkCheckButton* _tmp84_;
	ca_context* _tmp85_;
	gchar* locale = NULL;
	const gchar* _tmp86_;
	gchar* _tmp87_;
	ca_context* _tmp88_;
	const gchar* _tmp89_;
	ca_context* _tmp90_;
	GtkListBox* _tmp91_;
	GSettings* _tmp92_;
	GtkScale* _tmp93_;
	GtkScale* _tmp94_;
#line 37 "../src/OutputPanel.vala"
	parent_class = G_OBJECT_CLASS (sound_output_panel_parent_class);
#line 37 "../src/OutputPanel.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/OutputPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_OUTPUT_PANEL, SoundOutputPanel);
#line 37 "../src/OutputPanel.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 37 "../src/OutputPanel.vala"
	_data11_->_ref_count_ = 1;
#line 37 "../src/OutputPanel.vala"
	_data11_->self = g_object_ref (self);
#line 38 "../src/OutputPanel.vala"
	_tmp0_ = granite_widgets_alert_view_new (_ ("No Connected Output Devices Detected"), _ ("Check that all cables are securely attached and audio output devices a" \
"re powered on."), "audio-volume-muted-symbolic");
#line 38 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/OutputPanel.vala"
	no_device_grid = _tmp0_;
#line 43 "../src/OutputPanel.vala"
	_tmp1_ = no_device_grid;
#line 43 "../src/OutputPanel.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp1_);
#line 45 "../src/OutputPanel.vala"
	_tmp2_ = (GtkListBox*) gtk_list_box_new ();
#line 45 "../src/OutputPanel.vala"
	gtk_list_box_set_activate_on_single_click (_tmp2_, TRUE);
#line 45 "../src/OutputPanel.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
#line 45 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp2_);
#line 45 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->devices_listbox);
#line 45 "../src/OutputPanel.vala"
	self->priv->devices_listbox = _tmp2_;
#line 49 "../src/OutputPanel.vala"
	_tmp3_ = self->priv->devices_listbox;
#line 49 "../src/OutputPanel.vala"
	_tmp4_ = no_device_grid;
#line 49 "../src/OutputPanel.vala"
	gtk_list_box_set_placeholder (_tmp3_, (GtkWidget*) _tmp4_);
#line 51 "../src/OutputPanel.vala"
	_tmp5_ = self->priv->devices_listbox;
#line 51 "../src/OutputPanel.vala"
	_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
#line 51 "../src/OutputPanel.vala"
	_tmp7_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 51 "../src/OutputPanel.vala"
	g_object_set ((GtkContainer*) _tmp7_, "child", _tmp6_, NULL);
#line 51 "../src/OutputPanel.vala"
	_g_object_unref0 (_tmp6_);
#line 51 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp7_);
#line 51 "../src/OutputPanel.vala"
	scrolled = _tmp7_;
#line 55 "../src/OutputPanel.vala"
	_tmp8_ = scrolled;
#line 55 "../src/OutputPanel.vala"
	_tmp9_ = _g_object_ref0 ((GtkWidget*) _tmp8_);
#line 55 "../src/OutputPanel.vala"
	_tmp10_ = (GtkFrame*) gtk_frame_new (NULL);
#line 55 "../src/OutputPanel.vala"
	g_object_set ((GtkContainer*) _tmp10_, "child", _tmp9_, NULL);
#line 55 "../src/OutputPanel.vala"
	_g_object_unref0 (_tmp9_);
#line 55 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp10_);
#line 55 "../src/OutputPanel.vala"
	devices_frame = _tmp10_;
#line 59 "../src/OutputPanel.vala"
	_tmp11_ = granite_header_label_new (_ ("Volume"));
#line 59 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp11_);
#line 59 "../src/OutputPanel.vala"
	volume_label = _tmp11_;
#line 61 "../src/OutputPanel.vala"
	_tmp12_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 100, (gdouble) 5);
#line 61 "../src/OutputPanel.vala"
	gtk_scale_set_draw_value (_tmp12_, FALSE);
#line 61 "../src/OutputPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 61 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp12_);
#line 61 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 61 "../src/OutputPanel.vala"
	self->priv->volume_scale = _tmp12_;
#line 65 "../src/OutputPanel.vala"
	_tmp13_ = self->priv->volume_scale;
#line 65 "../src/OutputPanel.vala"
	_tmp14_ = gtk_range_get_adjustment ((GtkRange*) _tmp13_);
#line 65 "../src/OutputPanel.vala"
	_tmp15_ = _tmp14_;
#line 65 "../src/OutputPanel.vala"
	gtk_adjustment_set_page_increment (_tmp15_, (gdouble) 5);
#line 67 "../src/OutputPanel.vala"
	_tmp16_ = (GtkSwitch*) gtk_switch_new ();
#line 67 "../src/OutputPanel.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp16_, GTK_ALIGN_CENTER);
#line 67 "../src/OutputPanel.vala"
	gtk_switch_set_active (_tmp16_, TRUE);
#line 67 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp16_);
#line 67 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->volume_switch);
#line 67 "../src/OutputPanel.vala"
	self->priv->volume_switch = _tmp16_;
#line 71 "../src/OutputPanel.vala"
	_tmp17_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) -1, (gdouble) 1, 0.1);
#line 71 "../src/OutputPanel.vala"
	gtk_scale_set_draw_value (_tmp17_, FALSE);
#line 71 "../src/OutputPanel.vala"
	gtk_scale_set_has_origin (_tmp17_, FALSE);
#line 71 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp17_);
#line 71 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->balance_scale);
#line 71 "../src/OutputPanel.vala"
	self->priv->balance_scale = _tmp17_;
#line 76 "../src/OutputPanel.vala"
	_tmp18_ = self->priv->balance_scale;
#line 76 "../src/OutputPanel.vala"
	_tmp19_ = gtk_range_get_adjustment ((GtkRange*) _tmp18_);
#line 76 "../src/OutputPanel.vala"
	_tmp20_ = _tmp19_;
#line 76 "../src/OutputPanel.vala"
	gtk_adjustment_set_page_increment (_tmp20_, 0.1);
#line 78 "../src/OutputPanel.vala"
	_tmp21_ = self->priv->balance_scale;
#line 78 "../src/OutputPanel.vala"
	gtk_scale_add_mark (_tmp21_, (gdouble) -1, GTK_POS_BOTTOM, _ ("Left"));
#line 79 "../src/OutputPanel.vala"
	_tmp22_ = self->priv->balance_scale;
#line 79 "../src/OutputPanel.vala"
	gtk_scale_add_mark (_tmp22_, (gdouble) 0, GTK_POS_BOTTOM, _ ("Center"));
#line 80 "../src/OutputPanel.vala"
	_tmp23_ = self->priv->balance_scale;
#line 80 "../src/OutputPanel.vala"
	gtk_scale_add_mark (_tmp23_, (gdouble) 1, GTK_POS_BOTTOM, _ ("Right"));
#line 82 "../src/OutputPanel.vala"
	_tmp24_ = granite_header_label_new (_ ("Event Alerts"));
#line 82 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp24_);
#line 82 "../src/OutputPanel.vala"
	alerts_label = _tmp24_;
#line 84 "../src/OutputPanel.vala"
	_tmp25_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Play sound"));
#line 84 "../src/OutputPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp25_, 6);
#line 84 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp25_);
#line 84 "../src/OutputPanel.vala"
	audio_alert_check = _tmp25_;
#line 88 "../src/OutputPanel.vala"
	_tmp26_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Flash screen"));
#line 88 "../src/OutputPanel.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp26_, 6);
#line 88 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp26_);
#line 88 "../src/OutputPanel.vala"
	visual_alert_check = _tmp26_;
#line 92 "../src/OutputPanel.vala"
	_tmp27_ = (GtkLabel*) gtk_label_new (_ ("Notify when the system can't do something in response to input, like a" \
"ttempting to backspace in an empty input or switch windows when only o" \
"ne is open."));
#line 92 "../src/OutputPanel.vala"
	g_object_set (_tmp27_, "wrap", TRUE, NULL);
#line 92 "../src/OutputPanel.vala"
	gtk_label_set_xalign (_tmp27_, (gfloat) 0);
#line 92 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp27_);
#line 92 "../src/OutputPanel.vala"
	alerts_info = _tmp27_;
#line 99 "../src/OutputPanel.vala"
	_tmp28_ = alerts_info;
#line 99 "../src/OutputPanel.vala"
	_tmp29_ = gtk_widget_get_style_context ((GtkWidget*) _tmp28_);
#line 99 "../src/OutputPanel.vala"
	gtk_style_context_add_class (_tmp29_, GTK_STYLE_CLASS_DIM_LABEL);
#line 101 "../src/OutputPanel.vala"
	_tmp30_ = sound_test_popover_new ();
#line 101 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp30_);
#line 101 "../src/OutputPanel.vala"
	test_popover = _tmp30_;
#line 103 "../src/OutputPanel.vala"
	_tmp31_ = g_strdup (_ ("Test Speakers…"));
#line 103 "../src/OutputPanel.vala"
	_tmp32_ = test_popover;
#line 103 "../src/OutputPanel.vala"
	_tmp33_ = _g_object_ref0 ((GtkPopover*) _tmp32_);
#line 103 "../src/OutputPanel.vala"
	_tmp34_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 103 "../src/OutputPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp34_, GTK_ALIGN_END);
#line 103 "../src/OutputPanel.vala"
	gtk_button_set_label ((GtkButton*) _tmp34_, _tmp31_);
#line 103 "../src/OutputPanel.vala"
	_g_free0 (_tmp31_);
#line 103 "../src/OutputPanel.vala"
	gtk_menu_button_set_popover (_tmp34_, _tmp33_);
#line 103 "../src/OutputPanel.vala"
	_g_object_unref0 (_tmp33_);
#line 103 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp34_);
#line 103 "../src/OutputPanel.vala"
	test_button = _tmp34_;
#line 109 "../src/OutputPanel.vala"
	_tmp35_ = granite_header_label_new (_ ("Screen Reader"));
#line 109 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp35_);
#line 109 "../src/OutputPanel.vala"
	screen_reader_label = _tmp35_;
#line 111 "../src/OutputPanel.vala"
	_tmp36_ = (GtkSwitch*) gtk_switch_new ();
#line 111 "../src/OutputPanel.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp36_, GTK_ALIGN_END);
#line 111 "../src/OutputPanel.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp36_, GTK_ALIGN_CENTER);
#line 111 "../src/OutputPanel.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp36_, TRUE);
#line 111 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp36_);
#line 111 "../src/OutputPanel.vala"
	_data11_->screen_reader_switch = _tmp36_;
#line 117 "../src/OutputPanel.vala"
	_tmp37_ = g_settings_new ("org.gnome.settings-daemon.plugins.media-keys");
#line 117 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->media_keys_settings);
#line 117 "../src/OutputPanel.vala"
	self->priv->media_keys_settings = _tmp37_;
#line 118 "../src/OutputPanel.vala"
	_tmp38_ = sound_output_panel_get_screenreader_shortcut_label (self);
#line 118 "../src/OutputPanel.vala"
	_tmp39_ = _tmp38_;
#line 118 "../src/OutputPanel.vala"
	_tmp40_ = (GtkLabel*) gtk_label_new (_tmp39_);
#line 118 "../src/OutputPanel.vala"
	g_object_set (_tmp40_, "wrap", TRUE, NULL);
#line 118 "../src/OutputPanel.vala"
	gtk_label_set_xalign (_tmp40_, (gfloat) 0);
#line 118 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp40_);
#line 118 "../src/OutputPanel.vala"
	_data11_->screen_reader_description_label = _tmp40_;
#line 122 "../src/OutputPanel.vala"
	_tmp41_ = _data11_->screen_reader_description_label;
#line 122 "../src/OutputPanel.vala"
	_tmp42_ = gtk_widget_get_style_context ((GtkWidget*) _tmp41_);
#line 122 "../src/OutputPanel.vala"
	gtk_style_context_add_class (_tmp42_, GTK_STYLE_CLASS_DIM_LABEL);
#line 124 "../src/OutputPanel.vala"
	_tmp43_ = (GtkGrid*) gtk_grid_new ();
#line 124 "../src/OutputPanel.vala"
	gtk_grid_set_column_spacing (_tmp43_, 12);
#line 124 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp43_);
#line 124 "../src/OutputPanel.vala"
	output_grid = _tmp43_;
#line 127 "../src/OutputPanel.vala"
	_tmp44_ = output_grid;
#line 127 "../src/OutputPanel.vala"
	_tmp45_ = volume_label;
#line 127 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp44_, (GtkWidget*) _tmp45_, 0, 0, 2, 1);
#line 128 "../src/OutputPanel.vala"
	_tmp46_ = output_grid;
#line 128 "../src/OutputPanel.vala"
	_tmp47_ = self->priv->volume_scale;
#line 128 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, 0, 1, 1, 1);
#line 129 "../src/OutputPanel.vala"
	_tmp48_ = output_grid;
#line 129 "../src/OutputPanel.vala"
	_tmp49_ = self->priv->volume_switch;
#line 129 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp48_, (GtkWidget*) _tmp49_, 1, 1, 1, 1);
#line 130 "../src/OutputPanel.vala"
	_tmp50_ = output_grid;
#line 130 "../src/OutputPanel.vala"
	_tmp51_ = self->priv->balance_scale;
#line 130 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp50_, (GtkWidget*) _tmp51_, 0, 2, 1, 1);
#line 132 "../src/OutputPanel.vala"
	_tmp52_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 132 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp52_);
#line 132 "../src/OutputPanel.vala"
	alerts_box = _tmp52_;
#line 133 "../src/OutputPanel.vala"
	_tmp53_ = alerts_box;
#line 133 "../src/OutputPanel.vala"
	_tmp54_ = alerts_label;
#line 133 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
#line 134 "../src/OutputPanel.vala"
	_tmp55_ = alerts_box;
#line 134 "../src/OutputPanel.vala"
	_tmp56_ = alerts_info;
#line 134 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 135 "../src/OutputPanel.vala"
	_tmp57_ = alerts_box;
#line 135 "../src/OutputPanel.vala"
	_tmp58_ = audio_alert_check;
#line 135 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 136 "../src/OutputPanel.vala"
	_tmp59_ = alerts_box;
#line 136 "../src/OutputPanel.vala"
	_tmp60_ = visual_alert_check;
#line 136 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp60_);
#line 138 "../src/OutputPanel.vala"
	_tmp61_ = (GtkGrid*) gtk_grid_new ();
#line 138 "../src/OutputPanel.vala"
	gtk_grid_set_column_spacing (_tmp61_, 12);
#line 138 "../src/OutputPanel.vala"
	g_object_ref_sink (_tmp61_);
#line 138 "../src/OutputPanel.vala"
	screen_reader_grid = _tmp61_;
#line 141 "../src/OutputPanel.vala"
	_tmp62_ = screen_reader_grid;
#line 141 "../src/OutputPanel.vala"
	_tmp63_ = screen_reader_label;
#line 141 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 0, 1, 1);
#line 142 "../src/OutputPanel.vala"
	_tmp64_ = screen_reader_grid;
#line 142 "../src/OutputPanel.vala"
	_tmp65_ = _data11_->screen_reader_description_label;
#line 142 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 0, 1, 1, 1);
#line 143 "../src/OutputPanel.vala"
	_tmp66_ = screen_reader_grid;
#line 143 "../src/OutputPanel.vala"
	_tmp67_ = _data11_->screen_reader_switch;
#line 143 "../src/OutputPanel.vala"
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 1, 0, 1, 2);
#line 145 "../src/OutputPanel.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 146 "../src/OutputPanel.vala"
	gtk_box_set_spacing ((GtkBox*) self, 18);
#line 147 "../src/OutputPanel.vala"
	_tmp68_ = devices_frame;
#line 147 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp68_);
#line 148 "../src/OutputPanel.vala"
	_tmp69_ = output_grid;
#line 148 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp69_);
#line 149 "../src/OutputPanel.vala"
	_tmp70_ = alerts_box;
#line 149 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp70_);
#line 150 "../src/OutputPanel.vala"
	_tmp71_ = screen_reader_grid;
#line 150 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp71_);
#line 151 "../src/OutputPanel.vala"
	_tmp72_ = test_button;
#line 151 "../src/OutputPanel.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp72_);
#line 153 "../src/OutputPanel.vala"
	_tmp73_ = g_settings_new ("org.gnome.desktop.a11y.applications");
#line 153 "../src/OutputPanel.vala"
	applications_settings = _tmp73_;
#line 154 "../src/OutputPanel.vala"
	_tmp74_ = applications_settings;
#line 154 "../src/OutputPanel.vala"
	g_settings_bind (_tmp74_, "screen-reader-enabled", (GObject*) self, "screen_reader_active", G_SETTINGS_BIND_DEFAULT);
#line 155 "../src/OutputPanel.vala"
	_tmp75_ = _data11_->screen_reader_switch;
#line 155 "../src/OutputPanel.vala"
	g_object_bind_property_with_closures ((GObject*) self, "screen_reader_active", (GObject*) _tmp75_, "active", G_BINDING_BIDIRECTIONAL, (GClosure*) ((__sound_output_panel___lambda27__gbinding_transform_func == NULL) ? NULL : g_cclosure_new ((GCallback) __sound_output_panel___lambda27__gbinding_transform_func, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 161 "../src/OutputPanel.vala"
	_tmp76_ = sound_pulse_audio_manager_get_default ();
#line 161 "../src/OutputPanel.vala"
	self->priv->pam = _tmp76_;
#line 162 "../src/OutputPanel.vala"
	_tmp77_ = self->priv->pam;
#line 162 "../src/OutputPanel.vala"
	g_signal_connect_object (_tmp77_, "new-device", (GCallback) _sound_output_panel_add_device_sound_pulse_audio_manager_new_device, self, 0);
#line 163 "../src/OutputPanel.vala"
	_tmp78_ = self->priv->pam;
#line 163 "../src/OutputPanel.vala"
	g_signal_connect_object ((GObject*) _tmp78_, "notify::default-output", (GCallback) _sound_output_panel_default_changed_g_object_notify, self, 0);
#line 165 "../src/OutputPanel.vala"
	_tmp79_ = g_settings_new ("org.gnome.desktop.sound");
#line 165 "../src/OutputPanel.vala"
	sound_settings = _tmp79_;
#line 166 "../src/OutputPanel.vala"
	_tmp80_ = sound_settings;
#line 166 "../src/OutputPanel.vala"
	_tmp81_ = audio_alert_check;
#line 166 "../src/OutputPanel.vala"
	g_settings_bind (_tmp80_, "event-sounds", (GObject*) _tmp81_, "active", G_SETTINGS_BIND_DEFAULT);
#line 168 "../src/OutputPanel.vala"
	_tmp82_ = g_settings_new ("org.gnome.desktop.wm.preferences");
#line 168 "../src/OutputPanel.vala"
	wm_settings = _tmp82_;
#line 169 "../src/OutputPanel.vala"
	_tmp83_ = wm_settings;
#line 169 "../src/OutputPanel.vala"
	_tmp84_ = visual_alert_check;
#line 169 "../src/OutputPanel.vala"
	g_settings_bind (_tmp83_, "visual-bell", (GObject*) _tmp84_, "active", G_SETTINGS_BIND_DEFAULT);
#line 171 "../src/OutputPanel.vala"
	_tmp85_ = ca_gtk_context_get ();
#line 171 "../src/OutputPanel.vala"
	self->priv->ca_context = _tmp85_;
#line 172 "../src/OutputPanel.vala"
	_tmp86_ = setlocale (LC_MESSAGES, NULL);
#line 172 "../src/OutputPanel.vala"
	_tmp87_ = g_strdup (_tmp86_);
#line 172 "../src/OutputPanel.vala"
	locale = _tmp87_;
#line 173 "../src/OutputPanel.vala"
	_tmp88_ = self->priv->ca_context;
#line 173 "../src/OutputPanel.vala"
	_tmp89_ = locale;
#line 173 "../src/OutputPanel.vala"
	ca_context_change_props (_tmp88_, CA_PROP_APPLICATION_NAME, "switchboard-plug-sound", CA_PROP_APPLICATION_ID, "io.elementary.switchboard.sound", CA_PROP_APPLICATION_LANGUAGE, _tmp89_, NULL, NULL);
#line 177 "../src/OutputPanel.vala"
	_tmp90_ = self->priv->ca_context;
#line 177 "../src/OutputPanel.vala"
	ca_context_open (_tmp90_);
#line 178 "../src/OutputPanel.vala"
	sound_output_panel_connect_signals (self);
#line 180 "../src/OutputPanel.vala"
	_tmp91_ = self->priv->devices_listbox;
#line 180 "../src/OutputPanel.vala"
	g_signal_connect_object (_tmp91_, "row-activated", (GCallback) __sound_output_panel___lambda28__gtk_list_box_row_activated, self, 0);
#line 184 "../src/OutputPanel.vala"
	_tmp92_ = self->priv->media_keys_settings;
#line 184 "../src/OutputPanel.vala"
	g_signal_connect_data (_tmp92_, "changed::screenreader", (GCallback) __sound_output_panel___lambda29__g_settings_changed, block11_data_ref (_data11_), (GClosureNotify) block11_data_unref, 0);
#line 188 "../src/OutputPanel.vala"
	_tmp93_ = self->priv->volume_scale;
#line 188 "../src/OutputPanel.vala"
	g_signal_connect_object ((GtkWidget*) _tmp93_, "button-release-event", (GCallback) __sound_output_panel___lambda30__gtk_widget_button_release_event, self, 0);
#line 193 "../src/OutputPanel.vala"
	_tmp94_ = self->priv->volume_scale;
#line 193 "../src/OutputPanel.vala"
	g_signal_connect_object ((GtkWidget*) _tmp94_, "scroll-event", (GCallback) __sound_output_panel___lambda31__gtk_widget_scroll_event, self, 0);
#line 37 "../src/OutputPanel.vala"
	_g_free0 (locale);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (wm_settings);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (sound_settings);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (applications_settings);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (screen_reader_grid);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (alerts_box);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (output_grid);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (screen_reader_label);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (test_button);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (test_popover);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (alerts_info);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (visual_alert_check);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (audio_alert_check);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (alerts_label);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (volume_label);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (devices_frame);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (scrolled);
#line 37 "../src/OutputPanel.vala"
	_g_object_unref0 (no_device_grid);
#line 37 "../src/OutputPanel.vala"
	block11_data_unref (_data11_);
#line 37 "../src/OutputPanel.vala"
	_data11_ = NULL;
#line 37 "../src/OutputPanel.vala"
	return obj;
#line 2137 "OutputPanel.c"
}

static void
sound_output_panel_class_init (SoundOutputPanelClass * klass,
                               gpointer klass_data)
{
#line 8 "../src/OutputPanel.vala"
	sound_output_panel_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/OutputPanel.vala"
	g_type_class_adjust_private_offset (klass, &SoundOutputPanel_private_offset);
#line 8 "../src/OutputPanel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_output_panel_get_property;
#line 8 "../src/OutputPanel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_output_panel_set_property;
#line 8 "../src/OutputPanel.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_output_panel_constructor;
#line 8 "../src/OutputPanel.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_output_panel_finalize;
#line 8 "../src/OutputPanel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY, sound_output_panel_properties[SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY] = g_param_spec_boolean ("screen-reader-active", "screen-reader-active", "screen-reader-active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2158 "OutputPanel.c"
}

static void
sound_output_panel_instance_init (SoundOutputPanel * self,
                                  gpointer klass)
{
	gchar* _tmp0_;
#line 8 "../src/OutputPanel.vala"
	self->priv = sound_output_panel_get_instance_private (self);
#line 11 "../src/OutputPanel.vala"
	g_rec_mutex_init (&self->priv->__lock_default_device);
#line 11 "../src/OutputPanel.vala"
	self->priv->default_device = NULL;
#line 16 "../src/OutputPanel.vala"
	self->priv->notify_timeout_id = (guint) 0;
#line 17 "../src/OutputPanel.vala"
	self->priv->ca_context = NULL;
#line 21 "../src/OutputPanel.vala"
	_tmp0_ = g_strdup ("");
#line 21 "../src/OutputPanel.vala"
	self->priv->_screenreader_shortcut_label = _tmp0_;
#line 2180 "OutputPanel.c"
}

static void
sound_output_panel_finalize (GObject * obj)
{
	SoundOutputPanel * self;
#line 8 "../src/OutputPanel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_OUTPUT_PANEL, SoundOutputPanel);
#line 11 "../src/OutputPanel.vala"
	g_rec_mutex_clear (&self->priv->__lock_default_device);
#line 11 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->default_device);
#line 12 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->devices_listbox);
#line 13 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->balance_scale);
#line 14 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 15 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->volume_switch);
#line 19 "../src/OutputPanel.vala"
	_g_object_unref0 (self->priv->media_keys_settings);
#line 21 "../src/OutputPanel.vala"
	_g_free0 (self->priv->_screenreader_shortcut_label);
#line 8 "../src/OutputPanel.vala"
	G_OBJECT_CLASS (sound_output_panel_parent_class)->finalize (obj);
#line 2207 "OutputPanel.c"
}

static GType
sound_output_panel_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundOutputPanelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_output_panel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundOutputPanel), 0, (GInstanceInitFunc) sound_output_panel_instance_init, NULL };
	GType sound_output_panel_type_id;
	sound_output_panel_type_id = g_type_register_static (gtk_box_get_type (), "SoundOutputPanel", &g_define_type_info, 0);
	SoundOutputPanel_private_offset = g_type_add_instance_private (sound_output_panel_type_id, sizeof (SoundOutputPanelPrivate));
	return sound_output_panel_type_id;
}

GType
sound_output_panel_get_type (void)
{
	static volatile gsize sound_output_panel_type_id__once = 0;
	if (g_once_init_enter (&sound_output_panel_type_id__once)) {
		GType sound_output_panel_type_id;
		sound_output_panel_type_id = sound_output_panel_get_type_once ();
		g_once_init_leave (&sound_output_panel_type_id__once, sound_output_panel_type_id);
	}
	return sound_output_panel_type_id__once;
}

static void
_vala_sound_output_panel_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	SoundOutputPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_OUTPUT_PANEL, SoundOutputPanel);
#line 8 "../src/OutputPanel.vala"
	switch (property_id) {
#line 8 "../src/OutputPanel.vala"
		case SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY:
#line 8 "../src/OutputPanel.vala"
		g_value_set_boolean (value, sound_output_panel_get_screen_reader_active (self));
#line 8 "../src/OutputPanel.vala"
		break;
#line 2248 "OutputPanel.c"
		default:
#line 8 "../src/OutputPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/OutputPanel.vala"
		break;
#line 2254 "OutputPanel.c"
	}
}

static void
_vala_sound_output_panel_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	SoundOutputPanel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_OUTPUT_PANEL, SoundOutputPanel);
#line 8 "../src/OutputPanel.vala"
	switch (property_id) {
#line 8 "../src/OutputPanel.vala"
		case SOUND_OUTPUT_PANEL_SCREEN_READER_ACTIVE_PROPERTY:
#line 8 "../src/OutputPanel.vala"
		sound_output_panel_set_screen_reader_active (self, g_value_get_boolean (value));
#line 8 "../src/OutputPanel.vala"
		break;
#line 2274 "OutputPanel.c"
		default:
#line 8 "../src/OutputPanel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 8 "../src/OutputPanel.vala"
		break;
#line 2280 "OutputPanel.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

