/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.0-or-later
 * SPDX-FileCopyrightText: 2016-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "sound.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <handy.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_PLUG_0_PROPERTY,
	SOUND_PLUG_NUM_PROPERTIES
};
static GParamSpec* sound_plug_properties[SOUND_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPlugSearchData SoundPlugSearchData;

struct _SoundPlugPrivate {
	GtkBox* box;
	GtkStack* stack;
	SoundInputPanel* input_panel;
};

struct _SoundPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
};

static gint SoundPlug_private_offset;
static gpointer sound_plug_parent_class = NULL;

static GtkWidget* sound_plug_real_get_widget (SwitchboardPlug* base);
static void ___lambda32_ (SoundPlug* self);
static void ____lambda32__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void sound_plug_real_shown (SwitchboardPlug* base);
static void sound_plug_real_hidden (SwitchboardPlug* base);
static void sound_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void sound_plug_real_search_data_free (gpointer _data);
static void sound_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean sound_plug_real_search_co (SoundPlugSearchData* _data_);
static void sound_plug_finalize (GObject * obj);
static GType sound_plug_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_plug_get_instance_private (SoundPlug* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPlug_private_offset);
}

SoundPlug*
sound_plug_construct (GType object_type)
{
	SoundPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 14 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 15 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 17 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 17 "../src/Plug.vala"
	settings = _tmp0_;
#line 18 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound", NULL);
#line 19 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound/input", "input");
#line 20 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound/output", "output");
#line 21 "../src/Plug.vala"
	self = (SoundPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.switchboard.sound", "display-name", _ ("Sound"), "description", _ ("Change sound and microphone volume"), "icon", "preferences-desktop-sound", "supported-settings", settings, NULL);
#line 13 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 13 "../src/Plug.vala"
	return self;
#line 160 "Plug.c"
}

SoundPlug*
sound_plug_new (void)
{
#line 13 "../src/Plug.vala"
	return sound_plug_construct (SOUND_TYPE_PLUG);
#line 168 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 41 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 176 "Plug.c"
}

static void
___lambda32_ (SoundPlug* self)
{
	SoundInputPanel* _tmp0_;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	SoundInputPanel* _tmp4_;
#line 62 "../src/Plug.vala"
	_tmp0_ = self->priv->input_panel;
#line 62 "../src/Plug.vala"
	_tmp1_ = self->priv->stack;
#line 62 "../src/Plug.vala"
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
#line 62 "../src/Plug.vala"
	_tmp3_ = _tmp2_;
#line 62 "../src/Plug.vala"
	_tmp4_ = self->priv->input_panel;
#line 62 "../src/Plug.vala"
	sound_input_panel_set_visibility (_tmp0_, _tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 199 "Plug.c"
}

static void
____lambda32__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 61 "../src/Plug.vala"
	___lambda32_ ((SoundPlug*) self);
#line 209 "Plug.c"
}

static GtkWidget*
sound_plug_real_get_widget (SwitchboardPlug* base)
{
	SoundPlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* result;
#line 29 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 30 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 30 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 226 "Plug.c"
		SoundOutputPanel* output_panel = NULL;
		SoundOutputPanel* _tmp1_;
		SoundInputPanel* _tmp2_;
		GtkStack* _tmp3_ = NULL;
		GtkStack* _tmp4_;
		SoundOutputPanel* _tmp5_;
		GtkStack* _tmp6_;
		SoundInputPanel* _tmp7_;
		GtkStackSwitcher* stack_switcher = NULL;
		GtkStack* _tmp8_;
		GtkStack* _tmp9_;
		GtkStackSwitcher* _tmp10_ = NULL;
		HdyClamp* clamp = NULL;
		GtkStack* _tmp11_;
		GtkWidget* _tmp12_;
		HdyClamp* _tmp13_ = NULL;
		GtkBox* _tmp14_ = NULL;
		GtkBox* _tmp15_;
		GtkStackSwitcher* _tmp16_;
		GtkBox* _tmp17_;
		HdyClamp* _tmp18_;
		GtkBox* _tmp19_;
		SoundPulseAudioManager* pam = NULL;
		SoundPulseAudioManager* _tmp20_;
		SoundPulseAudioManager* _tmp21_;
		SoundPulseAudioManager* _tmp22_;
		GtkStack* _tmp23_;
#line 31 "../src/Plug.vala"
		_tmp1_ = sound_output_panel_new ();
#line 31 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 31 "../src/Plug.vala"
		output_panel = _tmp1_;
#line 32 "../src/Plug.vala"
		_tmp2_ = sound_input_panel_new ();
#line 32 "../src/Plug.vala"
		g_object_ref_sink (_tmp2_);
#line 32 "../src/Plug.vala"
		_g_object_unref0 (self->priv->input_panel);
#line 32 "../src/Plug.vala"
		self->priv->input_panel = _tmp2_;
#line 34 "../src/Plug.vala"
		_tmp3_ = (GtkStack*) gtk_stack_new ();
#line 34 "../src/Plug.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
#line 34 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp3_, TRUE);
#line 34 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 34 "../src/Plug.vala"
		_g_object_unref0 (self->priv->stack);
#line 34 "../src/Plug.vala"
		self->priv->stack = _tmp3_;
#line 38 "../src/Plug.vala"
		_tmp4_ = self->priv->stack;
#line 38 "../src/Plug.vala"
		_tmp5_ = output_panel;
#line 38 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp4_, (GtkWidget*) _tmp5_, "output", _ ("Output"));
#line 39 "../src/Plug.vala"
		_tmp6_ = self->priv->stack;
#line 39 "../src/Plug.vala"
		_tmp7_ = self->priv->input_panel;
#line 39 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp6_, (GtkWidget*) _tmp7_, "input", _ ("Input"));
#line 41 "../src/Plug.vala"
		_tmp8_ = self->priv->stack;
#line 41 "../src/Plug.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 41 "../src/Plug.vala"
		_tmp10_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 41 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_CENTER);
#line 41 "../src/Plug.vala"
		gtk_box_set_homogeneous ((GtkBox*) _tmp10_, TRUE);
#line 41 "../src/Plug.vala"
		gtk_stack_switcher_set_stack (_tmp10_, _tmp9_);
#line 41 "../src/Plug.vala"
		_g_object_unref0 (_tmp9_);
#line 41 "../src/Plug.vala"
		g_object_ref_sink (_tmp10_);
#line 41 "../src/Plug.vala"
		stack_switcher = _tmp10_;
#line 47 "../src/Plug.vala"
		_tmp11_ = self->priv->stack;
#line 47 "../src/Plug.vala"
		_tmp12_ = _g_object_ref0 ((GtkWidget*) _tmp11_);
#line 47 "../src/Plug.vala"
		_tmp13_ = (HdyClamp*) hdy_clamp_new ();
#line 47 "../src/Plug.vala"
		g_object_set ((GtkContainer*) _tmp13_, "child", _tmp12_, NULL);
#line 47 "../src/Plug.vala"
		_g_object_unref0 (_tmp12_);
#line 47 "../src/Plug.vala"
		g_object_ref_sink (_tmp13_);
#line 47 "../src/Plug.vala"
		clamp = _tmp13_;
#line 51 "../src/Plug.vala"
		_tmp14_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 51 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp14_, "margin", 12, NULL);
#line 51 "../src/Plug.vala"
		g_object_ref_sink (_tmp14_);
#line 51 "../src/Plug.vala"
		_g_object_unref0 (self->priv->box);
#line 51 "../src/Plug.vala"
		self->priv->box = _tmp14_;
#line 54 "../src/Plug.vala"
		_tmp15_ = self->priv->box;
#line 54 "../src/Plug.vala"
		_tmp16_ = stack_switcher;
#line 54 "../src/Plug.vala"
		gtk_container_add ((GtkContainer*) _tmp15_, (GtkWidget*) _tmp16_);
#line 55 "../src/Plug.vala"
		_tmp17_ = self->priv->box;
#line 55 "../src/Plug.vala"
		_tmp18_ = clamp;
#line 55 "../src/Plug.vala"
		gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 56 "../src/Plug.vala"
		_tmp19_ = self->priv->box;
#line 56 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp19_);
#line 58 "../src/Plug.vala"
		_tmp20_ = sound_pulse_audio_manager_get_default ();
#line 58 "../src/Plug.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 58 "../src/Plug.vala"
		pam = _tmp21_;
#line 59 "../src/Plug.vala"
		_tmp22_ = pam;
#line 59 "../src/Plug.vala"
		sound_pulse_audio_manager_start (_tmp22_);
#line 61 "../src/Plug.vala"
		_tmp23_ = self->priv->stack;
#line 61 "../src/Plug.vala"
		g_signal_connect_object ((GObject*) _tmp23_, "notify::visible-child", (GCallback) ____lambda32__g_object_notify, self, 0);
#line 30 "../src/Plug.vala"
		_g_object_unref0 (pam);
#line 30 "../src/Plug.vala"
		_g_object_unref0 (clamp);
#line 30 "../src/Plug.vala"
		_g_object_unref0 (stack_switcher);
#line 30 "../src/Plug.vala"
		_g_object_unref0 (output_panel);
#line 372 "Plug.c"
	}
#line 66 "../src/Plug.vala"
	_tmp24_ = self->priv->box;
#line 66 "../src/Plug.vala"
	_tmp25_ = _g_object_ref0 ((GtkWidget*) _tmp24_);
#line 66 "../src/Plug.vala"
	result = _tmp25_;
#line 66 "../src/Plug.vala"
	return result;
#line 382 "Plug.c"
}

static void
sound_plug_real_shown (SwitchboardPlug* base)
{
	SoundPlug * self;
	GtkBox* _tmp0_;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	SoundInputPanel* _tmp4_;
#line 69 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 70 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 70 "../src/Plug.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 71 "../src/Plug.vala"
	_tmp1_ = self->priv->stack;
#line 71 "../src/Plug.vala"
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
#line 71 "../src/Plug.vala"
	_tmp3_ = _tmp2_;
#line 71 "../src/Plug.vala"
	_tmp4_ = self->priv->input_panel;
#line 71 "../src/Plug.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 410 "Plug.c"
		SoundInputPanel* _tmp5_;
#line 72 "../src/Plug.vala"
		_tmp5_ = self->priv->input_panel;
#line 72 "../src/Plug.vala"
		sound_input_panel_set_visibility (_tmp5_, TRUE);
#line 416 "Plug.c"
	}
}

static void
sound_plug_real_hidden (SwitchboardPlug* base)
{
	SoundPlug * self;
#line 76 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 426 "Plug.c"
}

static void
sound_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	SoundPlug * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 80 "../src/Plug.vala"
	static GQuark _tmp1_label0 = 0;
#line 80 "../src/Plug.vala"
	static GQuark _tmp1_label1 = 0;
#line 79 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 79 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 80 "../src/Plug.vala"
	_tmp0_ = location;
#line 80 "../src/Plug.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 80 "../src/Plug.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("input")))) {
#line 80 "../src/Plug.vala"
		switch (0) {
#line 452 "Plug.c"
			default:
			{
				GtkStack* _tmp3_;
#line 82 "../src/Plug.vala"
				_tmp3_ = self->priv->stack;
#line 82 "../src/Plug.vala"
				gtk_stack_set_visible_child_name (_tmp3_, "input");
#line 83 "../src/Plug.vala"
				break;
#line 462 "Plug.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("output")))) {
#line 80 "../src/Plug.vala"
		switch (0) {
#line 468 "Plug.c"
			default:
			{
				GtkStack* _tmp4_;
#line 85 "../src/Plug.vala"
				_tmp4_ = self->priv->stack;
#line 85 "../src/Plug.vala"
				gtk_stack_set_visible_child_name (_tmp4_, "output");
#line 86 "../src/Plug.vala"
				break;
#line 478 "Plug.c"
			}
		}
	}
}

static void
sound_plug_real_search_data_free (gpointer _data)
{
	SoundPlugSearchData* _data_;
	_data_ = _data;
#line 8 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 8 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 8 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Plug.vala"
	g_slice_free (SoundPlugSearchData, _data_);
#line 497 "Plug.c"
}

static void
sound_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	SoundPlug * self;
	SoundPlugSearchData* _data_;
	SoundPlug* _tmp0_;
	gchar* _tmp1_;
#line 8 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 8 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 8 "../src/Plug.vala"
	_data_ = g_slice_new0 (SoundPlugSearchData);
#line 8 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_plug_real_search_data_free);
#line 8 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 8 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 8 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 8 "../src/Plug.vala"
	sound_plug_real_search_co (_data_);
#line 532 "Plug.c"
}

static GeeTreeMap*
sound_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	SoundPlugSearchData* _data_;
#line 8 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8 "../src/Plug.vala"
	result = _data_->result;
#line 8 "../src/Plug.vala"
	_data_->result = NULL;
#line 8 "../src/Plug.vala"
	return result;
#line 549 "Plug.c"
}

static gboolean
sound_plug_real_search_co (SoundPlugSearchData* _data_)
{
#line 91 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 91 "../src/Plug.vala"
		case 0:
#line 559 "Plug.c"
		goto _state_0;
		default:
#line 91 "../src/Plug.vala"
		g_assert_not_reached ();
#line 564 "Plug.c"
	}
	_state_0:
#line 92 "../src/Plug.vala"
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 92 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp0_;
#line 93 "../src/Plug.vala"
	_data_->_tmp1_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 93 "../src/Plug.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 93 "../src/Plug.vala"
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Output"));
#line 93 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 93 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp4_, "output");
#line 93 "../src/Plug.vala"
	_g_free0 (_data_->_tmp4_);
#line 94 "../src/Plug.vala"
	_data_->_tmp5_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 94 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 94 "../src/Plug.vala"
	_data_->_tmp7_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp6_, _ ("Output"), _ ("Device"));
#line 94 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 94 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp8_, "output");
#line 94 "../src/Plug.vala"
	_g_free0 (_data_->_tmp8_);
#line 95 "../src/Plug.vala"
	_data_->_tmp9_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 95 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 95 "../src/Plug.vala"
	_data_->_tmp11_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp10_, _ ("Output"), _ ("Event Sounds"));
#line 95 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 95 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp12_, "output");
#line 95 "../src/Plug.vala"
	_g_free0 (_data_->_tmp12_);
#line 96 "../src/Plug.vala"
	_data_->_tmp13_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 96 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 96 "../src/Plug.vala"
	_data_->_tmp15_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp14_, _ ("Output"), _ ("Port"));
#line 96 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 96 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp16_, "output");
#line 96 "../src/Plug.vala"
	_g_free0 (_data_->_tmp16_);
#line 97 "../src/Plug.vala"
	_data_->_tmp17_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 97 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 97 "../src/Plug.vala"
	_data_->_tmp19_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp18_, _ ("Output"), _ ("Volume"));
#line 97 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 97 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp20_, "output");
#line 97 "../src/Plug.vala"
	_g_free0 (_data_->_tmp20_);
#line 98 "../src/Plug.vala"
	_data_->_tmp21_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 98 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 98 "../src/Plug.vala"
	_data_->_tmp23_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp22_, _ ("Output"), _ ("Balance"));
#line 98 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 98 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp24_, "output");
#line 98 "../src/Plug.vala"
	_g_free0 (_data_->_tmp24_);
#line 99 "../src/Plug.vala"
	_data_->_tmp25_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 99 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 99 "../src/Plug.vala"
	_data_->_tmp27_ = g_strdup_printf ("%s → %s", _data_->_tmp26_, _ ("Input"));
#line 99 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 99 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp28_, "input");
#line 99 "../src/Plug.vala"
	_g_free0 (_data_->_tmp28_);
#line 100 "../src/Plug.vala"
	_data_->_tmp29_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 100 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 100 "../src/Plug.vala"
	_data_->_tmp31_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp30_, _ ("Input"), _ ("Device"));
#line 100 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 100 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp32_, "input");
#line 100 "../src/Plug.vala"
	_g_free0 (_data_->_tmp32_);
#line 101 "../src/Plug.vala"
	_data_->_tmp33_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 101 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 101 "../src/Plug.vala"
	_data_->_tmp35_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp34_, _ ("Input"), _ ("Port"));
#line 101 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 101 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp36_, "input");
#line 101 "../src/Plug.vala"
	_g_free0 (_data_->_tmp36_);
#line 102 "../src/Plug.vala"
	_data_->_tmp37_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 102 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 102 "../src/Plug.vala"
	_data_->_tmp39_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp38_, _ ("Input"), _ ("Volume"));
#line 102 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 102 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp40_, "input");
#line 102 "../src/Plug.vala"
	_g_free0 (_data_->_tmp40_);
#line 103 "../src/Plug.vala"
	_data_->_tmp41_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 103 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 103 "../src/Plug.vala"
	_data_->_tmp43_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp42_, _ ("Input"), _ ("Enable"));
#line 103 "../src/Plug.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 103 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp44_, "input");
#line 103 "../src/Plug.vala"
	_g_free0 (_data_->_tmp44_);
#line 104 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 104 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 104 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 104 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 104 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 713 "Plug.c"
		}
	}
#line 104 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 104 "../src/Plug.vala"
	return FALSE;
#line 720 "Plug.c"
}

static void
sound_plug_class_init (SoundPlugClass * klass,
                       gpointer klass_data)
{
#line 8 "../src/Plug.vala"
	sound_plug_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &SoundPlug_private_offset);
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) sound_plug_real_get_widget;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) sound_plug_real_shown;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) sound_plug_real_hidden;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) sound_plug_real_search_callback;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) sound_plug_real_search;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) sound_plug_search_finish;
#line 8 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_plug_finalize;
#line 745 "Plug.c"
}

static void
sound_plug_instance_init (SoundPlug * self,
                          gpointer klass)
{
#line 8 "../src/Plug.vala"
	self->priv = sound_plug_get_instance_private (self);
#line 754 "Plug.c"
}

static void
sound_plug_finalize (GObject * obj)
{
	SoundPlug * self;
#line 8 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PLUG, SoundPlug);
#line 9 "../src/Plug.vala"
	_g_object_unref0 (self->priv->box);
#line 10 "../src/Plug.vala"
	_g_object_unref0 (self->priv->stack);
#line 11 "../src/Plug.vala"
	_g_object_unref0 (self->priv->input_panel);
#line 8 "../src/Plug.vala"
	G_OBJECT_CLASS (sound_plug_parent_class)->finalize (obj);
#line 771 "Plug.c"
}

static GType
sound_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPlug), 0, (GInstanceInitFunc) sound_plug_instance_init, NULL };
	GType sound_plug_type_id;
	sound_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "SoundPlug", &g_define_type_info, 0);
	SoundPlug_private_offset = g_type_add_instance_private (sound_plug_type_id, sizeof (SoundPlugPrivate));
	return sound_plug_type_id;
}

GType
sound_plug_get_type (void)
{
	static volatile gsize sound_plug_type_id__once = 0;
	if (g_once_init_enter (&sound_plug_type_id__once)) {
		GType sound_plug_type_id;
		sound_plug_type_id = sound_plug_get_type_once ();
		g_once_init_leave (&sound_plug_type_id__once, sound_plug_type_id);
	}
	return sound_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	SoundPlug* plug = NULL;
	SoundPlug* _tmp0_;
	SwitchboardPlug* result;
#line 109 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 110 "../src/Plug.vala"
	g_debug ("Plug.vala:110: Activating Sound plug");
#line 111 "../src/Plug.vala"
	_tmp0_ = sound_plug_new ();
#line 111 "../src/Plug.vala"
	plug = _tmp0_;
#line 112 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 112 "../src/Plug.vala"
	return result;
#line 814 "Plug.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

