/* PulseAudioManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PulseAudioManager.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/*
 * Vocabulary of PulseAudio:
 *  - Source: Input (microphone)
 *  - Sink: Output (speaker)
 */

#include "sound.h"
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include "pulse/ext-stream-restore.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_PULSE_AUDIO_MANAGER_0_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY,
	SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES
};
static GParamSpec* sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _pa_glib_mainloop_free0(var) ((var == NULL) ? NULL : (var = (pa_glib_mainloop_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPulseAudioManagerSetDefaultDeviceData SoundPulseAudioManagerSetDefaultDeviceData;
typedef struct _Block1Data Block1Data;
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _SoundPulseAudioManagerSetCardProfileByIndexData SoundPulseAudioManagerSetCardProfileByIndexData;
typedef struct _Block2Data Block2Data;
typedef struct _SoundPulseAudioManagerWaitForUpdateData SoundPulseAudioManagerWaitForUpdateData;
typedef struct _Block3Data Block3Data;
typedef struct _SoundPulseAudioManagerSetSinkPortByNameData SoundPulseAudioManagerSetSinkPortByNameData;
typedef struct _Block4Data Block4Data;
typedef struct _SoundPulseAudioManagerSetSourcePortByNameData SoundPulseAudioManagerSetSourcePortByNameData;
typedef struct _Block5Data Block5Data;
typedef struct _SoundPulseAudioManagerSetDefaultSinkData SoundPulseAudioManagerSetDefaultSinkData;
typedef struct _Block6Data Block6Data;
typedef struct _SoundPulseAudioManagerSetDefaultSourceData SoundPulseAudioManagerSetDefaultSourceData;
typedef struct _Block7Data Block7Data;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
typedef struct _SoundPulseAudioManagerReconnectToPulseData SoundPulseAudioManagerReconnectToPulseData;
typedef struct _Block8Data Block8Data;
typedef struct _Block9Data Block9Data;
enum  {
	SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL,
	SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS
};
static guint sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NUM_SIGNALS] = {0};

struct _SoundPulseAudioManagerPrivate {
	pa_context* _context;
	pa_glib_mainloop* loop;
	gboolean is_ready;
	guint reconnect_timer_id;
	GeeHashMap* input_devices;
	GeeHashMap* output_devices;
	SoundDevice* _default_output;
	SoundDevice* _default_input;
	gchar* default_source_name;
	gchar* default_sink_name;
	GeeHashMap* volume_operations;
};

struct _SoundPulseAudioManagerSetDefaultDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	SoundDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	SoundDevice* _tmp8_;
	SoundDevice* _tmp9_;
	SoundDevice* other_device;
	SoundDevice* _tmp10_;
	gchar* profile_name;
	SoundDevice* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	GeeArrayList* _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	guint32 _tmp23_;
	guint32 _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	const gchar* _tmp43_;
	gboolean _tmp44_;
	gboolean _tmp45_;
	gboolean _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	const gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	const gchar* _tmp63_;
	const gchar* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	gboolean _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	gboolean _tmp71_;
	gboolean _tmp72_;
	gboolean _tmp73_;
	gboolean _tmp74_;
	gboolean _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	const gchar* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	gboolean _tmp84_;
	gboolean _tmp85_;
	gboolean _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	const gchar* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
};

struct _Block1Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetCardProfileByIndexData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	guint32 card_index;
	gchar* profile_name;
	Block1Data* _data1_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block2Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gulong handler_id;
	SoundDevice* device;
	gchar* prop_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerWaitForUpdateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	SoundDevice* device;
	gchar* prop_name;
	Block2Data* _data2_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gulong _tmp3_;
};

struct _Block3Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSinkPortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gchar* port_name;
	Block3Data* _data3_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block4Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetSourcePortByNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gchar* port_name;
	Block4Data* _data4_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block5Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSinkData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* sink_name;
	Block5Data* _data5_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block6Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	gchar* source_name;
	gpointer _async_data_;
};

struct _SoundPulseAudioManagerSetDefaultSourceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	gchar* source_name;
	Block6Data* _data6_;
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
};

struct _Block7Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _SoundPulseAudioManagerReconnectToPulseData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPulseAudioManager* self;
	pa_context* _tmp0_;
	pa_proplist* props;
	pa_proplist* _tmp1_;
	pa_proplist* _tmp2_;
	pa_glib_mainloop* _tmp3_;
	pa_mainloop_api* _tmp4_;
	pa_proplist* _tmp5_;
	pa_context* _tmp6_;
	pa_context* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	pa_context* _tmp10_;
	const gchar* _tmp11_;
};

struct _Block8Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

struct _Block9Data {
	int _ref_count_;
	SoundPulseAudioManager* self;
	SoundDevice* device;
};

static gint SoundPulseAudioManager_private_offset;
static gpointer sound_pulse_audio_manager_parent_class = NULL;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam;
static SoundPulseAudioManager* sound_pulse_audio_manager_pam = NULL;
static gboolean sound_pulse_audio_manager_debug_enabled;
static gboolean sound_pulse_audio_manager_debug_enabled = FALSE;

static SoundPulseAudioManager* sound_pulse_audio_manager_new (void);
static SoundPulseAudioManager* sound_pulse_audio_manager_construct (GType object_type);
static void sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_);
static void sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                          guint32 card_index,
                                                          const gchar* profile_name,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                                 GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                         GAsyncResult* _res_,
                                                         gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                const gchar* prop_name,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                       GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                      const gchar* sink_name,
                                                      const gchar* port_name,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                             GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                        const gchar* source_name,
                                                        const gchar* port_name,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
static void sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                               GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_);
static void sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda9_ (Block1Data* _data1_,
                 pa_context* c,
                 gint success);
static void ___lambda9__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static void sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda10_ (Block2Data* _data2_,
                  GObject* s,
                  GParamSpec* p);
static void ___lambda10__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda11_ (Block3Data* _data3_,
                  pa_context* c,
                  gint success);
static void ___lambda11__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda12_ (Block4Data* _data4_,
                  pa_context* c,
                  gint success);
static void ___lambda12__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda13_ (Block5Data* _data5_,
                  pa_context* c,
                  gint success);
static void ___lambda13__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static void sound_pulse_audio_manager_set_default_source_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static void __lambda14_ (Block6Data* _data6_,
                  pa_context* c,
                  gint success);
static void ___lambda14__pa_context_success_cb_t (pa_context* c,
                                           gint success,
                                           gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static gboolean __lambda15_ (Block7Data* _data7_,
                      pa_operation* operation);
static gboolean ___lambda15__gee_forall_func (gpointer g,
                                       gpointer self);
static pa_volume_t sound_pulse_audio_manager_double_to_volume (gdouble vol);
static gboolean sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self);
static void sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data);
static gboolean sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_);
static void sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                            pa_context* value);
static void sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                       pa_context* c);
static void _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                               gpointer self);
static void sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_subscription_event_type_t t,
                                                   guint32 index);
static void _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                              pa_subscription_event_type_t t,
                                                                              guint32 idx,
                                                                              gpointer self);
static void sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* context,
                                                     pa_server_info* server);
static void _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                          pa_server_info* i,
                                                                          gpointer self);
static gboolean _sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self);
static void sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_sink_info* sink,
                                                   gint eol);
static void _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                                   pa_context* c,
                                                   pa_card_info* card,
                                                   gint eol);
static void _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                      pa_card_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                       GeeHashMap* devices,
                                                       guint32 card_index);
static void sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                     pa_context* c,
                                                     pa_source_info* source,
                                                     gint eol);
static void _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                          pa_source_info* i,
                                                                          gint eol,
                                                                          gpointer self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static gboolean ______lambda8_ (Block8Data* _data8_,
                         pa_operation* operation);
static gboolean _______lambda8__gee_forall_func (gpointer g,
                                          gpointer self);
static gdouble sound_pulse_audio_manager_volume_to_double (pa_volume_t vol);
static void sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                                  SoundDevice* value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean ______lambda5_ (Block9Data* _data9_,
                         pa_operation* operation);
static gboolean _______lambda5__gee_forall_func (gpointer g,
                                          gpointer self);
static void sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                                   SoundDevice* value);
static void _vala_array_add1 (pa_card_port_info** * array,
                       gint* length,
                       gint* size,
                       pa_card_port_info* value);
static gchar* sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                                pa_card_port_info* port);
static GeeArrayList* sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                                         pa_card_port_info* port);
static void sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                                GeeHashMap* devices,
                                                pa_card_info* card,
                                                pa_card_port_info** relevant_ports,
                                                gint relevant_ports_length1);
static pa_card_profile_info2** _vala_array_dup1 (pa_card_profile_info2** self,
                                          gssize length);
static gint __lambda7_ (SoundPulseAudioManager* self,
                 pa_card_profile_info2* a,
                 pa_card_profile_info2* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                      pa_context* c,
                                                                      pa_ext_stream_restore_info* info,
                                                                      gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                              pa_ext_stream_restore_info* info,
                                                                                                              gint eol,
                                                                                                              gpointer self);
static void sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                        pa_context* c,
                                                                        pa_ext_stream_restore_info* info,
                                                                        gint eol);
static void _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                                pa_ext_stream_restore_info* info,
                                                                                                                gint eol,
                                                                                                                gpointer self);
static void __lambda6_ (SoundPulseAudioManager* self,
                 pa_context* c,
                 gint success);
static void ___lambda6__pa_context_success_cb_t (pa_context* c,
                                          gint success,
                                          gpointer self);
static GObject * sound_pulse_audio_manager_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void sound_pulse_audio_manager_finalize (GObject * obj);
static GType sound_pulse_audio_manager_get_type_once (void);
static void _vala_sound_pulse_audio_manager_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sound_pulse_audio_manager_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_pulse_audio_manager_get_instance_private (SoundPulseAudioManager* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPulseAudioManager_private_offset);
}

SoundPulseAudioManager*
sound_pulse_audio_manager_get_default (void)
{
	SoundPulseAudioManager* _tmp0_;
	SoundPulseAudioManager* _tmp2_;
	SoundPulseAudioManager* result;
#line 34 "../src/PulseAudioManager.vala"
	_tmp0_ = sound_pulse_audio_manager_pam;
#line 34 "../src/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 659 "PulseAudioManager.c"
		SoundPulseAudioManager* _tmp1_;
#line 35 "../src/PulseAudioManager.vala"
		_tmp1_ = sound_pulse_audio_manager_new ();
#line 35 "../src/PulseAudioManager.vala"
		_g_object_unref0 (sound_pulse_audio_manager_pam);
#line 35 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_pam = _tmp1_;
#line 667 "PulseAudioManager.c"
	}
#line 38 "../src/PulseAudioManager.vala"
	_tmp2_ = sound_pulse_audio_manager_pam;
#line 38 "../src/PulseAudioManager.vala"
	result = _tmp2_;
#line 38 "../src/PulseAudioManager.vala"
	return result;
#line 675 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_construct (GType object_type)
{
	SoundPulseAudioManager * self = NULL;
#line 55 "../src/PulseAudioManager.vala"
	self = (SoundPulseAudioManager*) g_object_new (object_type, NULL);
#line 55 "../src/PulseAudioManager.vala"
	return self;
#line 686 "PulseAudioManager.c"
}

static SoundPulseAudioManager*
sound_pulse_audio_manager_new (void)
{
#line 55 "../src/PulseAudioManager.vala"
	return sound_pulse_audio_manager_construct (SOUND_TYPE_PULSE_AUDIO_MANAGER);
#line 694 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_start (SoundPulseAudioManager* self)
{
#line 72 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 704 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultDeviceData, _data_);
#line 718 "PulseAudioManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/PulseAudioManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 726 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultDeviceData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_device_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 760 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_set_default_device_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 770 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_device_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultDeviceData* _data_;
#line 96 "../src/PulseAudioManager.vala"
	_data_ = _user_data_;
#line 96 "../src/PulseAudioManager.vala"
	_data_->_source_object_ = source_object;
#line 96 "../src/PulseAudioManager.vala"
	_data_->_res_ = _res_;
#line 96 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_device_co (_data_);
#line 787 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_device_co (SoundPulseAudioManagerSetDefaultDeviceData* _data_)
{
#line 76 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 76 "../src/PulseAudioManager.vala"
		case 0:
#line 797 "PulseAudioManager.c"
		goto _state_0;
#line 76 "../src/PulseAudioManager.vala"
		case 1:
#line 801 "PulseAudioManager.c"
		goto _state_1;
#line 76 "../src/PulseAudioManager.vala"
		case 2:
#line 805 "PulseAudioManager.c"
		goto _state_2;
#line 76 "../src/PulseAudioManager.vala"
		case 3:
#line 809 "PulseAudioManager.c"
		goto _state_3;
#line 76 "../src/PulseAudioManager.vala"
		case 4:
#line 813 "PulseAudioManager.c"
		goto _state_4;
#line 76 "../src/PulseAudioManager.vala"
		case 5:
#line 817 "PulseAudioManager.c"
		goto _state_5;
#line 76 "../src/PulseAudioManager.vala"
		case 6:
#line 821 "PulseAudioManager.c"
		goto _state_6;
#line 76 "../src/PulseAudioManager.vala"
		case 7:
#line 825 "PulseAudioManager.c"
		goto _state_7;
		default:
#line 76 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 830 "PulseAudioManager.c"
	}
	_state_0:
#line 77 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:77: \n");
#line 78 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->device);
#line 78 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 78 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:78: set_default_device: %s", _data_->_tmp1_);
#line 79 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = sound_device_get_input (_data_->device);
#line 79 "../src/PulseAudioManager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 79 "../src/PulseAudioManager.vala"
	if (_data_->_tmp4_) {
#line 79 "../src/PulseAudioManager.vala"
		_data_->_tmp2_ = "input";
#line 849 "PulseAudioManager.c"
	} else {
#line 79 "../src/PulseAudioManager.vala"
		_data_->_tmp2_ = "output";
#line 853 "PulseAudioManager.c"
	}
#line 79 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:79: \t%s", _data_->_tmp2_);
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp6_ = sound_device_get_input (_data_->device);
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 85 "../src/PulseAudioManager.vala"
	if (_data_->_tmp7_) {
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp8_ = _data_->self->priv->_default_output;
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp8_;
#line 867 "PulseAudioManager.c"
	} else {
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp9_ = _data_->self->priv->_default_input;
#line 85 "../src/PulseAudioManager.vala"
		_data_->_tmp5_ = _data_->_tmp9_;
#line 873 "PulseAudioManager.c"
	}
#line 85 "../src/PulseAudioManager.vala"
	_data_->_tmp10_ = _g_object_ref0 (_data_->_tmp5_);
#line 85 "../src/PulseAudioManager.vala"
	_data_->other_device = _data_->_tmp10_;
#line 87 "../src/PulseAudioManager.vala"
	_data_->_tmp11_ = _data_->other_device;
#line 87 "../src/PulseAudioManager.vala"
	_data_->_tmp12_ = sound_device_get_matching_profile (_data_->device, _data_->_tmp11_);
#line 87 "../src/PulseAudioManager.vala"
	_data_->profile_name = _data_->_tmp12_;
#line 89 "../src/PulseAudioManager.vala"
	_data_->_tmp13_ = _data_->profile_name;
#line 89 "../src/PulseAudioManager.vala"
	if (_data_->_tmp13_ == NULL) {
#line 90 "../src/PulseAudioManager.vala"
		_data_->_tmp14_ = sound_device_get_profiles (_data_->device);
#line 90 "../src/PulseAudioManager.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 90 "../src/PulseAudioManager.vala"
		_data_->_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp15_, 0);
#line 90 "../src/PulseAudioManager.vala"
		_g_free0 (_data_->profile_name);
#line 90 "../src/PulseAudioManager.vala"
		_data_->profile_name = (gchar*) _data_->_tmp16_;
#line 899 "PulseAudioManager.c"
	}
#line 93 "../src/PulseAudioManager.vala"
	_data_->_tmp17_ = _data_->profile_name;
#line 93 "../src/PulseAudioManager.vala"
	_data_->_tmp18_ = sound_device_get_card_active_profile_name (_data_->device);
#line 93 "../src/PulseAudioManager.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 93 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_data_->_tmp17_, _data_->_tmp19_) != 0) {
#line 94 "../src/PulseAudioManager.vala"
		_data_->_tmp20_ = sound_device_get_card_active_profile_name (_data_->device);
#line 94 "../src/PulseAudioManager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 94 "../src/PulseAudioManager.vala"
		_data_->_tmp22_ = _data_->profile_name;
#line 94 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:94: set card profile: %s > %s", _data_->_tmp21_, _data_->_tmp22_);
#line 96 "../src/PulseAudioManager.vala"
		_data_->_tmp23_ = sound_device_get_card_index (_data_->device);
#line 96 "../src/PulseAudioManager.vala"
		_data_->_tmp24_ = _data_->_tmp23_;
#line 96 "../src/PulseAudioManager.vala"
		_data_->_tmp25_ = _data_->profile_name;
#line 96 "../src/PulseAudioManager.vala"
		_data_->_state_ = 1;
#line 96 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index (_data_->self, _data_->_tmp24_, _data_->_tmp25_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 96 "../src/PulseAudioManager.vala"
		return FALSE;
#line 929 "PulseAudioManager.c"
		_state_1:
#line 96 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_finish (_data_->self, _data_->_res_);
#line 98 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:98: wait for card sink / source");
#line 99 "../src/PulseAudioManager.vala"
		_data_->_tmp27_ = sound_device_get_input (_data_->device);
#line 99 "../src/PulseAudioManager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 99 "../src/PulseAudioManager.vala"
		if (_data_->_tmp28_) {
#line 99 "../src/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-source-name";
#line 943 "PulseAudioManager.c"
		} else {
#line 99 "../src/PulseAudioManager.vala"
			_data_->_tmp26_ = "card-sink-name";
#line 947 "PulseAudioManager.c"
		}
#line 99 "../src/PulseAudioManager.vala"
		_data_->_state_ = 2;
#line 99 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp26_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 99 "../src/PulseAudioManager.vala"
		return FALSE;
#line 955 "PulseAudioManager.c"
		_state_2:
#line 99 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 959 "PulseAudioManager.c"
	}
#line 104 "../src/PulseAudioManager.vala"
	_data_->_tmp30_ = sound_device_get_input (_data_->device);
#line 104 "../src/PulseAudioManager.vala"
	_data_->_tmp31_ = _data_->_tmp30_;
#line 104 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp31_) {
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp32_ = sound_device_get_port_name (_data_->device);
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp34_ = sound_device_get_card_sink_port_name (_data_->device);
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp35_ = _data_->_tmp34_;
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp29_ = g_strcmp0 (_data_->_tmp33_, _data_->_tmp35_) != 0;
#line 977 "PulseAudioManager.c"
	} else {
#line 104 "../src/PulseAudioManager.vala"
		_data_->_tmp29_ = FALSE;
#line 981 "PulseAudioManager.c"
	}
#line 104 "../src/PulseAudioManager.vala"
	if (_data_->_tmp29_) {
#line 105 "../src/PulseAudioManager.vala"
		_data_->_tmp36_ = sound_device_get_card_sink_port_name (_data_->device);
#line 105 "../src/PulseAudioManager.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 105 "../src/PulseAudioManager.vala"
		_data_->_tmp38_ = sound_device_get_port_name (_data_->device);
#line 105 "../src/PulseAudioManager.vala"
		_data_->_tmp39_ = _data_->_tmp38_;
#line 105 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:105: set sink port: %s > %s", _data_->_tmp37_, _data_->_tmp39_);
#line 107 "../src/PulseAudioManager.vala"
		_data_->_tmp40_ = sound_device_get_card_sink_name (_data_->device);
#line 107 "../src/PulseAudioManager.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 107 "../src/PulseAudioManager.vala"
		_data_->_tmp42_ = sound_device_get_port_name (_data_->device);
#line 107 "../src/PulseAudioManager.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 107 "../src/PulseAudioManager.vala"
		_data_->_state_ = 3;
#line 107 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name (_data_->self, _data_->_tmp41_, _data_->_tmp43_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 107 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1009 "PulseAudioManager.c"
		_state_3:
#line 107 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_finish (_data_->self, _data_->_res_);
#line 1013 "PulseAudioManager.c"
	}
#line 110 "../src/PulseAudioManager.vala"
	_data_->_tmp45_ = sound_device_get_input (_data_->device);
#line 110 "../src/PulseAudioManager.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 110 "../src/PulseAudioManager.vala"
	if (_data_->_tmp46_) {
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp47_ = sound_device_get_port_name (_data_->device);
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp49_ = sound_device_get_card_source_port_name (_data_->device);
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp44_ = g_strcmp0 (_data_->_tmp48_, _data_->_tmp50_) != 0;
#line 1031 "PulseAudioManager.c"
	} else {
#line 110 "../src/PulseAudioManager.vala"
		_data_->_tmp44_ = FALSE;
#line 1035 "PulseAudioManager.c"
	}
#line 110 "../src/PulseAudioManager.vala"
	if (_data_->_tmp44_) {
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp51_ = sound_device_get_card_source_port_name (_data_->device);
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp52_ = _data_->_tmp51_;
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp53_ = sound_device_get_port_name (_data_->device);
#line 111 "../src/PulseAudioManager.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 111 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:111: set source port: %s > %s", _data_->_tmp52_, _data_->_tmp54_);
#line 112 "../src/PulseAudioManager.vala"
		_data_->_tmp55_ = sound_device_get_card_source_name (_data_->device);
#line 112 "../src/PulseAudioManager.vala"
		_data_->_tmp56_ = _data_->_tmp55_;
#line 112 "../src/PulseAudioManager.vala"
		_data_->_tmp57_ = sound_device_get_port_name (_data_->device);
#line 112 "../src/PulseAudioManager.vala"
		_data_->_tmp58_ = _data_->_tmp57_;
#line 112 "../src/PulseAudioManager.vala"
		_data_->_state_ = 4;
#line 112 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name (_data_->self, _data_->_tmp56_, _data_->_tmp58_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 112 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1063 "PulseAudioManager.c"
		_state_4:
#line 112 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_finish (_data_->self, _data_->_res_);
#line 1067 "PulseAudioManager.c"
	}
#line 116 "../src/PulseAudioManager.vala"
	_data_->_tmp61_ = sound_device_get_input (_data_->device);
#line 116 "../src/PulseAudioManager.vala"
	_data_->_tmp62_ = _data_->_tmp61_;
#line 116 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp62_) {
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp63_ = sound_device_get_sink_name (_data_->device);
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp60_ = _data_->_tmp64_ == NULL;
#line 1081 "PulseAudioManager.c"
	} else {
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp60_ = FALSE;
#line 1085 "PulseAudioManager.c"
	}
#line 116 "../src/PulseAudioManager.vala"
	if (_data_->_tmp60_) {
#line 116 "../src/PulseAudioManager.vala"
		_data_->_tmp59_ = TRUE;
#line 1091 "PulseAudioManager.c"
	} else {
#line 117 "../src/PulseAudioManager.vala"
		_data_->_tmp66_ = sound_device_get_input (_data_->device);
#line 117 "../src/PulseAudioManager.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 117 "../src/PulseAudioManager.vala"
		if (_data_->_tmp67_) {
#line 117 "../src/PulseAudioManager.vala"
			_data_->_tmp68_ = sound_device_get_source_name (_data_->device);
#line 117 "../src/PulseAudioManager.vala"
			_data_->_tmp69_ = _data_->_tmp68_;
#line 117 "../src/PulseAudioManager.vala"
			_data_->_tmp65_ = _data_->_tmp69_ == NULL;
#line 1105 "PulseAudioManager.c"
		} else {
#line 117 "../src/PulseAudioManager.vala"
			_data_->_tmp65_ = FALSE;
#line 1109 "PulseAudioManager.c"
		}
#line 117 "../src/PulseAudioManager.vala"
		_data_->_tmp59_ = _data_->_tmp65_;
#line 1113 "PulseAudioManager.c"
	}
#line 116 "../src/PulseAudioManager.vala"
	if (_data_->_tmp59_) {
#line 118 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:118: wait for sink / source");
#line 119 "../src/PulseAudioManager.vala"
		_data_->_tmp71_ = sound_device_get_input (_data_->device);
#line 119 "../src/PulseAudioManager.vala"
		_data_->_tmp72_ = _data_->_tmp71_;
#line 119 "../src/PulseAudioManager.vala"
		if (_data_->_tmp72_) {
#line 119 "../src/PulseAudioManager.vala"
			_data_->_tmp70_ = "source-name";
#line 1127 "PulseAudioManager.c"
		} else {
#line 119 "../src/PulseAudioManager.vala"
			_data_->_tmp70_ = "sink-name";
#line 1131 "PulseAudioManager.c"
		}
#line 119 "../src/PulseAudioManager.vala"
		_data_->_state_ = 5;
#line 119 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update (_data_->self, _data_->device, _data_->_tmp70_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 119 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1139 "PulseAudioManager.c"
		_state_5:
#line 119 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_finish (_data_->self, _data_->_res_);
#line 1143 "PulseAudioManager.c"
	}
#line 124 "../src/PulseAudioManager.vala"
	_data_->_tmp74_ = sound_device_get_input (_data_->device);
#line 124 "../src/PulseAudioManager.vala"
	_data_->_tmp75_ = _data_->_tmp74_;
#line 124 "../src/PulseAudioManager.vala"
	if (!_data_->_tmp75_) {
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp76_ = sound_device_get_sink_name (_data_->device);
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp77_ = _data_->_tmp76_;
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp78_ = _data_->self->priv->default_sink_name;
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp73_ = g_strcmp0 (_data_->_tmp77_, _data_->_tmp78_) != 0;
#line 1159 "PulseAudioManager.c"
	} else {
#line 124 "../src/PulseAudioManager.vala"
		_data_->_tmp73_ = FALSE;
#line 1163 "PulseAudioManager.c"
	}
#line 124 "../src/PulseAudioManager.vala"
	if (_data_->_tmp73_) {
#line 125 "../src/PulseAudioManager.vala"
		_data_->_tmp79_ = _data_->self->priv->default_sink_name;
#line 125 "../src/PulseAudioManager.vala"
		_data_->_tmp80_ = sound_device_get_sink_name (_data_->device);
#line 125 "../src/PulseAudioManager.vala"
		_data_->_tmp81_ = _data_->_tmp80_;
#line 125 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:125: set sink: %s > %s", _data_->_tmp79_, _data_->_tmp81_);
#line 126 "../src/PulseAudioManager.vala"
		_data_->_tmp82_ = sound_device_get_sink_name (_data_->device);
#line 126 "../src/PulseAudioManager.vala"
		_data_->_tmp83_ = _data_->_tmp82_;
#line 126 "../src/PulseAudioManager.vala"
		_data_->_state_ = 6;
#line 126 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink (_data_->self, _data_->_tmp83_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 126 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1185 "PulseAudioManager.c"
		_state_6:
#line 126 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_finish (_data_->self, _data_->_res_);
#line 1189 "PulseAudioManager.c"
	}
#line 129 "../src/PulseAudioManager.vala"
	_data_->_tmp85_ = sound_device_get_input (_data_->device);
#line 129 "../src/PulseAudioManager.vala"
	_data_->_tmp86_ = _data_->_tmp85_;
#line 129 "../src/PulseAudioManager.vala"
	if (_data_->_tmp86_) {
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp87_ = sound_device_get_source_name (_data_->device);
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp88_ = _data_->_tmp87_;
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp89_ = _data_->self->priv->default_source_name;
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp84_ = g_strcmp0 (_data_->_tmp88_, _data_->_tmp89_) != 0;
#line 1205 "PulseAudioManager.c"
	} else {
#line 129 "../src/PulseAudioManager.vala"
		_data_->_tmp84_ = FALSE;
#line 1209 "PulseAudioManager.c"
	}
#line 129 "../src/PulseAudioManager.vala"
	if (_data_->_tmp84_) {
#line 130 "../src/PulseAudioManager.vala"
		_data_->_tmp90_ = _data_->self->priv->default_source_name;
#line 130 "../src/PulseAudioManager.vala"
		_data_->_tmp91_ = sound_device_get_source_name (_data_->device);
#line 130 "../src/PulseAudioManager.vala"
		_data_->_tmp92_ = _data_->_tmp91_;
#line 130 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:130: set source: %s > %s", _data_->_tmp90_, _data_->_tmp92_);
#line 131 "../src/PulseAudioManager.vala"
		_data_->_tmp93_ = sound_device_get_source_name (_data_->device);
#line 131 "../src/PulseAudioManager.vala"
		_data_->_tmp94_ = _data_->_tmp93_;
#line 131 "../src/PulseAudioManager.vala"
		_data_->_state_ = 7;
#line 131 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source (_data_->self, _data_->_tmp94_, sound_pulse_audio_manager_set_default_device_ready, _data_);
#line 131 "../src/PulseAudioManager.vala"
		return FALSE;
#line 1231 "PulseAudioManager.c"
		_state_7:
#line 131 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_finish (_data_->self, _data_->_res_);
#line 1235 "PulseAudioManager.c"
	}
#line 76 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 76 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->other_device);
#line 76 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 76 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 76 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 76 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1249 "PulseAudioManager.c"
		}
	}
#line 76 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 76 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1256 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetCardProfileByIndexData, _data_);
#line 1268 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index (SoundPulseAudioManager* self,
                                                     guint32 card_index,
                                                     const gchar* profile_name,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (profile_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetCardProfileByIndexData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_card_profile_by_index_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_data_->card_index = card_index;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (profile_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->profile_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->profile_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_card_profile_by_index_co (_data_);
#line 1305 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_card_profile_by_index_finish (SoundPulseAudioManager* self,
                                                            GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetCardProfileByIndexData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1315 "PulseAudioManager.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 135 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 135 "../src/PulseAudioManager.vala"
	return _data1_;
#line 1325 "PulseAudioManager.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 135 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1335 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 135 "../src/PulseAudioManager.vala"
		self = _data1_->self;
#line 135 "../src/PulseAudioManager.vala"
		_g_free0 (_data1_->profile_name);
#line 135 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 135 "../src/PulseAudioManager.vala"
		g_slice_free (Block1Data, _data1_);
#line 1345 "PulseAudioManager.c"
	}
}

static void
__lambda9_ (Block1Data* _data1_,
            pa_context* c,
            gint success)
{
	SoundPulseAudioManager* self;
#line 136 "../src/PulseAudioManager.vala"
	self = _data1_->self;
#line 136 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 137 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 138 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_card_profile_by_index_co (_data1_->_async_data_);
#line 1363 "PulseAudioManager.c"
	} else {
#line 140 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:140: setting card %u profile to %s failed", (guint) _data1_->card_index, _data1_->profile_name);
#line 1367 "PulseAudioManager.c"
	}
}

static void
___lambda9__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
#line 136 "../src/PulseAudioManager.vala"
	__lambda9_ (self, c, success);
#line 1378 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_card_profile_by_index_co (SoundPulseAudioManagerSetCardProfileByIndexData* _data_)
{
#line 135 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 135 "../src/PulseAudioManager.vala"
		case 0:
#line 1388 "PulseAudioManager.c"
		goto _state_0;
#line 135 "../src/PulseAudioManager.vala"
		case 1:
#line 1392 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 135 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1397 "PulseAudioManager.c"
	}
	_state_0:
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_->card_index = _data_->card_index;
#line 135 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data1_->profile_name);
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_->profile_name = _data_->profile_name;
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 136 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 136 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_card_profile_by_index (_data_->_tmp0_, _data_->_data1_->card_index, _data_->_data1_->profile_name, ___lambda9__pa_context_success_cb_t, _data_->_data1_);
#line 136 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 136 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 144 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 144 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1426 "PulseAudioManager.c"
	_state_1:
	;
#line 135 "../src/PulseAudioManager.vala"
	block1_data_unref (_data_->_data1_);
#line 135 "../src/PulseAudioManager.vala"
	_data_->_data1_ = NULL;
#line 135 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 135 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 135 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 135 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1441 "PulseAudioManager.c"
		}
	}
#line 135 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 135 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1448 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_data_free (gpointer _data)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerWaitForUpdateData, _data_);
#line 1460 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update (SoundPulseAudioManager* self,
                                           SoundDevice* device,
                                           const gchar* prop_name,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
	SoundPulseAudioManager* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (device != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (prop_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerWaitForUpdateData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_wait_for_update_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->device);
#line 29 "../src/PulseAudioManager.vala"
	_data_->device = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (prop_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->prop_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->prop_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_wait_for_update_co (_data_);
#line 1504 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_wait_for_update_finish (SoundPulseAudioManager* self,
                                                  GAsyncResult* _res_)
{
	SoundPulseAudioManagerWaitForUpdateData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1514 "PulseAudioManager.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 148 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 148 "../src/PulseAudioManager.vala"
	return _data2_;
#line 1524 "PulseAudioManager.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 148 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1534 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 148 "../src/PulseAudioManager.vala"
		self = _data2_->self;
#line 148 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data2_->device);
#line 148 "../src/PulseAudioManager.vala"
		_g_free0 (_data2_->prop_name);
#line 148 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 148 "../src/PulseAudioManager.vala"
		g_slice_free (Block2Data, _data2_);
#line 1546 "PulseAudioManager.c"
	}
}

static void
__lambda10_ (Block2Data* _data2_,
             GObject* s,
             GParamSpec* p)
{
	SoundPulseAudioManager* self;
	gchar* prop_value = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
#line 151 "../src/PulseAudioManager.vala"
	self = _data2_->self;
#line 151 "../src/PulseAudioManager.vala"
	g_return_if_fail (s != NULL);
#line 151 "../src/PulseAudioManager.vala"
	g_return_if_fail (p != NULL);
#line 153 "../src/PulseAudioManager.vala"
	g_object_get ((GObject*) _data2_->device, _data2_->prop_name, &_tmp0_, NULL);
#line 153 "../src/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 153 "../src/PulseAudioManager.vala"
	prop_value = _tmp0_;
#line 154 "../src/PulseAudioManager.vala"
	_tmp1_ = prop_value;
#line 154 "../src/PulseAudioManager.vala"
	if (_tmp1_ != NULL) {
#line 155 "../src/PulseAudioManager.vala"
		g_signal_handler_disconnect ((GObject*) _data2_->device, _data2_->handler_id);
#line 156 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_wait_for_update_co (_data2_->_async_data_);
#line 1579 "PulseAudioManager.c"
	}
#line 151 "../src/PulseAudioManager.vala"
	_g_free0 (prop_value);
#line 1583 "PulseAudioManager.c"
}

static void
___lambda10__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 151 "../src/PulseAudioManager.vala"
	__lambda10_ (self, _sender, pspec);
#line 1593 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_wait_for_update_co (SoundPulseAudioManagerWaitForUpdateData* _data_)
{
#line 148 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 148 "../src/PulseAudioManager.vala"
		case 0:
#line 1603 "PulseAudioManager.c"
		goto _state_0;
#line 148 "../src/PulseAudioManager.vala"
		case 1:
#line 1607 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 148 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1612 "PulseAudioManager.c"
	}
	_state_0:
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 148 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->_data2_->device);
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_->device = _data_->device;
#line 148 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data2_->prop_name);
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_->prop_name = _data_->prop_name;
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 149 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = sound_device_get_id (_data_->_data2_->device);
#line 149 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 149 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:149: wait_for_update: %s:%s", _data_->_tmp1_, _data_->_data2_->prop_name);
#line 150 "../src/PulseAudioManager.vala"
	_data_->_data2_->handler_id = (gulong) 0;
#line 151 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = g_strconcat ("notify::", _data_->_data2_->prop_name, NULL);
#line 151 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = g_signal_connect_data ((GObject*) _data_->_data2_->device, _data_->_tmp2_, (GCallback) ___lambda10__g_object_notify, block2_data_ref (_data_->_data2_), (GClosureNotify) block2_data_unref, 0);
#line 151 "../src/PulseAudioManager.vala"
	_data_->_data2_->handler_id = _data_->_tmp3_;
#line 151 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_tmp2_);
#line 160 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 160 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1651 "PulseAudioManager.c"
	_state_1:
	;
#line 148 "../src/PulseAudioManager.vala"
	block2_data_unref (_data_->_data2_);
#line 148 "../src/PulseAudioManager.vala"
	_data_->_data2_ = NULL;
#line 148 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 148 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 148 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 148 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1666 "PulseAudioManager.c"
		}
	}
#line 148 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 148 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1673 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSinkPortByNameData, _data_);
#line 1685 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name (SoundPulseAudioManager* self,
                                                 const gchar* sink_name,
                                                 const gchar* port_name,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (sink_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (port_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSinkPortByNameData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_sink_port_by_name_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_sink_port_by_name_co (_data_);
#line 1729 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_sink_port_by_name_finish (SoundPulseAudioManager* self,
                                                        GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSinkPortByNameData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1739 "PulseAudioManager.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 163 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 163 "../src/PulseAudioManager.vala"
	return _data3_;
#line 1749 "PulseAudioManager.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 163 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1759 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 163 "../src/PulseAudioManager.vala"
		self = _data3_->self;
#line 163 "../src/PulseAudioManager.vala"
		_g_free0 (_data3_->sink_name);
#line 163 "../src/PulseAudioManager.vala"
		_g_free0 (_data3_->port_name);
#line 163 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 163 "../src/PulseAudioManager.vala"
		g_slice_free (Block3Data, _data3_);
#line 1771 "PulseAudioManager.c"
	}
}

static void
__lambda11_ (Block3Data* _data3_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 164 "../src/PulseAudioManager.vala"
	self = _data3_->self;
#line 164 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 165 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 166 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_sink_port_by_name_co (_data3_->_async_data_);
#line 1789 "PulseAudioManager.c"
	} else {
#line 168 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:168: setting sink %s port to %s failed", _data3_->sink_name, _data3_->port_name);
#line 1793 "PulseAudioManager.c"
	}
}

static void
___lambda11__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 164 "../src/PulseAudioManager.vala"
	__lambda11_ (self, c, success);
#line 1804 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_sink_port_by_name_co (SoundPulseAudioManagerSetSinkPortByNameData* _data_)
{
#line 163 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 163 "../src/PulseAudioManager.vala"
		case 0:
#line 1814 "PulseAudioManager.c"
		goto _state_0;
#line 163 "../src/PulseAudioManager.vala"
		case 1:
#line 1818 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 163 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 1823 "PulseAudioManager.c"
	}
	_state_0:
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_ = g_slice_new0 (Block3Data);
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_->_ref_count_ = 1;
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_->self = g_object_ref (_data_->self);
#line 163 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data3_->sink_name);
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_->sink_name = _data_->sink_name;
#line 163 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data3_->port_name);
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_->port_name = _data_->port_name;
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_->_async_data_ = _data_;
#line 164 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 164 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_sink_port_by_name (_data_->_tmp0_, _data_->_data3_->sink_name, _data_->_data3_->port_name, ___lambda11__pa_context_success_cb_t, _data_->_data3_);
#line 164 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 164 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 172 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 172 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1854 "PulseAudioManager.c"
	_state_1:
	;
#line 163 "../src/PulseAudioManager.vala"
	block3_data_unref (_data_->_data3_);
#line 163 "../src/PulseAudioManager.vala"
	_data_->_data3_ = NULL;
#line 163 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 163 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 163 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 163 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1869 "PulseAudioManager.c"
		}
	}
#line 163 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 163 "../src/PulseAudioManager.vala"
	return FALSE;
#line 1876 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetSourcePortByNameData, _data_);
#line 1888 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name (SoundPulseAudioManager* self,
                                                   const gchar* source_name,
                                                   const gchar* port_name,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (source_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (port_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetSourcePortByNameData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_source_port_by_name_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp2_ = g_strdup (port_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->port_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->port_name = _tmp2_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_source_port_by_name_co (_data_);
#line 1932 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_source_port_by_name_finish (SoundPulseAudioManager* self,
                                                          GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetSourcePortByNameData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1942 "PulseAudioManager.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 175 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 175 "../src/PulseAudioManager.vala"
	return _data4_;
#line 1952 "PulseAudioManager.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 175 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1962 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 175 "../src/PulseAudioManager.vala"
		self = _data4_->self;
#line 175 "../src/PulseAudioManager.vala"
		_g_free0 (_data4_->source_name);
#line 175 "../src/PulseAudioManager.vala"
		_g_free0 (_data4_->port_name);
#line 175 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 175 "../src/PulseAudioManager.vala"
		g_slice_free (Block4Data, _data4_);
#line 1974 "PulseAudioManager.c"
	}
}

static void
__lambda12_ (Block4Data* _data4_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 176 "../src/PulseAudioManager.vala"
	self = _data4_->self;
#line 176 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 177 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 178 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_source_port_by_name_co (_data4_->_async_data_);
#line 1992 "PulseAudioManager.c"
	} else {
#line 180 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:180: setting source %s port to %s failed", _data4_->source_name, _data4_->port_name);
#line 1996 "PulseAudioManager.c"
	}
}

static void
___lambda12__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 176 "../src/PulseAudioManager.vala"
	__lambda12_ (self, c, success);
#line 2007 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_source_port_by_name_co (SoundPulseAudioManagerSetSourcePortByNameData* _data_)
{
#line 175 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 175 "../src/PulseAudioManager.vala"
		case 0:
#line 2017 "PulseAudioManager.c"
		goto _state_0;
#line 175 "../src/PulseAudioManager.vala"
		case 1:
#line 2021 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 175 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2026 "PulseAudioManager.c"
	}
	_state_0:
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_ = g_slice_new0 (Block4Data);
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_->_ref_count_ = 1;
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_->self = g_object_ref (_data_->self);
#line 175 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data4_->source_name);
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_->source_name = _data_->source_name;
#line 175 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data4_->port_name);
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_->port_name = _data_->port_name;
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_->_async_data_ = _data_;
#line 176 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 176 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_source_port_by_name (_data_->_tmp0_, _data_->_data4_->source_name, _data_->_data4_->port_name, ___lambda12__pa_context_success_cb_t, _data_->_data4_);
#line 176 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 176 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 184 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 184 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2057 "PulseAudioManager.c"
	_state_1:
	;
#line 175 "../src/PulseAudioManager.vala"
	block4_data_unref (_data_->_data4_);
#line 175 "../src/PulseAudioManager.vala"
	_data_->_data4_ = NULL;
#line 175 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 175 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 175 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 175 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2072 "PulseAudioManager.c"
		}
	}
#line 175 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 175 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2079 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSinkData, _data_);
#line 2091 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink (SoundPulseAudioManager* self,
                                            const gchar* sink_name,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (sink_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSinkData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_sink_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->sink_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->sink_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_sink_co (_data_);
#line 2125 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_sink_finish (SoundPulseAudioManager* self,
                                                   GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSinkData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2135 "PulseAudioManager.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 187 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 187 "../src/PulseAudioManager.vala"
	return _data5_;
#line 2145 "PulseAudioManager.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 187 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2155 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 187 "../src/PulseAudioManager.vala"
		self = _data5_->self;
#line 187 "../src/PulseAudioManager.vala"
		_g_free0 (_data5_->sink_name);
#line 187 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 187 "../src/PulseAudioManager.vala"
		g_slice_free (Block5Data, _data5_);
#line 2165 "PulseAudioManager.c"
	}
}

static void
__lambda13_ (Block5Data* _data5_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 188 "../src/PulseAudioManager.vala"
	self = _data5_->self;
#line 188 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 189 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 190 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_sink_co (_data5_->_async_data_);
#line 2183 "PulseAudioManager.c"
	} else {
#line 192 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:192: setting default sink to %s failed", _data5_->sink_name);
#line 2187 "PulseAudioManager.c"
	}
}

static void
___lambda13__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 188 "../src/PulseAudioManager.vala"
	__lambda13_ (self, c, success);
#line 2198 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_sink_co (SoundPulseAudioManagerSetDefaultSinkData* _data_)
{
#line 187 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 187 "../src/PulseAudioManager.vala"
		case 0:
#line 2208 "PulseAudioManager.c"
		goto _state_0;
#line 187 "../src/PulseAudioManager.vala"
		case 1:
#line 2212 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 187 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2217 "PulseAudioManager.c"
	}
	_state_0:
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 187 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data5_->sink_name);
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_->sink_name = _data_->sink_name;
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 188 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 188 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_sink (_data_->_tmp0_, _data_->_data5_->sink_name, ___lambda13__pa_context_success_cb_t, _data_->_data5_);
#line 188 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 188 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 196 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 196 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2244 "PulseAudioManager.c"
	_state_1:
	;
#line 187 "../src/PulseAudioManager.vala"
	block5_data_unref (_data_->_data5_);
#line 187 "../src/PulseAudioManager.vala"
	_data_->_data5_ = NULL;
#line 187 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 187 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 187 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 187 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2259 "PulseAudioManager.c"
		}
	}
#line 187 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 187 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2266 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_data_free (gpointer _data)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerSetDefaultSourceData, _data_);
#line 2278 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source (SoundPulseAudioManager* self,
                                              const gchar* source_name,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
	SoundPulseAudioManager* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (source_name != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerSetDefaultSourceData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_set_default_source_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	_tmp1_ = g_strdup (source_name);
#line 29 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->source_name);
#line 29 "../src/PulseAudioManager.vala"
	_data_->source_name = _tmp1_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_default_source_co (_data_);
#line 2312 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_source_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerSetDefaultSourceData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2322 "PulseAudioManager.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 199 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 199 "../src/PulseAudioManager.vala"
	return _data6_;
#line 2332 "PulseAudioManager.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 199 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2342 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 199 "../src/PulseAudioManager.vala"
		self = _data6_->self;
#line 199 "../src/PulseAudioManager.vala"
		_g_free0 (_data6_->source_name);
#line 199 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 199 "../src/PulseAudioManager.vala"
		g_slice_free (Block6Data, _data6_);
#line 2352 "PulseAudioManager.c"
	}
}

static void
__lambda14_ (Block6Data* _data6_,
             pa_context* c,
             gint success)
{
	SoundPulseAudioManager* self;
#line 200 "../src/PulseAudioManager.vala"
	self = _data6_->self;
#line 200 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 201 "../src/PulseAudioManager.vala"
	if (success == 1) {
#line 202 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_source_co (_data6_->_async_data_);
#line 2370 "PulseAudioManager.c"
	} else {
#line 204 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:204: setting default source to %s failed", _data6_->source_name);
#line 2374 "PulseAudioManager.c"
	}
}

static void
___lambda14__pa_context_success_cb_t (pa_context* c,
                                      gint success,
                                      gpointer self)
{
#line 200 "../src/PulseAudioManager.vala"
	__lambda14_ (self, c, success);
#line 2385 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_set_default_source_co (SoundPulseAudioManagerSetDefaultSourceData* _data_)
{
#line 199 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 199 "../src/PulseAudioManager.vala"
		case 0:
#line 2395 "PulseAudioManager.c"
		goto _state_0;
#line 199 "../src/PulseAudioManager.vala"
		case 1:
#line 2399 "PulseAudioManager.c"
		goto _state_1;
		default:
#line 199 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2404 "PulseAudioManager.c"
	}
	_state_0:
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_->self = g_object_ref (_data_->self);
#line 199 "../src/PulseAudioManager.vala"
	_g_free0 (_data_->_data6_->source_name);
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_->source_name = _data_->source_name;
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 200 "../src/PulseAudioManager.vala"
	_data_->_tmp0_ = _data_->self->priv->_context;
#line 200 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_context_set_default_source (_data_->_tmp0_, _data_->_data6_->source_name, ___lambda14__pa_context_success_cb_t, _data_->_data6_);
#line 200 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 200 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_data_->_tmp2_);
#line 208 "../src/PulseAudioManager.vala"
	_data_->_state_ = 1;
#line 208 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2431 "PulseAudioManager.c"
	_state_1:
	;
#line 199 "../src/PulseAudioManager.vala"
	block6_data_unref (_data_->_data6_);
#line 199 "../src/PulseAudioManager.vala"
	_data_->_data6_ = NULL;
#line 199 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 199 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 199 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 199 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2446 "PulseAudioManager.c"
		}
	}
#line 199 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 199 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2453 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_mute (SoundPulseAudioManager* self,
                                              SoundDevice* device,
                                              gboolean mute)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 211 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/PulseAudioManager.vala"
	if (device == NULL) {
#line 212 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 2470 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
#line 212 "../src/PulseAudioManager.vala"
		_tmp1_ = sound_device_get_source_name (device);
#line 212 "../src/PulseAudioManager.vala"
		_tmp2_ = _tmp1_;
#line 212 "../src/PulseAudioManager.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 2480 "PulseAudioManager.c"
	}
#line 212 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 213 "../src/PulseAudioManager.vala"
		return;
#line 2486 "PulseAudioManager.c"
	}
#line 216 "../src/PulseAudioManager.vala"
	_tmp3_ = sound_device_get_input (device);
#line 216 "../src/PulseAudioManager.vala"
	_tmp4_ = _tmp3_;
#line 216 "../src/PulseAudioManager.vala"
	if (_tmp4_) {
#line 2494 "PulseAudioManager.c"
		pa_context* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		pa_operation* _tmp8_;
		pa_operation* _tmp9_;
#line 217 "../src/PulseAudioManager.vala"
		_tmp5_ = self->priv->_context;
#line 217 "../src/PulseAudioManager.vala"
		_tmp6_ = sound_device_get_source_name (device);
#line 217 "../src/PulseAudioManager.vala"
		_tmp7_ = _tmp6_;
#line 217 "../src/PulseAudioManager.vala"
		_tmp8_ = pa_context_set_source_mute_by_name (_tmp5_, _tmp7_, mute, NULL, NULL);
#line 217 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_;
#line 217 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp9_);
#line 2512 "PulseAudioManager.c"
	} else {
		pa_context* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		pa_operation* _tmp13_;
		pa_operation* _tmp14_;
#line 219 "../src/PulseAudioManager.vala"
		_tmp10_ = self->priv->_context;
#line 219 "../src/PulseAudioManager.vala"
		_tmp11_ = sound_device_get_sink_name (device);
#line 219 "../src/PulseAudioManager.vala"
		_tmp12_ = _tmp11_;
#line 219 "../src/PulseAudioManager.vala"
		_tmp13_ = pa_context_set_sink_mute_by_name (_tmp10_, _tmp12_, mute, NULL, NULL);
#line 219 "../src/PulseAudioManager.vala"
		_tmp14_ = _tmp13_;
#line 219 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp14_);
#line 2531 "PulseAudioManager.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 223 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 223 "../src/PulseAudioManager.vala"
	return _data7_;
#line 2542 "PulseAudioManager.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 223 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 2552 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 223 "../src/PulseAudioManager.vala"
		self = _data7_->self;
#line 223 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data7_->device);
#line 223 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 223 "../src/PulseAudioManager.vala"
		g_slice_free (Block7Data, _data7_);
#line 2562 "PulseAudioManager.c"
	}
}

static gboolean
__lambda15_ (Block7Data* _data7_,
             pa_operation* operation)
{
	SoundPulseAudioManager* self;
	GeeLinkedList* _tmp0_;
	gboolean result;
#line 228 "../src/PulseAudioManager.vala"
	self = _data7_->self;
#line 228 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 229 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) == PA_OPERATION_RUNNING) {
#line 230 "../src/PulseAudioManager.vala"
		pa_operation_cancel (operation);
#line 2581 "PulseAudioManager.c"
	}
#line 233 "../src/PulseAudioManager.vala"
	_tmp0_ = _data7_->device->volume_operations;
#line 233 "../src/PulseAudioManager.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, operation);
#line 234 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 234 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 234 "../src/PulseAudioManager.vala"
	return result;
#line 2593 "PulseAudioManager.c"
}

static gboolean
___lambda15__gee_forall_func (gpointer g,
                              gpointer self)
{
	gboolean result;
	result = __lambda15_ (self, (pa_operation*) g);
#line 228 "../src/PulseAudioManager.vala"
	return result;
#line 2604 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_volume (SoundPulseAudioManager* self,
                                                SoundDevice* device,
                                                gdouble volume)
{
	Block7Data* _data7_;
	SoundDevice* _tmp0_;
	GeeLinkedList* _tmp1_;
	pa_cvolume cvol = {0};
	pa_cvolume _tmp2_;
	pa_operation* operation = NULL;
	gboolean _tmp3_;
	gboolean _tmp4_;
	pa_operation* _tmp15_;
#line 223 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 223 "../src/PulseAudioManager.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 223 "../src/PulseAudioManager.vala"
	_data7_->_ref_count_ = 1;
#line 223 "../src/PulseAudioManager.vala"
	_data7_->self = g_object_ref (self);
#line 223 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (device);
#line 223 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data7_->device);
#line 223 "../src/PulseAudioManager.vala"
	_data7_->device = _tmp0_;
#line 224 "../src/PulseAudioManager.vala"
	if (_data7_->device == NULL) {
#line 225 "../src/PulseAudioManager.vala"
		block7_data_unref (_data7_);
#line 225 "../src/PulseAudioManager.vala"
		_data7_ = NULL;
#line 225 "../src/PulseAudioManager.vala"
		return;
#line 2643 "PulseAudioManager.c"
	}
#line 228 "../src/PulseAudioManager.vala"
	_tmp1_ = _data7_->device->volume_operations;
#line 228 "../src/PulseAudioManager.vala"
	gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp1_, ___lambda15__gee_forall_func, _data7_);
#line 237 "../src/PulseAudioManager.vala"
	_tmp2_ = _data7_->device->cvolume;
#line 237 "../src/PulseAudioManager.vala"
	cvol = _tmp2_;
#line 238 "../src/PulseAudioManager.vala"
	pa_cvolume_scale (&cvol, sound_pulse_audio_manager_double_to_volume (volume));
#line 239 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 240 "../src/PulseAudioManager.vala"
	_tmp3_ = sound_device_get_input (_data7_->device);
#line 240 "../src/PulseAudioManager.vala"
	_tmp4_ = _tmp3_;
#line 240 "../src/PulseAudioManager.vala"
	if (_tmp4_) {
#line 2663 "PulseAudioManager.c"
		pa_context* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		pa_cvolume _tmp8_;
		pa_operation* _tmp9_;
#line 241 "../src/PulseAudioManager.vala"
		_tmp5_ = self->priv->_context;
#line 241 "../src/PulseAudioManager.vala"
		_tmp6_ = sound_device_get_source_name (_data7_->device);
#line 241 "../src/PulseAudioManager.vala"
		_tmp7_ = _tmp6_;
#line 241 "../src/PulseAudioManager.vala"
		_tmp8_ = cvol;
#line 241 "../src/PulseAudioManager.vala"
		_tmp9_ = pa_context_set_source_volume_by_name (_tmp5_, _tmp7_, &_tmp8_, NULL, NULL);
#line 241 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 241 "../src/PulseAudioManager.vala"
		operation = _tmp9_;
#line 2683 "PulseAudioManager.c"
	} else {
		pa_context* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		pa_cvolume _tmp13_;
		pa_operation* _tmp14_;
#line 243 "../src/PulseAudioManager.vala"
		_tmp10_ = self->priv->_context;
#line 243 "../src/PulseAudioManager.vala"
		_tmp11_ = sound_device_get_sink_name (_data7_->device);
#line 243 "../src/PulseAudioManager.vala"
		_tmp12_ = _tmp11_;
#line 243 "../src/PulseAudioManager.vala"
		_tmp13_ = cvol;
#line 243 "../src/PulseAudioManager.vala"
		_tmp14_ = pa_context_set_sink_volume_by_name (_tmp10_, _tmp12_, &_tmp13_, NULL, NULL);
#line 243 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 243 "../src/PulseAudioManager.vala"
		operation = _tmp14_;
#line 2704 "PulseAudioManager.c"
	}
#line 246 "../src/PulseAudioManager.vala"
	_tmp15_ = operation;
#line 246 "../src/PulseAudioManager.vala"
	if (_tmp15_ != NULL) {
#line 2710 "PulseAudioManager.c"
		GeeLinkedList* _tmp16_;
		pa_operation* _tmp17_;
#line 247 "../src/PulseAudioManager.vala"
		_tmp16_ = _data7_->device->volume_operations;
#line 247 "../src/PulseAudioManager.vala"
		_tmp17_ = operation;
#line 247 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 2719 "PulseAudioManager.c"
	}
#line 223 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 223 "../src/PulseAudioManager.vala"
	block7_data_unref (_data7_);
#line 223 "../src/PulseAudioManager.vala"
	_data7_ = NULL;
#line 2727 "PulseAudioManager.c"
}

void
sound_pulse_audio_manager_change_device_balance (SoundPulseAudioManager* self,
                                                 SoundDevice* device,
                                                 gfloat balance)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_;
	pa_channel_map _tmp1_;
	pa_operation* operation = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	pa_operation* _tmp14_;
#line 251 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/PulseAudioManager.vala"
	if (device == NULL) {
#line 253 "../src/PulseAudioManager.vala"
		return;
#line 2748 "PulseAudioManager.c"
	}
#line 256 "../src/PulseAudioManager.vala"
	_tmp0_ = device->cvolume;
#line 256 "../src/PulseAudioManager.vala"
	cvol = _tmp0_;
#line 257 "../src/PulseAudioManager.vala"
	_tmp1_ = device->channel_map;
#line 257 "../src/PulseAudioManager.vala"
	cvol = *pa_cvolume_set_balance (&cvol, &_tmp1_, balance);
#line 258 "../src/PulseAudioManager.vala"
	operation = NULL;
#line 259 "../src/PulseAudioManager.vala"
	_tmp2_ = sound_device_get_input (device);
#line 259 "../src/PulseAudioManager.vala"
	_tmp3_ = _tmp2_;
#line 259 "../src/PulseAudioManager.vala"
	if (_tmp3_) {
#line 2766 "PulseAudioManager.c"
		pa_context* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		pa_cvolume _tmp7_;
		pa_operation* _tmp8_;
#line 260 "../src/PulseAudioManager.vala"
		_tmp4_ = self->priv->_context;
#line 260 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_source_name (device);
#line 260 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 260 "../src/PulseAudioManager.vala"
		_tmp7_ = cvol;
#line 260 "../src/PulseAudioManager.vala"
		_tmp8_ = pa_context_set_source_volume_by_name (_tmp4_, _tmp6_, &_tmp7_, NULL, NULL);
#line 260 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 260 "../src/PulseAudioManager.vala"
		operation = _tmp8_;
#line 2786 "PulseAudioManager.c"
	} else {
		pa_context* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		pa_cvolume _tmp12_;
		pa_operation* _tmp13_;
#line 262 "../src/PulseAudioManager.vala"
		_tmp9_ = self->priv->_context;
#line 262 "../src/PulseAudioManager.vala"
		_tmp10_ = sound_device_get_sink_name (device);
#line 262 "../src/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 262 "../src/PulseAudioManager.vala"
		_tmp12_ = cvol;
#line 262 "../src/PulseAudioManager.vala"
		_tmp13_ = pa_context_set_sink_volume_by_name (_tmp9_, _tmp11_, &_tmp12_, NULL, NULL);
#line 262 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (operation);
#line 262 "../src/PulseAudioManager.vala"
		operation = _tmp13_;
#line 2807 "PulseAudioManager.c"
	}
#line 265 "../src/PulseAudioManager.vala"
	_tmp14_ = operation;
#line 265 "../src/PulseAudioManager.vala"
	if (_tmp14_ != NULL) {
#line 2813 "PulseAudioManager.c"
		GeeLinkedList* _tmp15_;
		pa_operation* _tmp16_;
#line 266 "../src/PulseAudioManager.vala"
		_tmp15_ = device->volume_operations;
#line 266 "../src/PulseAudioManager.vala"
		_tmp16_ = operation;
#line 266 "../src/PulseAudioManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 2822 "PulseAudioManager.c"
	}
#line 251 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 2826 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_timeout (SoundPulseAudioManager* self)
{
	gboolean result;
#line 274 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 275 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 276 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse (self, NULL, NULL);
#line 277 "../src/PulseAudioManager.vala"
	result = FALSE;
#line 277 "../src/PulseAudioManager.vala"
	return result;
#line 2843 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_data_free (gpointer _data)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	_data_ = _data;
#line 29 "../src/PulseAudioManager.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/PulseAudioManager.vala"
	g_slice_free (SoundPulseAudioManagerReconnectToPulseData, _data_);
#line 2855 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse (SoundPulseAudioManager* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
	SoundPulseAudioManager* _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_slice_new0 (SoundPulseAudioManagerReconnectToPulseData);
#line 29 "../src/PulseAudioManager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 29 "../src/PulseAudioManager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_pulse_audio_manager_reconnect_to_pulse_data_free);
#line 29 "../src/PulseAudioManager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/PulseAudioManager.vala"
	_data_->self = _tmp0_;
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_reconnect_to_pulse_co (_data_);
#line 2879 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_reconnect_to_pulse_finish (SoundPulseAudioManager* self,
                                                     GAsyncResult* _res_)
{
	SoundPulseAudioManagerReconnectToPulseData* _data_;
#line 29 "../src/PulseAudioManager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2889 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self)
{
#line 290 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_context_state_callback ((SoundPulseAudioManager*) self, c);
#line 2898 "PulseAudioManager.c"
}

static gboolean
sound_pulse_audio_manager_reconnect_to_pulse_co (SoundPulseAudioManagerReconnectToPulseData* _data_)
{
#line 280 "../src/PulseAudioManager.vala"
	switch (_data_->_state_) {
#line 280 "../src/PulseAudioManager.vala"
		case 0:
#line 2908 "PulseAudioManager.c"
		goto _state_0;
		default:
#line 280 "../src/PulseAudioManager.vala"
		g_assert_not_reached ();
#line 2913 "PulseAudioManager.c"
	}
	_state_0:
#line 281 "../src/PulseAudioManager.vala"
	if (_data_->self->priv->is_ready) {
#line 282 "../src/PulseAudioManager.vala"
		_data_->_tmp0_ = _data_->self->priv->_context;
#line 282 "../src/PulseAudioManager.vala"
		pa_context_disconnect (_data_->_tmp0_);
#line 283 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (_data_->self, NULL);
#line 284 "../src/PulseAudioManager.vala"
		_data_->self->priv->is_ready = FALSE;
#line 2926 "PulseAudioManager.c"
	}
#line 287 "../src/PulseAudioManager.vala"
	_data_->_tmp1_ = pa_proplist_new ();
#line 287 "../src/PulseAudioManager.vala"
	_data_->props = _data_->_tmp1_;
#line 288 "../src/PulseAudioManager.vala"
	_data_->_tmp2_ = _data_->props;
#line 288 "../src/PulseAudioManager.vala"
	pa_proplist_sets (_data_->_tmp2_, PA_PROP_APPLICATION_ID, "org.pantheon.switchboard.plug.sound");
#line 289 "../src/PulseAudioManager.vala"
	_data_->_tmp3_ = _data_->self->priv->loop;
#line 289 "../src/PulseAudioManager.vala"
	_data_->_tmp4_ = pa_glib_mainloop_get_api (_data_->_tmp3_);
#line 289 "../src/PulseAudioManager.vala"
	_data_->_tmp5_ = _data_->props;
#line 289 "../src/PulseAudioManager.vala"
	_data_->_tmp6_ = pa_context_new_with_proplist (_data_->_tmp4_, NULL, _data_->_tmp5_);
#line 289 "../src/PulseAudioManager.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 289 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_set_context (_data_->self, _data_->_tmp7_);
#line 289 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (_data_->_tmp7_);
#line 290 "../src/PulseAudioManager.vala"
	_data_->_tmp8_ = _data_->self->priv->_context;
#line 290 "../src/PulseAudioManager.vala"
	pa_context_set_state_callback (_data_->_tmp8_, _sound_pulse_audio_manager_context_state_callback_pa_context_notify_cb_t, _data_->self);
#line 292 "../src/PulseAudioManager.vala"
	_data_->_tmp9_ = _data_->self->priv->_context;
#line 292 "../src/PulseAudioManager.vala"
	if (pa_context_connect (_data_->_tmp9_, NULL, PA_CONTEXT_NOFAIL, NULL) < 0) {
#line 293 "../src/PulseAudioManager.vala"
		_data_->_tmp10_ = _data_->self->priv->_context;
#line 293 "../src/PulseAudioManager.vala"
		_data_->_tmp11_ = pa_strerror (pa_context_errno (_data_->_tmp10_));
#line 293 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:293: pa_context_connect () failed: %s\n", _data_->_tmp11_);
#line 2964 "PulseAudioManager.c"
	}
#line 280 "../src/PulseAudioManager.vala"
	_pa_proplist_free0 (_data_->props);
#line 280 "../src/PulseAudioManager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 280 "../src/PulseAudioManager.vala"
	if (_data_->_state_ != 0) {
#line 280 "../src/PulseAudioManager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 280 "../src/PulseAudioManager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2976 "PulseAudioManager.c"
		}
	}
#line 280 "../src/PulseAudioManager.vala"
	g_object_unref (_data_->_async_result);
#line 280 "../src/PulseAudioManager.vala"
	return FALSE;
#line 2983 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t (pa_context* c,
                                                                         pa_subscription_event_type_t t,
                                                                         guint32 idx,
                                                                         gpointer self)
{
#line 300 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_subscribe_callback ((SoundPulseAudioManager*) self, c, t, idx);
#line 2994 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t (pa_context* c,
                                                                     pa_server_info* i,
                                                                     gpointer self)
{
#line 307 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_server_info_callback ((SoundPulseAudioManager*) self, c, i);
#line 3004 "PulseAudioManager.c"
}

static gboolean
_sound_pulse_audio_manager_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = sound_pulse_audio_manager_reconnect_timeout ((SoundPulseAudioManager*) self);
#line 314 "../src/PulseAudioManager.vala"
	return result;
#line 3014 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_context_state_callback (SoundPulseAudioManager* self,
                                                  pa_context* c)
{
#line 297 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 298 "../src/PulseAudioManager.vala"
	switch (pa_context_get_state (c)) {
#line 298 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_READY:
#line 3029 "PulseAudioManager.c"
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context* _tmp2_;
			pa_operation* _tmp3_;
			pa_operation* _tmp4_;
#line 300 "../src/PulseAudioManager.vala"
			pa_context_set_subscribe_callback (c, _sound_pulse_audio_manager_subscribe_callback_pa_context_subscribe_cb_t, self);
#line 301 "../src/PulseAudioManager.vala"
			_tmp0_ = pa_context_subscribe (c, ((((PA_SUBSCRIPTION_MASK_SERVER | PA_SUBSCRIPTION_MASK_SINK) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT) | PA_SUBSCRIPTION_MASK_CARD, NULL, NULL);
#line 301 "../src/PulseAudioManager.vala"
			_tmp1_ = _tmp0_;
#line 301 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp1_);
#line 307 "../src/PulseAudioManager.vala"
			_tmp2_ = self->priv->_context;
#line 307 "../src/PulseAudioManager.vala"
			_tmp3_ = pa_context_get_server_info (_tmp2_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 307 "../src/PulseAudioManager.vala"
			_tmp4_ = _tmp3_;
#line 307 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp4_);
#line 308 "../src/PulseAudioManager.vala"
			self->priv->is_ready = TRUE;
#line 309 "../src/PulseAudioManager.vala"
			break;
#line 3056 "PulseAudioManager.c"
		}
#line 298 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_FAILED:
#line 298 "../src/PulseAudioManager.vala"
		case PA_CONTEXT_TERMINATED:
#line 3062 "PulseAudioManager.c"
		{
#line 313 "../src/PulseAudioManager.vala"
			if (self->priv->reconnect_timer_id == 0U) {
#line 314 "../src/PulseAudioManager.vala"
				self->priv->reconnect_timer_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _sound_pulse_audio_manager_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
#line 3068 "PulseAudioManager.c"
			}
#line 317 "../src/PulseAudioManager.vala"
			break;
#line 3072 "PulseAudioManager.c"
		}
		default:
		{
#line 320 "../src/PulseAudioManager.vala"
			self->priv->is_ready = FALSE;
#line 321 "../src/PulseAudioManager.vala"
			break;
#line 3080 "PulseAudioManager.c"
		}
	}
}

static void
_sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 337 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_sink_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3093 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t (pa_context* c,
                                                                 pa_card_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
#line 377 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_card_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3104 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t (pa_context* c,
                                                                     pa_source_info* i,
                                                                     gint eol,
                                                                     gpointer self)
{
#line 397 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_source_info_callback ((SoundPulseAudioManager*) self, c, i, eol);
#line 3115 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_subscribe_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_subscription_event_type_t t,
                                              guint32 index)
{
	pa_subscription_event_type_t source_type = 0;
#line 329 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 330 "../src/PulseAudioManager.vala"
	source_type = t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK;
#line 331 "../src/PulseAudioManager.vala"
	switch (source_type) {
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK:
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
#line 3137 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 334 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 335 "../src/PulseAudioManager.vala"
			switch (event_type) {
#line 335 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3146 "PulseAudioManager.c"
				{
					pa_operation* _tmp0_;
					pa_operation* _tmp1_;
#line 337 "../src/PulseAudioManager.vala"
					_tmp0_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 337 "../src/PulseAudioManager.vala"
					_tmp1_ = _tmp0_;
#line 337 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp1_);
#line 338 "../src/PulseAudioManager.vala"
					break;
#line 3158 "PulseAudioManager.c"
				}
#line 335 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3162 "PulseAudioManager.c"
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
#line 341 "../src/PulseAudioManager.vala"
					_tmp2_ = pa_context_get_sink_info_by_index (c, index, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 341 "../src/PulseAudioManager.vala"
					_tmp3_ = _tmp2_;
#line 341 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp3_);
#line 342 "../src/PulseAudioManager.vala"
					break;
#line 3174 "PulseAudioManager.c"
				}
#line 335 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3178 "PulseAudioManager.c"
				{
#line 345 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:345: subscribe_callback:SINK:REMOVE");
#line 3182 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp4_;
						GeeCollection* _tmp5_;
						GeeCollection* _tmp6_;
						GeeCollection* _tmp7_;
						GeeIterator* _tmp8_;
						GeeIterator* _tmp9_;
#line 346 "../src/PulseAudioManager.vala"
						_tmp4_ = self->priv->output_devices;
#line 346 "../src/PulseAudioManager.vala"
						_tmp5_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp4_);
#line 346 "../src/PulseAudioManager.vala"
						_tmp6_ = _tmp5_;
#line 346 "../src/PulseAudioManager.vala"
						_tmp7_ = _tmp6_;
#line 346 "../src/PulseAudioManager.vala"
						_tmp8_ = gee_iterable_iterator ((GeeIterable*) _tmp7_);
#line 346 "../src/PulseAudioManager.vala"
						_tmp9_ = _tmp8_;
#line 346 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_tmp7_);
#line 346 "../src/PulseAudioManager.vala"
						_device_it = _tmp9_;
#line 346 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 3209 "PulseAudioManager.c"
							GeeIterator* _tmp10_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp11_;
							gpointer _tmp12_;
							SoundDevice* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SoundDevice* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
#line 346 "../src/PulseAudioManager.vala"
							_tmp10_ = _device_it;
#line 346 "../src/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp10_)) {
#line 346 "../src/PulseAudioManager.vala"
								break;
#line 3226 "PulseAudioManager.c"
							}
#line 346 "../src/PulseAudioManager.vala"
							_tmp11_ = _device_it;
#line 346 "../src/PulseAudioManager.vala"
							_tmp12_ = gee_iterator_get (_tmp11_);
#line 346 "../src/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp12_;
#line 347 "../src/PulseAudioManager.vala"
							_tmp13_ = device;
#line 347 "../src/PulseAudioManager.vala"
							_tmp14_ = sound_device_get_sink_index (_tmp13_);
#line 347 "../src/PulseAudioManager.vala"
							_tmp15_ = _tmp14_;
#line 347 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp15_) == index) {
#line 3242 "PulseAudioManager.c"
								SoundDevice* _tmp16_;
								const gchar* _tmp17_;
								const gchar* _tmp18_;
								SoundDevice* _tmp19_;
								SoundDevice* _tmp20_;
								SoundDevice* _tmp21_;
								SoundDevice* _tmp22_;
								const gchar* _tmp23_;
								const gchar* _tmp24_;
#line 348 "../src/PulseAudioManager.vala"
								_tmp16_ = device;
#line 348 "../src/PulseAudioManager.vala"
								_tmp17_ = sound_device_get_id (_tmp16_);
#line 348 "../src/PulseAudioManager.vala"
								_tmp18_ = _tmp17_;
#line 348 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:348: \tupdating device: %s", _tmp18_);
#line 349 "../src/PulseAudioManager.vala"
								_tmp19_ = device;
#line 349 "../src/PulseAudioManager.vala"
								sound_device_set_sink_name (_tmp19_, NULL);
#line 350 "../src/PulseAudioManager.vala"
								_tmp20_ = device;
#line 350 "../src/PulseAudioManager.vala"
								sound_device_set_sink_index (_tmp20_, -1);
#line 351 "../src/PulseAudioManager.vala"
								_tmp21_ = device;
#line 351 "../src/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp21_, FALSE);
#line 352 "../src/PulseAudioManager.vala"
								_tmp22_ = device;
#line 352 "../src/PulseAudioManager.vala"
								_tmp23_ = sound_device_get_sink_name (_tmp22_);
#line 352 "../src/PulseAudioManager.vala"
								_tmp24_ = _tmp23_;
#line 352 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:352: \t\tdevice.sink_name: %s", _tmp24_);
#line 3280 "PulseAudioManager.c"
							}
#line 355 "../src/PulseAudioManager.vala"
							_tmp25_ = device;
#line 355 "../src/PulseAudioManager.vala"
							_tmp26_ = sound_device_get_card_sink_index (_tmp25_);
#line 355 "../src/PulseAudioManager.vala"
							_tmp27_ = _tmp26_;
#line 355 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp27_) == index) {
#line 3290 "PulseAudioManager.c"
								SoundDevice* _tmp28_;
								const gchar* _tmp29_;
								const gchar* _tmp30_;
								SoundDevice* _tmp31_;
								SoundDevice* _tmp32_;
								SoundDevice* _tmp33_;
								SoundDevice* _tmp34_;
								const gchar* _tmp35_;
								const gchar* _tmp36_;
#line 356 "../src/PulseAudioManager.vala"
								_tmp28_ = device;
#line 356 "../src/PulseAudioManager.vala"
								_tmp29_ = sound_device_get_id (_tmp28_);
#line 356 "../src/PulseAudioManager.vala"
								_tmp30_ = _tmp29_;
#line 356 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:356: \tupdating device: %s", _tmp30_);
#line 357 "../src/PulseAudioManager.vala"
								_tmp31_ = device;
#line 357 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_name (_tmp31_, NULL);
#line 358 "../src/PulseAudioManager.vala"
								_tmp32_ = device;
#line 358 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_index (_tmp32_, -1);
#line 359 "../src/PulseAudioManager.vala"
								_tmp33_ = device;
#line 359 "../src/PulseAudioManager.vala"
								sound_device_set_card_sink_port_name (_tmp33_, NULL);
#line 360 "../src/PulseAudioManager.vala"
								_tmp34_ = device;
#line 360 "../src/PulseAudioManager.vala"
								_tmp35_ = sound_device_get_card_sink_name (_tmp34_);
#line 360 "../src/PulseAudioManager.vala"
								_tmp36_ = _tmp35_;
#line 360 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:360: \t\tdevice.card_sink_name: %s", _tmp36_);
#line 3328 "PulseAudioManager.c"
							}
#line 346 "../src/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 3332 "PulseAudioManager.c"
						}
#line 346 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 3336 "PulseAudioManager.c"
					}
#line 364 "../src/PulseAudioManager.vala"
					break;
#line 3340 "PulseAudioManager.c"
				}
				default:
#line 335 "../src/PulseAudioManager.vala"
				break;
#line 3345 "PulseAudioManager.c"
			}
#line 367 "../src/PulseAudioManager.vala"
			break;
#line 3349 "PulseAudioManager.c"
		}
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SERVER:
#line 3353 "PulseAudioManager.c"
		{
			pa_context* _tmp37_;
			pa_operation* _tmp38_;
			pa_operation* _tmp39_;
#line 370 "../src/PulseAudioManager.vala"
			_tmp37_ = self->priv->_context;
#line 370 "../src/PulseAudioManager.vala"
			_tmp38_ = pa_context_get_server_info (_tmp37_, _sound_pulse_audio_manager_server_info_callback_pa_server_info_cb_t, self);
#line 370 "../src/PulseAudioManager.vala"
			_tmp39_ = _tmp38_;
#line 370 "../src/PulseAudioManager.vala"
			_pa_operation_unref0 (_tmp39_);
#line 371 "../src/PulseAudioManager.vala"
			break;
#line 3368 "PulseAudioManager.c"
		}
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_CARD:
#line 3372 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 374 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 375 "../src/PulseAudioManager.vala"
			switch (event_type) {
#line 375 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3381 "PulseAudioManager.c"
				{
					pa_operation* _tmp40_;
					pa_operation* _tmp41_;
#line 377 "../src/PulseAudioManager.vala"
					_tmp40_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 377 "../src/PulseAudioManager.vala"
					_tmp41_ = _tmp40_;
#line 377 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp41_);
#line 378 "../src/PulseAudioManager.vala"
					break;
#line 3393 "PulseAudioManager.c"
				}
#line 375 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3397 "PulseAudioManager.c"
				{
					pa_operation* _tmp42_;
					pa_operation* _tmp43_;
#line 381 "../src/PulseAudioManager.vala"
					_tmp42_ = pa_context_get_card_info_by_index (c, index, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 381 "../src/PulseAudioManager.vala"
					_tmp43_ = _tmp42_;
#line 381 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp43_);
#line 382 "../src/PulseAudioManager.vala"
					break;
#line 3409 "PulseAudioManager.c"
				}
#line 375 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3413 "PulseAudioManager.c"
				{
					GeeHashMap* _tmp44_;
					GeeHashMap* _tmp45_;
#line 385 "../src/PulseAudioManager.vala"
					_tmp44_ = self->priv->output_devices;
#line 385 "../src/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp44_, index);
#line 386 "../src/PulseAudioManager.vala"
					_tmp45_ = self->priv->input_devices;
#line 386 "../src/PulseAudioManager.vala"
					sound_pulse_audio_manager_remove_devices_by_card (self, _tmp45_, index);
#line 387 "../src/PulseAudioManager.vala"
					break;
#line 3427 "PulseAudioManager.c"
				}
				default:
#line 375 "../src/PulseAudioManager.vala"
				break;
#line 3432 "PulseAudioManager.c"
			}
#line 390 "../src/PulseAudioManager.vala"
			break;
#line 3436 "PulseAudioManager.c"
		}
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE:
#line 331 "../src/PulseAudioManager.vala"
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
#line 3442 "PulseAudioManager.c"
		{
			pa_subscription_event_type_t event_type = 0;
#line 394 "../src/PulseAudioManager.vala"
			event_type = t & PA_SUBSCRIPTION_EVENT_TYPE_MASK;
#line 395 "../src/PulseAudioManager.vala"
			switch (event_type) {
#line 395 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_NEW:
#line 3451 "PulseAudioManager.c"
				{
					pa_operation* _tmp46_;
					pa_operation* _tmp47_;
#line 397 "../src/PulseAudioManager.vala"
					_tmp46_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 397 "../src/PulseAudioManager.vala"
					_tmp47_ = _tmp46_;
#line 397 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp47_);
#line 398 "../src/PulseAudioManager.vala"
					break;
#line 3463 "PulseAudioManager.c"
				}
#line 395 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_CHANGE:
#line 3467 "PulseAudioManager.c"
				{
					pa_operation* _tmp48_;
					pa_operation* _tmp49_;
#line 401 "../src/PulseAudioManager.vala"
					_tmp48_ = pa_context_get_source_info_by_index (c, index, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 401 "../src/PulseAudioManager.vala"
					_tmp49_ = _tmp48_;
#line 401 "../src/PulseAudioManager.vala"
					_pa_operation_unref0 (_tmp49_);
#line 402 "../src/PulseAudioManager.vala"
					break;
#line 3479 "PulseAudioManager.c"
				}
#line 395 "../src/PulseAudioManager.vala"
				case PA_SUBSCRIPTION_EVENT_REMOVE:
#line 3483 "PulseAudioManager.c"
				{
#line 405 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:405: subscribe_callback:SOURCE:REMOVE");
#line 3487 "PulseAudioManager.c"
					{
						GeeIterator* _device_it = NULL;
						GeeHashMap* _tmp50_;
						GeeCollection* _tmp51_;
						GeeCollection* _tmp52_;
						GeeCollection* _tmp53_;
						GeeIterator* _tmp54_;
						GeeIterator* _tmp55_;
#line 406 "../src/PulseAudioManager.vala"
						_tmp50_ = self->priv->input_devices;
#line 406 "../src/PulseAudioManager.vala"
						_tmp51_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp50_);
#line 406 "../src/PulseAudioManager.vala"
						_tmp52_ = _tmp51_;
#line 406 "../src/PulseAudioManager.vala"
						_tmp53_ = _tmp52_;
#line 406 "../src/PulseAudioManager.vala"
						_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 406 "../src/PulseAudioManager.vala"
						_tmp55_ = _tmp54_;
#line 406 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_tmp53_);
#line 406 "../src/PulseAudioManager.vala"
						_device_it = _tmp55_;
#line 406 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 3514 "PulseAudioManager.c"
							GeeIterator* _tmp56_;
							SoundDevice* device = NULL;
							GeeIterator* _tmp57_;
							gpointer _tmp58_;
							SoundDevice* _tmp59_;
							gint _tmp60_;
							gint _tmp61_;
							SoundDevice* _tmp71_;
							gint _tmp72_;
							gint _tmp73_;
#line 406 "../src/PulseAudioManager.vala"
							_tmp56_ = _device_it;
#line 406 "../src/PulseAudioManager.vala"
							if (!gee_iterator_next (_tmp56_)) {
#line 406 "../src/PulseAudioManager.vala"
								break;
#line 3531 "PulseAudioManager.c"
							}
#line 406 "../src/PulseAudioManager.vala"
							_tmp57_ = _device_it;
#line 406 "../src/PulseAudioManager.vala"
							_tmp58_ = gee_iterator_get (_tmp57_);
#line 406 "../src/PulseAudioManager.vala"
							device = (SoundDevice*) _tmp58_;
#line 407 "../src/PulseAudioManager.vala"
							_tmp59_ = device;
#line 407 "../src/PulseAudioManager.vala"
							_tmp60_ = sound_device_get_source_index (_tmp59_);
#line 407 "../src/PulseAudioManager.vala"
							_tmp61_ = _tmp60_;
#line 407 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp61_) == index) {
#line 3547 "PulseAudioManager.c"
								SoundDevice* _tmp62_;
								const gchar* _tmp63_;
								const gchar* _tmp64_;
								SoundDevice* _tmp65_;
								SoundDevice* _tmp66_;
								SoundDevice* _tmp67_;
								SoundDevice* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
#line 408 "../src/PulseAudioManager.vala"
								_tmp62_ = device;
#line 408 "../src/PulseAudioManager.vala"
								_tmp63_ = sound_device_get_id (_tmp62_);
#line 408 "../src/PulseAudioManager.vala"
								_tmp64_ = _tmp63_;
#line 408 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:408: \tupdating device: %s", _tmp64_);
#line 409 "../src/PulseAudioManager.vala"
								_tmp65_ = device;
#line 409 "../src/PulseAudioManager.vala"
								sound_device_set_source_name (_tmp65_, NULL);
#line 410 "../src/PulseAudioManager.vala"
								_tmp66_ = device;
#line 410 "../src/PulseAudioManager.vala"
								sound_device_set_source_index (_tmp66_, -1);
#line 411 "../src/PulseAudioManager.vala"
								_tmp67_ = device;
#line 411 "../src/PulseAudioManager.vala"
								sound_device_set_is_default (_tmp67_, FALSE);
#line 412 "../src/PulseAudioManager.vala"
								_tmp68_ = device;
#line 412 "../src/PulseAudioManager.vala"
								_tmp69_ = sound_device_get_source_name (_tmp68_);
#line 412 "../src/PulseAudioManager.vala"
								_tmp70_ = _tmp69_;
#line 412 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:412: \t\tdevice.source_name: %s", _tmp70_);
#line 3585 "PulseAudioManager.c"
							}
#line 415 "../src/PulseAudioManager.vala"
							_tmp71_ = device;
#line 415 "../src/PulseAudioManager.vala"
							_tmp72_ = sound_device_get_card_source_index (_tmp71_);
#line 415 "../src/PulseAudioManager.vala"
							_tmp73_ = _tmp72_;
#line 415 "../src/PulseAudioManager.vala"
							if (((guint32) _tmp73_) == index) {
#line 3595 "PulseAudioManager.c"
								SoundDevice* _tmp74_;
								const gchar* _tmp75_;
								const gchar* _tmp76_;
								SoundDevice* _tmp77_;
								SoundDevice* _tmp78_;
								SoundDevice* _tmp79_;
								SoundDevice* _tmp80_;
								const gchar* _tmp81_;
								const gchar* _tmp82_;
#line 416 "../src/PulseAudioManager.vala"
								_tmp74_ = device;
#line 416 "../src/PulseAudioManager.vala"
								_tmp75_ = sound_device_get_id (_tmp74_);
#line 416 "../src/PulseAudioManager.vala"
								_tmp76_ = _tmp75_;
#line 416 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:416: \tupdating device: %s", _tmp76_);
#line 417 "../src/PulseAudioManager.vala"
								_tmp77_ = device;
#line 417 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_name (_tmp77_, NULL);
#line 418 "../src/PulseAudioManager.vala"
								_tmp78_ = device;
#line 418 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_index (_tmp78_, -1);
#line 419 "../src/PulseAudioManager.vala"
								_tmp79_ = device;
#line 419 "../src/PulseAudioManager.vala"
								sound_device_set_card_source_port_name (_tmp79_, NULL);
#line 420 "../src/PulseAudioManager.vala"
								_tmp80_ = device;
#line 420 "../src/PulseAudioManager.vala"
								_tmp81_ = sound_device_get_card_source_name (_tmp80_);
#line 420 "../src/PulseAudioManager.vala"
								_tmp82_ = _tmp81_;
#line 420 "../src/PulseAudioManager.vala"
								g_debug ("PulseAudioManager.vala:420: \t\tdevice.card_source_name: %s", _tmp82_);
#line 3633 "PulseAudioManager.c"
							}
#line 406 "../src/PulseAudioManager.vala"
							_g_object_unref0 (device);
#line 3637 "PulseAudioManager.c"
						}
#line 406 "../src/PulseAudioManager.vala"
						_g_object_unref0 (_device_it);
#line 3641 "PulseAudioManager.c"
					}
#line 424 "../src/PulseAudioManager.vala"
					break;
#line 3645 "PulseAudioManager.c"
				}
				default:
#line 395 "../src/PulseAudioManager.vala"
				break;
#line 3650 "PulseAudioManager.c"
			}
#line 427 "../src/PulseAudioManager.vala"
			break;
#line 3654 "PulseAudioManager.c"
		}
		default:
#line 331 "../src/PulseAudioManager.vala"
		break;
#line 3659 "PulseAudioManager.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 463 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 463 "../src/PulseAudioManager.vala"
	return _data8_;
#line 3670 "PulseAudioManager.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 463 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3680 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 463 "../src/PulseAudioManager.vala"
		self = _data8_->self;
#line 463 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data8_->device);
#line 463 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 463 "../src/PulseAudioManager.vala"
		g_slice_free (Block8Data, _data8_);
#line 3690 "PulseAudioManager.c"
	}
}

static gboolean
______lambda8_ (Block8Data* _data8_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result;
#line 481 "../src/PulseAudioManager.vala"
	self = _data8_->self;
#line 481 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 482 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 3706 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 483 "../src/PulseAudioManager.vala"
		_tmp0_ = _data8_->device;
#line 483 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 483 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 3715 "PulseAudioManager.c"
	}
#line 486 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 486 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 486 "../src/PulseAudioManager.vala"
	return result;
#line 3723 "PulseAudioManager.c"
}

static gboolean
_______lambda8__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda8_ (self, (pa_operation*) g);
#line 481 "../src/PulseAudioManager.vala"
	return result;
#line 3734 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_source_info_callback (SoundPulseAudioManager* self,
                                                pa_context* c,
                                                pa_source_info* source,
                                                gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_source_port_info* _tmp8_;
#line 435 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 436 "../src/PulseAudioManager.vala"
	if (source == NULL) {
#line 437 "../src/PulseAudioManager.vala"
		return;
#line 3755 "PulseAudioManager.c"
	}
#line 441 "../src/PulseAudioManager.vala"
	if ((*source).monitor_of_sink != PA_INVALID_INDEX) {
#line 442 "../src/PulseAudioManager.vala"
		return;
#line 3761 "PulseAudioManager.c"
	}
#line 445 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:445: source info update");
#line 446 "../src/PulseAudioManager.vala"
	_tmp0_ = (*source).description;
#line 446 "../src/PulseAudioManager.vala"
	_tmp1_ = (*source).name;
#line 446 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:446: \tsource: %s (%s)", _tmp0_, _tmp1_);
#line 447 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:447: \t\tcard: %u", (guint) (*source).card);
#line 449 "../src/PulseAudioManager.vala"
	_tmp2_ = (*source).name;
#line 449 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 450 "../src/PulseAudioManager.vala"
		return;
#line 3779 "PulseAudioManager.c"
	}
#line 453 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_debug_enabled) {
#line 3783 "PulseAudioManager.c"
		pa_source_port_info** _tmp3_;
		gint _tmp3__length1;
#line 454 "../src/PulseAudioManager.vala"
		_tmp3_ = (*source).ports;
#line 454 "../src/PulseAudioManager.vala"
		_tmp3__length1 = (*source).n_ports;
#line 3790 "PulseAudioManager.c"
		{
			pa_source_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 454 "../src/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 454 "../src/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 454 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 3802 "PulseAudioManager.c"
				pa_source_port_info* port = NULL;
#line 454 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 3806 "PulseAudioManager.c"
				{
					pa_source_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_source_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 455 "../src/PulseAudioManager.vala"
					_tmp4_ = port;
#line 455 "../src/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 455 "../src/PulseAudioManager.vala"
					_tmp6_ = port;
#line 455 "../src/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 455 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:455: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 3822 "PulseAudioManager.c"
				}
			}
		}
	}
#line 459 "../src/PulseAudioManager.vala"
	_tmp8_ = (*source).active_port;
#line 459 "../src/PulseAudioManager.vala"
	if (_tmp8_ != NULL) {
#line 3831 "PulseAudioManager.c"
		pa_source_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_source_port_info* _tmp11_;
		const gchar* _tmp12_;
#line 460 "../src/PulseAudioManager.vala"
		_tmp9_ = (*source).active_port;
#line 460 "../src/PulseAudioManager.vala"
		_tmp10_ = (*_tmp9_).description;
#line 460 "../src/PulseAudioManager.vala"
		_tmp11_ = (*source).active_port;
#line 460 "../src/PulseAudioManager.vala"
		_tmp12_ = (*_tmp11_).name;
#line 460 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:460: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
#line 3846 "PulseAudioManager.c"
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 463 "../src/PulseAudioManager.vala"
		_tmp13_ = self->priv->input_devices;
#line 463 "../src/PulseAudioManager.vala"
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
#line 463 "../src/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 463 "../src/PulseAudioManager.vala"
		_tmp16_ = _tmp15_;
#line 463 "../src/PulseAudioManager.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 463 "../src/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 463 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_tmp16_);
#line 463 "../src/PulseAudioManager.vala"
		_device_it = _tmp18_;
#line 463 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 3874 "PulseAudioManager.c"
			Block8Data* _data8_;
			GeeIterator* _tmp19_;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
#line 463 "../src/PulseAudioManager.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 463 "../src/PulseAudioManager.vala"
			_data8_->_ref_count_ = 1;
#line 463 "../src/PulseAudioManager.vala"
			_data8_->self = g_object_ref (self);
#line 463 "../src/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 463 "../src/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 463 "../src/PulseAudioManager.vala"
				block8_data_unref (_data8_);
#line 463 "../src/PulseAudioManager.vala"
				_data8_ = NULL;
#line 463 "../src/PulseAudioManager.vala"
				break;
#line 3898 "PulseAudioManager.c"
			}
#line 463 "../src/PulseAudioManager.vala"
			_tmp20_ = _device_it;
#line 463 "../src/PulseAudioManager.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 463 "../src/PulseAudioManager.vala"
			_data8_->device = (SoundDevice*) _tmp21_;
#line 464 "../src/PulseAudioManager.vala"
			_tmp22_ = _data8_->device;
#line 464 "../src/PulseAudioManager.vala"
			_tmp23_ = sound_device_get_card_index (_tmp22_);
#line 464 "../src/PulseAudioManager.vala"
			_tmp24_ = _tmp23_;
#line 464 "../src/PulseAudioManager.vala"
			if (_tmp24_ == (*source).card) {
#line 3914 "PulseAudioManager.c"
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_source_port_info* _tmp35_;
#line 465 "../src/PulseAudioManager.vala"
				_tmp25_ = _data8_->device;
#line 465 "../src/PulseAudioManager.vala"
				_tmp26_ = sound_device_get_id (_tmp25_);
#line 465 "../src/PulseAudioManager.vala"
				_tmp27_ = _tmp26_;
#line 465 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:465: \t\tupdating device: %s", _tmp27_);
#line 466 "../src/PulseAudioManager.vala"
				_tmp28_ = _data8_->device;
#line 466 "../src/PulseAudioManager.vala"
				sound_device_set_card_source_index (_tmp28_, (gint) (*source).index);
#line 467 "../src/PulseAudioManager.vala"
				_tmp29_ = _data8_->device;
#line 467 "../src/PulseAudioManager.vala"
				_tmp30_ = (*source).name;
#line 467 "../src/PulseAudioManager.vala"
				sound_device_set_card_source_name (_tmp29_, _tmp30_);
#line 468 "../src/PulseAudioManager.vala"
				_tmp31_ = _data8_->device;
#line 468 "../src/PulseAudioManager.vala"
				_tmp32_ = sound_device_get_card_source_name (_tmp31_);
#line 468 "../src/PulseAudioManager.vala"
				_tmp33_ = _tmp32_;
#line 468 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:468: \t\t\tdevice.card_source_name: %s", _tmp33_);
#line 469 "../src/PulseAudioManager.vala"
				_tmp35_ = (*source).active_port;
#line 469 "../src/PulseAudioManager.vala"
				if (_tmp35_ != NULL) {
#line 3956 "PulseAudioManager.c"
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_source_port_info* _tmp39_;
					const gchar* _tmp40_;
#line 469 "../src/PulseAudioManager.vala"
					_tmp36_ = _data8_->device;
#line 469 "../src/PulseAudioManager.vala"
					_tmp37_ = sound_device_get_port_name (_tmp36_);
#line 469 "../src/PulseAudioManager.vala"
					_tmp38_ = _tmp37_;
#line 469 "../src/PulseAudioManager.vala"
					_tmp39_ = (*source).active_port;
#line 469 "../src/PulseAudioManager.vala"
					_tmp40_ = (*_tmp39_).name;
#line 469 "../src/PulseAudioManager.vala"
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
#line 3974 "PulseAudioManager.c"
				} else {
#line 469 "../src/PulseAudioManager.vala"
					_tmp34_ = FALSE;
#line 3978 "PulseAudioManager.c"
				}
#line 469 "../src/PulseAudioManager.vala"
				if (_tmp34_) {
#line 3982 "PulseAudioManager.c"
					SoundDevice* _tmp41_;
					pa_source_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					SoundDevice* _tmp58_;
					pa_cvolume _tmp59_;
					SoundDevice* _tmp60_;
					pa_channel_map _tmp61_;
					SoundDevice* _tmp62_;
					pa_channel_map _tmp63_;
					SoundDevice* _tmp64_;
					GeeLinkedList* _tmp65_;
					SoundDevice* _tmp66_;
					GeeLinkedList* _tmp67_;
					gboolean _tmp68_;
					gboolean _tmp69_;
					SoundDevice* _tmp71_;
					gboolean _tmp72_;
					gboolean _tmp73_;
#line 470 "../src/PulseAudioManager.vala"
					_tmp41_ = _data8_->device;
#line 470 "../src/PulseAudioManager.vala"
					_tmp42_ = (*source).active_port;
#line 470 "../src/PulseAudioManager.vala"
					_tmp43_ = (*_tmp42_).name;
#line 470 "../src/PulseAudioManager.vala"
					sound_device_set_card_source_port_name (_tmp41_, _tmp43_);
#line 471 "../src/PulseAudioManager.vala"
					_tmp44_ = _data8_->device;
#line 471 "../src/PulseAudioManager.vala"
					_tmp45_ = (*source).name;
#line 471 "../src/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp44_, _tmp45_);
#line 472 "../src/PulseAudioManager.vala"
					_tmp46_ = _data8_->device;
#line 472 "../src/PulseAudioManager.vala"
					_tmp47_ = sound_device_get_card_source_name (_tmp46_);
#line 472 "../src/PulseAudioManager.vala"
					_tmp48_ = _tmp47_;
#line 472 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:472: \t\t\tdevice.source_name: %s", _tmp48_);
#line 473 "../src/PulseAudioManager.vala"
					_tmp49_ = _data8_->device;
#line 473 "../src/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp49_, (gint) (*source).index);
#line 474 "../src/PulseAudioManager.vala"
					_tmp50_ = _data8_->device;
#line 474 "../src/PulseAudioManager.vala"
					_tmp51_ = (*source).name;
#line 474 "../src/PulseAudioManager.vala"
					_tmp52_ = self->priv->default_source_name;
#line 474 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
#line 475 "../src/PulseAudioManager.vala"
					_tmp54_ = _data8_->device;
#line 475 "../src/PulseAudioManager.vala"
					_tmp55_ = sound_device_get_is_default (_tmp54_);
#line 475 "../src/PulseAudioManager.vala"
					_tmp56_ = _tmp55_;
#line 475 "../src/PulseAudioManager.vala"
					if (_tmp56_) {
#line 475 "../src/PulseAudioManager.vala"
						_tmp53_ = "true";
#line 4059 "PulseAudioManager.c"
					} else {
#line 475 "../src/PulseAudioManager.vala"
						_tmp53_ = "false";
#line 4063 "PulseAudioManager.c"
					}
#line 475 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:475: \t\t\tis_default: %s", _tmp53_);
#line 477 "../src/PulseAudioManager.vala"
					_tmp57_ = _data8_->device;
#line 477 "../src/PulseAudioManager.vala"
					sound_device_set_is_muted (_tmp57_, (*source).mute != 0);
#line 478 "../src/PulseAudioManager.vala"
					_tmp58_ = _data8_->device;
#line 478 "../src/PulseAudioManager.vala"
					_tmp59_ = (*source).volume;
#line 478 "../src/PulseAudioManager.vala"
					_tmp58_->cvolume = _tmp59_;
#line 479 "../src/PulseAudioManager.vala"
					_tmp60_ = _data8_->device;
#line 479 "../src/PulseAudioManager.vala"
					_tmp61_ = (*source).channel_map;
#line 479 "../src/PulseAudioManager.vala"
					_tmp60_->channel_map = _tmp61_;
#line 480 "../src/PulseAudioManager.vala"
					_tmp62_ = _data8_->device;
#line 480 "../src/PulseAudioManager.vala"
					_tmp63_ = (*source).channel_map;
#line 480 "../src/PulseAudioManager.vala"
					sound_device_set_balance (_tmp62_, pa_cvolume_get_balance (&(*source).volume, &_tmp63_));
#line 481 "../src/PulseAudioManager.vala"
					_tmp64_ = _data8_->device;
#line 481 "../src/PulseAudioManager.vala"
					_tmp65_ = _tmp64_->volume_operations;
#line 481 "../src/PulseAudioManager.vala"
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp65_, _______lambda8__gee_forall_func, _data8_);
#line 489 "../src/PulseAudioManager.vala"
					_tmp66_ = _data8_->device;
#line 489 "../src/PulseAudioManager.vala"
					_tmp67_ = _tmp66_->volume_operations;
#line 489 "../src/PulseAudioManager.vala"
					_tmp68_ = gee_collection_get_is_empty ((GeeCollection*) _tmp67_);
#line 489 "../src/PulseAudioManager.vala"
					_tmp69_ = _tmp68_;
#line 489 "../src/PulseAudioManager.vala"
					if (_tmp69_) {
#line 4105 "PulseAudioManager.c"
						SoundDevice* _tmp70_;
#line 490 "../src/PulseAudioManager.vala"
						_tmp70_ = _data8_->device;
#line 490 "../src/PulseAudioManager.vala"
						sound_device_set_volume (_tmp70_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*source).volume)));
#line 4111 "PulseAudioManager.c"
					}
#line 493 "../src/PulseAudioManager.vala"
					_tmp71_ = _data8_->device;
#line 493 "../src/PulseAudioManager.vala"
					_tmp72_ = sound_device_get_is_default (_tmp71_);
#line 493 "../src/PulseAudioManager.vala"
					_tmp73_ = _tmp72_;
#line 493 "../src/PulseAudioManager.vala"
					if (_tmp73_) {
#line 4121 "PulseAudioManager.c"
						SoundDevice* _tmp74_;
#line 494 "../src/PulseAudioManager.vala"
						_tmp74_ = _data8_->device;
#line 494 "../src/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_input (self, _tmp74_);
#line 4127 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp75_;
					SoundDevice* _tmp76_;
					SoundDevice* _tmp77_;
#line 498 "../src/PulseAudioManager.vala"
					_tmp75_ = _data8_->device;
#line 498 "../src/PulseAudioManager.vala"
					sound_device_set_source_name (_tmp75_, NULL);
#line 499 "../src/PulseAudioManager.vala"
					_tmp76_ = _data8_->device;
#line 499 "../src/PulseAudioManager.vala"
					sound_device_set_source_index (_tmp76_, -1);
#line 500 "../src/PulseAudioManager.vala"
					_tmp77_ = _data8_->device;
#line 500 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp77_, FALSE);
#line 4145 "PulseAudioManager.c"
				}
			}
#line 463 "../src/PulseAudioManager.vala"
			block8_data_unref (_data8_);
#line 463 "../src/PulseAudioManager.vala"
			_data8_ = NULL;
#line 4152 "PulseAudioManager.c"
		}
#line 463 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 4156 "PulseAudioManager.c"
	}
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 531 "../src/PulseAudioManager.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 531 "../src/PulseAudioManager.vala"
	return _data9_;
#line 4167 "PulseAudioManager.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 531 "../src/PulseAudioManager.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 4177 "PulseAudioManager.c"
		SoundPulseAudioManager* self;
#line 531 "../src/PulseAudioManager.vala"
		self = _data9_->self;
#line 531 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_data9_->device);
#line 531 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self);
#line 531 "../src/PulseAudioManager.vala"
		g_slice_free (Block9Data, _data9_);
#line 4187 "PulseAudioManager.c"
	}
}

static gboolean
______lambda5_ (Block9Data* _data9_,
                pa_operation* operation)
{
	SoundPulseAudioManager* self;
	gboolean result;
#line 549 "../src/PulseAudioManager.vala"
	self = _data9_->self;
#line 549 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (operation != NULL, FALSE);
#line 550 "../src/PulseAudioManager.vala"
	if (pa_operation_get_state (operation) != PA_OPERATION_RUNNING) {
#line 4203 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
		GeeLinkedList* _tmp1_;
#line 551 "../src/PulseAudioManager.vala"
		_tmp0_ = _data9_->device;
#line 551 "../src/PulseAudioManager.vala"
		_tmp1_ = _tmp0_->volume_operations;
#line 551 "../src/PulseAudioManager.vala"
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, operation);
#line 4212 "PulseAudioManager.c"
	}
#line 554 "../src/PulseAudioManager.vala"
	result = G_SOURCE_CONTINUE;
#line 554 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (operation);
#line 554 "../src/PulseAudioManager.vala"
	return result;
#line 4220 "PulseAudioManager.c"
}

static gboolean
_______lambda5__gee_forall_func (gpointer g,
                                 gpointer self)
{
	gboolean result;
	result = ______lambda5_ (self, (pa_operation*) g);
#line 549 "../src/PulseAudioManager.vala"
	return result;
#line 4231 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_sink_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_sink_info* sink,
                                              gint eol)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_sink_port_info* _tmp8_;
#line 506 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 507 "../src/PulseAudioManager.vala"
	if (sink == NULL) {
#line 508 "../src/PulseAudioManager.vala"
		return;
#line 4252 "PulseAudioManager.c"
	}
#line 511 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:511: sink info update");
#line 512 "../src/PulseAudioManager.vala"
	_tmp0_ = (*sink).description;
#line 512 "../src/PulseAudioManager.vala"
	_tmp1_ = (*sink).name;
#line 512 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:512: \tsink: %s (%s)", _tmp0_, _tmp1_);
#line 514 "../src/PulseAudioManager.vala"
	_tmp2_ = (*sink).name;
#line 514 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp2_, "auto_null") == 0) {
#line 515 "../src/PulseAudioManager.vala"
		return;
#line 4268 "PulseAudioManager.c"
	}
#line 518 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:518: \t\tcard: %u", (guint) (*sink).card);
#line 519 "../src/PulseAudioManager.vala"
	if (sound_pulse_audio_manager_debug_enabled) {
#line 4274 "PulseAudioManager.c"
		pa_sink_port_info** _tmp3_;
		gint _tmp3__length1;
#line 521 "../src/PulseAudioManager.vala"
		_tmp3_ = (*sink).ports;
#line 521 "../src/PulseAudioManager.vala"
		_tmp3__length1 = (*sink).n_ports;
#line 4281 "PulseAudioManager.c"
		{
			pa_sink_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 521 "../src/PulseAudioManager.vala"
			port_collection = _tmp3_;
#line 521 "../src/PulseAudioManager.vala"
			port_collection_length1 = _tmp3__length1;
#line 521 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 4293 "PulseAudioManager.c"
				pa_sink_port_info* port = NULL;
#line 521 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 4297 "PulseAudioManager.c"
				{
					pa_sink_port_info* _tmp4_;
					const gchar* _tmp5_;
					pa_sink_port_info* _tmp6_;
					const gchar* _tmp7_;
#line 522 "../src/PulseAudioManager.vala"
					_tmp4_ = port;
#line 522 "../src/PulseAudioManager.vala"
					_tmp5_ = (*_tmp4_).description;
#line 522 "../src/PulseAudioManager.vala"
					_tmp6_ = port;
#line 522 "../src/PulseAudioManager.vala"
					_tmp7_ = (*_tmp6_).name;
#line 522 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:522: \t\tport: %s (%s)", _tmp5_, _tmp7_);
#line 4313 "PulseAudioManager.c"
				}
			}
		}
	}
#line 527 "../src/PulseAudioManager.vala"
	_tmp8_ = (*sink).active_port;
#line 527 "../src/PulseAudioManager.vala"
	if (_tmp8_ != NULL) {
#line 4322 "PulseAudioManager.c"
		pa_sink_port_info* _tmp9_;
		const gchar* _tmp10_;
		pa_sink_port_info* _tmp11_;
		const gchar* _tmp12_;
#line 528 "../src/PulseAudioManager.vala"
		_tmp9_ = (*sink).active_port;
#line 528 "../src/PulseAudioManager.vala"
		_tmp10_ = (*_tmp9_).description;
#line 528 "../src/PulseAudioManager.vala"
		_tmp11_ = (*sink).active_port;
#line 528 "../src/PulseAudioManager.vala"
		_tmp12_ = (*_tmp11_).name;
#line 528 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:528: \t\tactive port: %s (%s)", _tmp10_, _tmp12_);
#line 4337 "PulseAudioManager.c"
	}
	{
		GeeIterator* _device_it = NULL;
		GeeHashMap* _tmp13_;
		GeeCollection* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_;
		GeeIterator* _tmp18_;
#line 531 "../src/PulseAudioManager.vala"
		_tmp13_ = self->priv->output_devices;
#line 531 "../src/PulseAudioManager.vala"
		_tmp14_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp13_);
#line 531 "../src/PulseAudioManager.vala"
		_tmp15_ = _tmp14_;
#line 531 "../src/PulseAudioManager.vala"
		_tmp16_ = _tmp15_;
#line 531 "../src/PulseAudioManager.vala"
		_tmp17_ = gee_iterable_iterator ((GeeIterable*) _tmp16_);
#line 531 "../src/PulseAudioManager.vala"
		_tmp18_ = _tmp17_;
#line 531 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_tmp16_);
#line 531 "../src/PulseAudioManager.vala"
		_device_it = _tmp18_;
#line 531 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 4365 "PulseAudioManager.c"
			Block9Data* _data9_;
			GeeIterator* _tmp19_;
			GeeIterator* _tmp20_;
			gpointer _tmp21_;
			SoundDevice* _tmp22_;
			guint32 _tmp23_;
			guint32 _tmp24_;
#line 531 "../src/PulseAudioManager.vala"
			_data9_ = g_slice_new0 (Block9Data);
#line 531 "../src/PulseAudioManager.vala"
			_data9_->_ref_count_ = 1;
#line 531 "../src/PulseAudioManager.vala"
			_data9_->self = g_object_ref (self);
#line 531 "../src/PulseAudioManager.vala"
			_tmp19_ = _device_it;
#line 531 "../src/PulseAudioManager.vala"
			if (!gee_iterator_next (_tmp19_)) {
#line 531 "../src/PulseAudioManager.vala"
				block9_data_unref (_data9_);
#line 531 "../src/PulseAudioManager.vala"
				_data9_ = NULL;
#line 531 "../src/PulseAudioManager.vala"
				break;
#line 4389 "PulseAudioManager.c"
			}
#line 531 "../src/PulseAudioManager.vala"
			_tmp20_ = _device_it;
#line 531 "../src/PulseAudioManager.vala"
			_tmp21_ = gee_iterator_get (_tmp20_);
#line 531 "../src/PulseAudioManager.vala"
			_data9_->device = (SoundDevice*) _tmp21_;
#line 532 "../src/PulseAudioManager.vala"
			_tmp22_ = _data9_->device;
#line 532 "../src/PulseAudioManager.vala"
			_tmp23_ = sound_device_get_card_index (_tmp22_);
#line 532 "../src/PulseAudioManager.vala"
			_tmp24_ = _tmp23_;
#line 532 "../src/PulseAudioManager.vala"
			if (_tmp24_ == (*sink).card) {
#line 4405 "PulseAudioManager.c"
				SoundDevice* _tmp25_;
				const gchar* _tmp26_;
				const gchar* _tmp27_;
				SoundDevice* _tmp28_;
				SoundDevice* _tmp29_;
				const gchar* _tmp30_;
				SoundDevice* _tmp31_;
				const gchar* _tmp32_;
				const gchar* _tmp33_;
				gboolean _tmp34_ = FALSE;
				pa_sink_port_info* _tmp35_;
#line 533 "../src/PulseAudioManager.vala"
				_tmp25_ = _data9_->device;
#line 533 "../src/PulseAudioManager.vala"
				_tmp26_ = sound_device_get_id (_tmp25_);
#line 533 "../src/PulseAudioManager.vala"
				_tmp27_ = _tmp26_;
#line 533 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:533: \t\tupdating device: %s", _tmp27_);
#line 534 "../src/PulseAudioManager.vala"
				_tmp28_ = _data9_->device;
#line 534 "../src/PulseAudioManager.vala"
				sound_device_set_card_sink_index (_tmp28_, (gint) (*sink).index);
#line 535 "../src/PulseAudioManager.vala"
				_tmp29_ = _data9_->device;
#line 535 "../src/PulseAudioManager.vala"
				_tmp30_ = (*sink).name;
#line 535 "../src/PulseAudioManager.vala"
				sound_device_set_card_sink_name (_tmp29_, _tmp30_);
#line 536 "../src/PulseAudioManager.vala"
				_tmp31_ = _data9_->device;
#line 536 "../src/PulseAudioManager.vala"
				_tmp32_ = sound_device_get_card_sink_name (_tmp31_);
#line 536 "../src/PulseAudioManager.vala"
				_tmp33_ = _tmp32_;
#line 536 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:536: \t\t\tdevice.card_sink_name: %s", _tmp33_);
#line 538 "../src/PulseAudioManager.vala"
				_tmp35_ = (*sink).active_port;
#line 538 "../src/PulseAudioManager.vala"
				if (_tmp35_ != NULL) {
#line 4447 "PulseAudioManager.c"
					SoundDevice* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
					pa_sink_port_info* _tmp39_;
					const gchar* _tmp40_;
#line 538 "../src/PulseAudioManager.vala"
					_tmp36_ = _data9_->device;
#line 538 "../src/PulseAudioManager.vala"
					_tmp37_ = sound_device_get_port_name (_tmp36_);
#line 538 "../src/PulseAudioManager.vala"
					_tmp38_ = _tmp37_;
#line 538 "../src/PulseAudioManager.vala"
					_tmp39_ = (*sink).active_port;
#line 538 "../src/PulseAudioManager.vala"
					_tmp40_ = (*_tmp39_).name;
#line 538 "../src/PulseAudioManager.vala"
					_tmp34_ = g_strcmp0 (_tmp38_, _tmp40_) == 0;
#line 4465 "PulseAudioManager.c"
				} else {
#line 538 "../src/PulseAudioManager.vala"
					_tmp34_ = FALSE;
#line 4469 "PulseAudioManager.c"
				}
#line 538 "../src/PulseAudioManager.vala"
				if (_tmp34_) {
#line 4473 "PulseAudioManager.c"
					SoundDevice* _tmp41_;
					pa_sink_port_info* _tmp42_;
					const gchar* _tmp43_;
					SoundDevice* _tmp44_;
					const gchar* _tmp45_;
					SoundDevice* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					SoundDevice* _tmp49_;
					SoundDevice* _tmp50_;
					const gchar* _tmp51_;
					const gchar* _tmp52_;
					const gchar* _tmp53_ = NULL;
					SoundDevice* _tmp54_;
					gboolean _tmp55_;
					gboolean _tmp56_;
					SoundDevice* _tmp57_;
					SoundDevice* _tmp58_;
					pa_cvolume _tmp59_;
					SoundDevice* _tmp60_;
					pa_channel_map _tmp61_;
					SoundDevice* _tmp62_;
					pa_channel_map _tmp63_;
					SoundDevice* _tmp64_;
					GeeLinkedList* _tmp65_;
					SoundDevice* _tmp66_;
					GeeLinkedList* _tmp67_;
					gboolean _tmp68_;
					gboolean _tmp69_;
					SoundDevice* _tmp71_;
					gboolean _tmp72_;
					gboolean _tmp73_;
#line 539 "../src/PulseAudioManager.vala"
					_tmp41_ = _data9_->device;
#line 539 "../src/PulseAudioManager.vala"
					_tmp42_ = (*sink).active_port;
#line 539 "../src/PulseAudioManager.vala"
					_tmp43_ = (*_tmp42_).name;
#line 539 "../src/PulseAudioManager.vala"
					sound_device_set_card_sink_port_name (_tmp41_, _tmp43_);
#line 540 "../src/PulseAudioManager.vala"
					_tmp44_ = _data9_->device;
#line 540 "../src/PulseAudioManager.vala"
					_tmp45_ = (*sink).name;
#line 540 "../src/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp44_, _tmp45_);
#line 541 "../src/PulseAudioManager.vala"
					_tmp46_ = _data9_->device;
#line 541 "../src/PulseAudioManager.vala"
					_tmp47_ = sound_device_get_card_sink_name (_tmp46_);
#line 541 "../src/PulseAudioManager.vala"
					_tmp48_ = _tmp47_;
#line 541 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:541: \t\t\tdevice.sink_name: %s", _tmp48_);
#line 542 "../src/PulseAudioManager.vala"
					_tmp49_ = _data9_->device;
#line 542 "../src/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp49_, (gint) (*sink).index);
#line 543 "../src/PulseAudioManager.vala"
					_tmp50_ = _data9_->device;
#line 543 "../src/PulseAudioManager.vala"
					_tmp51_ = (*sink).name;
#line 543 "../src/PulseAudioManager.vala"
					_tmp52_ = self->priv->default_sink_name;
#line 543 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp50_, g_strcmp0 (_tmp51_, _tmp52_) == 0);
#line 544 "../src/PulseAudioManager.vala"
					_tmp54_ = _data9_->device;
#line 544 "../src/PulseAudioManager.vala"
					_tmp55_ = sound_device_get_is_default (_tmp54_);
#line 544 "../src/PulseAudioManager.vala"
					_tmp56_ = _tmp55_;
#line 544 "../src/PulseAudioManager.vala"
					if (_tmp56_) {
#line 544 "../src/PulseAudioManager.vala"
						_tmp53_ = "true";
#line 4550 "PulseAudioManager.c"
					} else {
#line 544 "../src/PulseAudioManager.vala"
						_tmp53_ = "false";
#line 4554 "PulseAudioManager.c"
					}
#line 544 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:544: \t\t\tis_default: %s", _tmp53_);
#line 545 "../src/PulseAudioManager.vala"
					_tmp57_ = _data9_->device;
#line 545 "../src/PulseAudioManager.vala"
					sound_device_set_is_muted (_tmp57_, (*sink).mute != 0);
#line 546 "../src/PulseAudioManager.vala"
					_tmp58_ = _data9_->device;
#line 546 "../src/PulseAudioManager.vala"
					_tmp59_ = (*sink).volume;
#line 546 "../src/PulseAudioManager.vala"
					_tmp58_->cvolume = _tmp59_;
#line 547 "../src/PulseAudioManager.vala"
					_tmp60_ = _data9_->device;
#line 547 "../src/PulseAudioManager.vala"
					_tmp61_ = (*sink).channel_map;
#line 547 "../src/PulseAudioManager.vala"
					_tmp60_->channel_map = _tmp61_;
#line 548 "../src/PulseAudioManager.vala"
					_tmp62_ = _data9_->device;
#line 548 "../src/PulseAudioManager.vala"
					_tmp63_ = (*sink).channel_map;
#line 548 "../src/PulseAudioManager.vala"
					sound_device_set_balance (_tmp62_, pa_cvolume_get_balance (&(*sink).volume, &_tmp63_));
#line 549 "../src/PulseAudioManager.vala"
					_tmp64_ = _data9_->device;
#line 549 "../src/PulseAudioManager.vala"
					_tmp65_ = _tmp64_->volume_operations;
#line 549 "../src/PulseAudioManager.vala"
					gee_abstract_collection_foreach ((GeeAbstractCollection*) _tmp65_, _______lambda5__gee_forall_func, _data9_);
#line 557 "../src/PulseAudioManager.vala"
					_tmp66_ = _data9_->device;
#line 557 "../src/PulseAudioManager.vala"
					_tmp67_ = _tmp66_->volume_operations;
#line 557 "../src/PulseAudioManager.vala"
					_tmp68_ = gee_collection_get_is_empty ((GeeCollection*) _tmp67_);
#line 557 "../src/PulseAudioManager.vala"
					_tmp69_ = _tmp68_;
#line 557 "../src/PulseAudioManager.vala"
					if (_tmp69_) {
#line 4596 "PulseAudioManager.c"
						SoundDevice* _tmp70_;
#line 558 "../src/PulseAudioManager.vala"
						_tmp70_ = _data9_->device;
#line 558 "../src/PulseAudioManager.vala"
						sound_device_set_volume (_tmp70_, sound_pulse_audio_manager_volume_to_double (pa_cvolume_max (&(*sink).volume)));
#line 4602 "PulseAudioManager.c"
					}
#line 561 "../src/PulseAudioManager.vala"
					_tmp71_ = _data9_->device;
#line 561 "../src/PulseAudioManager.vala"
					_tmp72_ = sound_device_get_is_default (_tmp71_);
#line 561 "../src/PulseAudioManager.vala"
					_tmp73_ = _tmp72_;
#line 561 "../src/PulseAudioManager.vala"
					if (_tmp73_) {
#line 4612 "PulseAudioManager.c"
						SoundDevice* _tmp74_;
#line 562 "../src/PulseAudioManager.vala"
						_tmp74_ = _data9_->device;
#line 562 "../src/PulseAudioManager.vala"
						sound_pulse_audio_manager_set_default_output (self, _tmp74_);
#line 4618 "PulseAudioManager.c"
					}
				} else {
					SoundDevice* _tmp75_;
					SoundDevice* _tmp76_;
					SoundDevice* _tmp77_;
#line 566 "../src/PulseAudioManager.vala"
					_tmp75_ = _data9_->device;
#line 566 "../src/PulseAudioManager.vala"
					sound_device_set_sink_name (_tmp75_, NULL);
#line 567 "../src/PulseAudioManager.vala"
					_tmp76_ = _data9_->device;
#line 567 "../src/PulseAudioManager.vala"
					sound_device_set_sink_index (_tmp76_, -1);
#line 568 "../src/PulseAudioManager.vala"
					_tmp77_ = _data9_->device;
#line 568 "../src/PulseAudioManager.vala"
					sound_device_set_is_default (_tmp77_, FALSE);
#line 4636 "PulseAudioManager.c"
				}
			}
#line 531 "../src/PulseAudioManager.vala"
			block9_data_unref (_data9_);
#line 531 "../src/PulseAudioManager.vala"
			_data9_ = NULL;
#line 4643 "PulseAudioManager.c"
		}
#line 531 "../src/PulseAudioManager.vala"
		_g_object_unref0 (_device_it);
#line 4647 "PulseAudioManager.c"
	}
}

static void
_vala_array_add1 (pa_card_port_info** * array,
                  gint* length,
                  gint* size,
                  pa_card_port_info* value)
{
#line 595 "../src/PulseAudioManager.vala"
	if ((*length) == (*size)) {
#line 595 "../src/PulseAudioManager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 595 "../src/PulseAudioManager.vala"
		*array = g_renew (pa_card_port_info*, *array, *size);
#line 4663 "PulseAudioManager.c"
	}
#line 595 "../src/PulseAudioManager.vala"
	(*array)[(*length)++] = value;
#line 4667 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_card_info_callback (SoundPulseAudioManager* self,
                                              pa_context* c,
                                              pa_card_info* card,
                                              gint eol)
{
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	pa_card_profile_info2* _tmp3_;
	const gchar* _tmp4_;
	pa_proplist* _tmp5_;
	const gchar* _tmp6_;
	pa_proplist* _tmp7_;
	const gchar* _tmp8_;
	gchar* card_active_profile_name = NULL;
	pa_card_profile_info2* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	pa_card_port_info** relevant_ports = NULL;
	pa_card_port_info** _tmp12_;
	gint relevant_ports_length1;
	gint _relevant_ports_size_;
	pa_card_port_info** _tmp13_;
	gint _tmp13__length1;
	pa_card_port_info** _tmp16_;
	gint _tmp16__length1;
	GeeHashMap* _tmp124_;
	pa_card_port_info** _tmp125_;
	gint _tmp125__length1;
	pa_card_info _tmp126_;
	GeeHashMap* _tmp127_;
	pa_card_port_info** _tmp128_;
	gint _tmp128__length1;
	pa_card_info _tmp129_;
#line 574 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 574 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 575 "../src/PulseAudioManager.vala"
	if (card == NULL) {
#line 576 "../src/PulseAudioManager.vala"
		return;
#line 4713 "PulseAudioManager.c"
	}
#line 579 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:579: card info update");
#line 580 "../src/PulseAudioManager.vala"
	_tmp0_ = (*card).proplist;
#line 580 "../src/PulseAudioManager.vala"
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_DEVICE_DESCRIPTION);
#line 580 "../src/PulseAudioManager.vala"
	_tmp2_ = (*card).name;
#line 580 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:580: \tcard: %u %s (%s)", (guint) (*card).index, _tmp1_, _tmp2_);
#line 581 "../src/PulseAudioManager.vala"
	_tmp3_ = (*card).active_profile2;
#line 581 "../src/PulseAudioManager.vala"
	_tmp4_ = (*_tmp3_).name;
#line 581 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:581: \t\tactive profile: %s", _tmp4_);
#line 583 "../src/PulseAudioManager.vala"
	_tmp5_ = (*card).proplist;
#line 583 "../src/PulseAudioManager.vala"
	_tmp6_ = pa_proplist_gets (_tmp5_, PA_PROP_DEVICE_FORM_FACTOR);
#line 583 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:583: \t\tcard form factor: %s", _tmp6_);
#line 584 "../src/PulseAudioManager.vala"
	_tmp7_ = (*card).proplist;
#line 584 "../src/PulseAudioManager.vala"
	_tmp8_ = pa_proplist_gets (_tmp7_, PA_PROP_MEDIA_ICON_NAME);
#line 584 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:584: \t\tcard icon name: %s", _tmp8_);
#line 586 "../src/PulseAudioManager.vala"
	_tmp9_ = (*card).active_profile2;
#line 586 "../src/PulseAudioManager.vala"
	_tmp10_ = (*_tmp9_).name;
#line 586 "../src/PulseAudioManager.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 586 "../src/PulseAudioManager.vala"
	card_active_profile_name = _tmp11_;
#line 589 "../src/PulseAudioManager.vala"
	_tmp12_ = g_new0 (pa_card_port_info*, 0);
#line 589 "../src/PulseAudioManager.vala"
	relevant_ports = _tmp12_;
#line 589 "../src/PulseAudioManager.vala"
	relevant_ports_length1 = 0;
#line 589 "../src/PulseAudioManager.vala"
	_relevant_ports_size_ = relevant_ports_length1;
#line 590 "../src/PulseAudioManager.vala"
	_tmp13_ = (*card).ports;
#line 590 "../src/PulseAudioManager.vala"
	_tmp13__length1 = (*card).n_ports;
#line 4763 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 590 "../src/PulseAudioManager.vala"
		port_collection = _tmp13_;
#line 590 "../src/PulseAudioManager.vala"
		port_collection_length1 = _tmp13__length1;
#line 590 "../src/PulseAudioManager.vala"
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 4775 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 590 "../src/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 4779 "PulseAudioManager.c"
			{
				pa_card_port_info* _tmp14_;
				pa_card_port_info* _tmp15_;
#line 591 "../src/PulseAudioManager.vala"
				_tmp14_ = port;
#line 591 "../src/PulseAudioManager.vala"
				if ((*_tmp14_).available == PA_PORT_AVAILABLE_NO) {
#line 592 "../src/PulseAudioManager.vala"
					continue;
#line 4789 "PulseAudioManager.c"
				}
#line 595 "../src/PulseAudioManager.vala"
				_tmp15_ = port;
#line 595 "../src/PulseAudioManager.vala"
				_vala_array_add1 (&relevant_ports, &relevant_ports_length1, &_relevant_ports_size_, _tmp15_);
#line 4795 "PulseAudioManager.c"
			}
		}
	}
#line 599 "../src/PulseAudioManager.vala"
	_tmp16_ = relevant_ports;
#line 599 "../src/PulseAudioManager.vala"
	_tmp16__length1 = relevant_ports_length1;
#line 4803 "PulseAudioManager.c"
	{
		pa_card_port_info** port_collection = NULL;
		gint port_collection_length1 = 0;
		gint _port_collection_size_ = 0;
		gint port_it = 0;
#line 599 "../src/PulseAudioManager.vala"
		port_collection = _tmp16_;
#line 599 "../src/PulseAudioManager.vala"
		port_collection_length1 = _tmp16__length1;
#line 599 "../src/PulseAudioManager.vala"
		for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 4815 "PulseAudioManager.c"
			pa_card_port_info* port = NULL;
#line 599 "../src/PulseAudioManager.vala"
			port = port_collection[port_it];
#line 4819 "PulseAudioManager.c"
			{
				gboolean is_input = FALSE;
				pa_card_port_info* _tmp17_;
				const gchar* _tmp18_ = NULL;
				pa_card_port_info* _tmp19_;
				const gchar* _tmp20_;
				pa_card_port_info* _tmp21_;
				const gchar* _tmp22_;
				GeeHashMap* _tmp23_ = NULL;
				GeeHashMap* devices = NULL;
				GeeHashMap* _tmp26_;
				SoundDevice* device = NULL;
				gchar* id = NULL;
				pa_card_port_info* _tmp27_;
				pa_card_info _tmp28_;
				gchar* _tmp29_;
				gboolean is_new = FALSE;
				GeeHashMap* _tmp30_;
				const gchar* _tmp31_;
				SoundDevice* _tmp41_;
				const gchar* _tmp42_;
				SoundDevice* _tmp43_;
				SoundDevice* _tmp44_;
				const gchar* _tmp45_;
				SoundDevice* _tmp46_;
				pa_card_port_info* _tmp47_;
				const gchar* _tmp48_;
				SoundDevice* _tmp49_;
				pa_proplist* _tmp50_;
				const gchar* _tmp51_;
				SoundDevice* _tmp52_;
				pa_card_port_info* _tmp53_;
				pa_proplist* _tmp54_;
				const gchar* _tmp55_;
				SoundDevice* _tmp56_;
				const gchar* _tmp57_;
				const gchar* _tmp58_;
				SoundDevice* _tmp62_;
				pa_card_port_info* _tmp63_;
				pa_proplist* _tmp64_;
				const gchar* _tmp65_;
				SoundDevice* _tmp66_;
				const gchar* _tmp67_;
				const gchar* _tmp68_;
				gboolean _tmp72_ = FALSE;
				SoundDevice* _tmp73_;
				const gchar* _tmp74_;
				const gchar* _tmp75_;
				SoundDevice* _tmp95_;
				const gchar* _tmp96_;
				const gchar* _tmp97_;
				gboolean _tmp100_ = FALSE;
				SoundDevice* _tmp105_;
				pa_card_port_info* _tmp106_;
				GeeArrayList* _tmp107_;
				GeeArrayList* _tmp108_;
#line 600 "../src/PulseAudioManager.vala"
				_tmp17_ = port;
#line 600 "../src/PulseAudioManager.vala"
				is_input = ((*_tmp17_).direction & PA_DIRECTION_INPUT) == PA_DIRECTION_INPUT;
#line 601 "../src/PulseAudioManager.vala"
				if (is_input) {
#line 601 "../src/PulseAudioManager.vala"
					_tmp18_ = "input";
#line 4884 "PulseAudioManager.c"
				} else {
#line 601 "../src/PulseAudioManager.vala"
					_tmp18_ = "output";
#line 4888 "PulseAudioManager.c"
				}
#line 601 "../src/PulseAudioManager.vala"
				_tmp19_ = port;
#line 601 "../src/PulseAudioManager.vala"
				_tmp20_ = (*_tmp19_).description;
#line 601 "../src/PulseAudioManager.vala"
				_tmp21_ = port;
#line 601 "../src/PulseAudioManager.vala"
				_tmp22_ = (*_tmp21_).name;
#line 601 "../src/PulseAudioManager.vala"
				g_debug ("PulseAudioManager.vala:601: \t\t%s port: %s (%s)", _tmp18_, _tmp20_, _tmp22_);
#line 602 "../src/PulseAudioManager.vala"
				if (is_input) {
#line 4902 "PulseAudioManager.c"
					GeeHashMap* _tmp24_;
#line 602 "../src/PulseAudioManager.vala"
					_tmp24_ = self->priv->input_devices;
#line 602 "../src/PulseAudioManager.vala"
					_tmp23_ = _tmp24_;
#line 4908 "PulseAudioManager.c"
				} else {
					GeeHashMap* _tmp25_;
#line 602 "../src/PulseAudioManager.vala"
					_tmp25_ = self->priv->output_devices;
#line 602 "../src/PulseAudioManager.vala"
					_tmp23_ = _tmp25_;
#line 4915 "PulseAudioManager.c"
				}
#line 602 "../src/PulseAudioManager.vala"
				_tmp26_ = _g_object_ref0 (_tmp23_);
#line 602 "../src/PulseAudioManager.vala"
				devices = _tmp26_;
#line 603 "../src/PulseAudioManager.vala"
				device = NULL;
#line 604 "../src/PulseAudioManager.vala"
				_tmp27_ = port;
#line 604 "../src/PulseAudioManager.vala"
				_tmp28_ = *card;
#line 604 "../src/PulseAudioManager.vala"
				_tmp29_ = sound_pulse_audio_manager_get_device_id (&_tmp28_, _tmp27_);
#line 604 "../src/PulseAudioManager.vala"
				id = _tmp29_;
#line 605 "../src/PulseAudioManager.vala"
				_tmp30_ = devices;
#line 605 "../src/PulseAudioManager.vala"
				_tmp31_ = id;
#line 605 "../src/PulseAudioManager.vala"
				is_new = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp30_, _tmp31_);
#line 606 "../src/PulseAudioManager.vala"
				if (is_new) {
#line 4939 "PulseAudioManager.c"
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					pa_card_port_info* _tmp34_;
					const gchar* _tmp35_;
					SoundDevice* _tmp36_;
#line 607 "../src/PulseAudioManager.vala"
					_tmp32_ = id;
#line 607 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:607: \t\t\tnew device: %s", _tmp32_);
#line 608 "../src/PulseAudioManager.vala"
					_tmp33_ = id;
#line 608 "../src/PulseAudioManager.vala"
					_tmp34_ = port;
#line 608 "../src/PulseAudioManager.vala"
					_tmp35_ = (*_tmp34_).name;
#line 608 "../src/PulseAudioManager.vala"
					_tmp36_ = sound_device_new (_tmp33_, (*card).index, _tmp35_);
#line 608 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 608 "../src/PulseAudioManager.vala"
					device = _tmp36_;
#line 4961 "PulseAudioManager.c"
				} else {
					const gchar* _tmp37_;
					GeeHashMap* _tmp38_;
					const gchar* _tmp39_;
					gpointer _tmp40_;
#line 610 "../src/PulseAudioManager.vala"
					_tmp37_ = id;
#line 610 "../src/PulseAudioManager.vala"
					g_debug ("PulseAudioManager.vala:610: \t\t\tupdating device: %s", _tmp37_);
#line 611 "../src/PulseAudioManager.vala"
					_tmp38_ = devices;
#line 611 "../src/PulseAudioManager.vala"
					_tmp39_ = id;
#line 611 "../src/PulseAudioManager.vala"
					_tmp40_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp38_, _tmp39_);
#line 611 "../src/PulseAudioManager.vala"
					_g_object_unref0 (device);
#line 611 "../src/PulseAudioManager.vala"
					device = (SoundDevice*) _tmp40_;
#line 4981 "PulseAudioManager.c"
				}
#line 614 "../src/PulseAudioManager.vala"
				_tmp41_ = device;
#line 614 "../src/PulseAudioManager.vala"
				_tmp42_ = card_active_profile_name;
#line 614 "../src/PulseAudioManager.vala"
				sound_device_set_card_active_profile_name (_tmp41_, _tmp42_);
#line 615 "../src/PulseAudioManager.vala"
				_tmp43_ = device;
#line 615 "../src/PulseAudioManager.vala"
				sound_device_set_input (_tmp43_, is_input);
#line 616 "../src/PulseAudioManager.vala"
				_tmp44_ = device;
#line 616 "../src/PulseAudioManager.vala"
				_tmp45_ = (*card).name;
#line 616 "../src/PulseAudioManager.vala"
				sound_device_set_card_name (_tmp44_, _tmp45_);
#line 617 "../src/PulseAudioManager.vala"
				_tmp46_ = device;
#line 617 "../src/PulseAudioManager.vala"
				_tmp47_ = port;
#line 617 "../src/PulseAudioManager.vala"
				_tmp48_ = (*_tmp47_).description;
#line 617 "../src/PulseAudioManager.vala"
				sound_device_set_description (_tmp46_, _tmp48_);
#line 618 "../src/PulseAudioManager.vala"
				_tmp49_ = device;
#line 618 "../src/PulseAudioManager.vala"
				_tmp50_ = (*card).proplist;
#line 618 "../src/PulseAudioManager.vala"
				_tmp51_ = pa_proplist_gets (_tmp50_, PA_PROP_DEVICE_DESCRIPTION);
#line 618 "../src/PulseAudioManager.vala"
				sound_device_set_display_name (_tmp49_, _tmp51_);
#line 619 "../src/PulseAudioManager.vala"
				_tmp52_ = device;
#line 619 "../src/PulseAudioManager.vala"
				_tmp53_ = port;
#line 619 "../src/PulseAudioManager.vala"
				_tmp54_ = (*_tmp53_).proplist;
#line 619 "../src/PulseAudioManager.vala"
				_tmp55_ = pa_proplist_gets (_tmp54_, PA_PROP_DEVICE_FORM_FACTOR);
#line 619 "../src/PulseAudioManager.vala"
				sound_device_set_form_factor (_tmp52_, _tmp55_);
#line 620 "../src/PulseAudioManager.vala"
				_tmp56_ = device;
#line 620 "../src/PulseAudioManager.vala"
				_tmp57_ = sound_device_get_form_factor (_tmp56_);
#line 620 "../src/PulseAudioManager.vala"
				_tmp58_ = _tmp57_;
#line 620 "../src/PulseAudioManager.vala"
				if (_tmp58_ == NULL) {
#line 5033 "PulseAudioManager.c"
					SoundDevice* _tmp59_;
					pa_proplist* _tmp60_;
					const gchar* _tmp61_;
#line 621 "../src/PulseAudioManager.vala"
					_tmp59_ = device;
#line 621 "../src/PulseAudioManager.vala"
					_tmp60_ = (*card).proplist;
#line 621 "../src/PulseAudioManager.vala"
					_tmp61_ = pa_proplist_gets (_tmp60_, PA_PROP_DEVICE_FORM_FACTOR);
#line 621 "../src/PulseAudioManager.vala"
					sound_device_set_form_factor (_tmp59_, _tmp61_);
#line 5045 "PulseAudioManager.c"
				}
#line 624 "../src/PulseAudioManager.vala"
				_tmp62_ = device;
#line 624 "../src/PulseAudioManager.vala"
				_tmp63_ = port;
#line 624 "../src/PulseAudioManager.vala"
				_tmp64_ = (*_tmp63_).proplist;
#line 624 "../src/PulseAudioManager.vala"
				_tmp65_ = pa_proplist_gets (_tmp64_, PA_PROP_DEVICE_ICON_NAME);
#line 624 "../src/PulseAudioManager.vala"
				sound_device_set_icon_name (_tmp62_, _tmp65_);
#line 625 "../src/PulseAudioManager.vala"
				_tmp66_ = device;
#line 625 "../src/PulseAudioManager.vala"
				_tmp67_ = sound_device_get_icon_name (_tmp66_);
#line 625 "../src/PulseAudioManager.vala"
				_tmp68_ = _tmp67_;
#line 625 "../src/PulseAudioManager.vala"
				if (_tmp68_ == NULL) {
#line 5065 "PulseAudioManager.c"
					SoundDevice* _tmp69_;
					pa_proplist* _tmp70_;
					const gchar* _tmp71_;
#line 626 "../src/PulseAudioManager.vala"
					_tmp69_ = device;
#line 626 "../src/PulseAudioManager.vala"
					_tmp70_ = (*card).proplist;
#line 626 "../src/PulseAudioManager.vala"
					_tmp71_ = pa_proplist_gets (_tmp70_, PA_PROP_DEVICE_ICON_NAME);
#line 626 "../src/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp69_, _tmp71_);
#line 5077 "PulseAudioManager.c"
				}
#line 630 "../src/PulseAudioManager.vala"
				_tmp73_ = device;
#line 630 "../src/PulseAudioManager.vala"
				_tmp74_ = sound_device_get_icon_name (_tmp73_);
#line 630 "../src/PulseAudioManager.vala"
				_tmp75_ = _tmp74_;
#line 630 "../src/PulseAudioManager.vala"
				if (_tmp75_ == NULL) {
#line 5087 "PulseAudioManager.c"
					SoundDevice* _tmp76_;
					const gchar* _tmp77_;
					const gchar* _tmp78_;
#line 630 "../src/PulseAudioManager.vala"
					_tmp76_ = device;
#line 630 "../src/PulseAudioManager.vala"
					_tmp77_ = sound_device_get_form_factor (_tmp76_);
#line 630 "../src/PulseAudioManager.vala"
					_tmp78_ = _tmp77_;
#line 630 "../src/PulseAudioManager.vala"
					_tmp72_ = _tmp78_ != NULL;
#line 5099 "PulseAudioManager.c"
				} else {
#line 630 "../src/PulseAudioManager.vala"
					_tmp72_ = FALSE;
#line 5103 "PulseAudioManager.c"
				}
#line 630 "../src/PulseAudioManager.vala"
				if (_tmp72_) {
#line 5107 "PulseAudioManager.c"
					SoundDevice* _tmp79_;
					const gchar* _tmp80_;
					const gchar* _tmp81_;
					const gchar* _tmp82_;
					GQuark _tmp84_ = 0U;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label0 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label1 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label2 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label3 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label4 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label5 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label6 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label7 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label8 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label9 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label10 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label11 = 0;
#line 631 "../src/PulseAudioManager.vala"
					static GQuark _tmp83_label12 = 0;
#line 631 "../src/PulseAudioManager.vala"
					_tmp79_ = device;
#line 631 "../src/PulseAudioManager.vala"
					_tmp80_ = sound_device_get_form_factor (_tmp79_);
#line 631 "../src/PulseAudioManager.vala"
					_tmp81_ = _tmp80_;
#line 631 "../src/PulseAudioManager.vala"
					_tmp82_ = _tmp81_;
#line 631 "../src/PulseAudioManager.vala"
					_tmp84_ = (NULL == _tmp82_) ? 0 : g_quark_from_string (_tmp82_);
#line 631 "../src/PulseAudioManager.vala"
					if (_tmp84_ == ((0 != _tmp83_label0) ? _tmp83_label0 : (_tmp83_label0 = g_quark_from_static_string ("car")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5153 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp85_;
#line 633 "../src/PulseAudioManager.vala"
								_tmp85_ = device;
#line 633 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp85_, "audio-car");
#line 634 "../src/PulseAudioManager.vala"
								break;
#line 5163 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp84_ == ((0 != _tmp83_label1) ? _tmp83_label1 : (_tmp83_label1 = g_quark_from_static_string ("computer")))) || (_tmp84_ == ((0 != _tmp83_label2) ? _tmp83_label2 : (_tmp83_label2 = g_quark_from_static_string ("internal"))))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5169 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp86_;
#line 637 "../src/PulseAudioManager.vala"
								_tmp86_ = device;
#line 637 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp86_, "computer");
#line 638 "../src/PulseAudioManager.vala"
								break;
#line 5179 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label3) ? _tmp83_label3 : (_tmp83_label3 = g_quark_from_static_string ("handset")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5185 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp87_;
#line 640 "../src/PulseAudioManager.vala"
								_tmp87_ = device;
#line 640 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp87_, "phone");
#line 641 "../src/PulseAudioManager.vala"
								break;
#line 5195 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label4) ? _tmp83_label4 : (_tmp83_label4 = g_quark_from_static_string ("headphone")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5201 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp88_;
#line 643 "../src/PulseAudioManager.vala"
								_tmp88_ = device;
#line 643 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp88_, "audio-headphones");
#line 644 "../src/PulseAudioManager.vala"
								break;
#line 5211 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp84_ == ((0 != _tmp83_label5) ? _tmp83_label5 : (_tmp83_label5 = g_quark_from_static_string ("hands-free")))) || (_tmp84_ == ((0 != _tmp83_label6) ? _tmp83_label6 : (_tmp83_label6 = g_quark_from_static_string ("headset"))))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5217 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp89_;
#line 647 "../src/PulseAudioManager.vala"
								_tmp89_ = device;
#line 647 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp89_, "audio-headset");
#line 648 "../src/PulseAudioManager.vala"
								break;
#line 5227 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label7) ? _tmp83_label7 : (_tmp83_label7 = g_quark_from_static_string ("hifi")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5233 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp90_;
#line 650 "../src/PulseAudioManager.vala"
								_tmp90_ = device;
#line 650 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp90_, "audio-subwoofer");
#line 651 "../src/PulseAudioManager.vala"
								break;
#line 5243 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label8) ? _tmp83_label8 : (_tmp83_label8 = g_quark_from_static_string ("microphone")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5249 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp91_;
#line 653 "../src/PulseAudioManager.vala"
								_tmp91_ = device;
#line 653 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp91_, "audio-input-microphone");
#line 654 "../src/PulseAudioManager.vala"
								break;
#line 5259 "PulseAudioManager.c"
							}
						}
					} else if ((_tmp84_ == ((0 != _tmp83_label9) ? _tmp83_label9 : (_tmp83_label9 = g_quark_from_static_string ("portable")))) || (_tmp84_ == ((0 != _tmp83_label10) ? _tmp83_label10 : (_tmp83_label10 = g_quark_from_static_string ("speaker"))))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5265 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp92_;
#line 657 "../src/PulseAudioManager.vala"
								_tmp92_ = device;
#line 657 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp92_, "bluetooth");
#line 658 "../src/PulseAudioManager.vala"
								break;
#line 5275 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label11) ? _tmp83_label11 : (_tmp83_label11 = g_quark_from_static_string ("tv")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5281 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp93_;
#line 660 "../src/PulseAudioManager.vala"
								_tmp93_ = device;
#line 660 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp93_, "video-display-tv");
#line 661 "../src/PulseAudioManager.vala"
								break;
#line 5291 "PulseAudioManager.c"
							}
						}
					} else if (_tmp84_ == ((0 != _tmp83_label12) ? _tmp83_label12 : (_tmp83_label12 = g_quark_from_static_string ("webcam")))) {
#line 631 "../src/PulseAudioManager.vala"
						switch (0) {
#line 5297 "PulseAudioManager.c"
							default:
							{
								SoundDevice* _tmp94_;
#line 663 "../src/PulseAudioManager.vala"
								_tmp94_ = device;
#line 663 "../src/PulseAudioManager.vala"
								sound_device_set_icon_name (_tmp94_, "camera-web");
#line 664 "../src/PulseAudioManager.vala"
								break;
#line 5307 "PulseAudioManager.c"
							}
						}
					}
				}
#line 669 "../src/PulseAudioManager.vala"
				_tmp95_ = device;
#line 669 "../src/PulseAudioManager.vala"
				_tmp96_ = sound_device_get_icon_name (_tmp95_);
#line 669 "../src/PulseAudioManager.vala"
				_tmp97_ = _tmp96_;
#line 669 "../src/PulseAudioManager.vala"
				if (_tmp97_ == NULL) {
#line 5320 "PulseAudioManager.c"
					const gchar* _tmp98_ = NULL;
					SoundDevice* _tmp99_;
#line 670 "../src/PulseAudioManager.vala"
					if (is_input) {
#line 670 "../src/PulseAudioManager.vala"
						_tmp98_ = "audio-input-microphone";
#line 5327 "PulseAudioManager.c"
					} else {
#line 670 "../src/PulseAudioManager.vala"
						_tmp98_ = "audio-card";
#line 5331 "PulseAudioManager.c"
					}
#line 670 "../src/PulseAudioManager.vala"
					_tmp99_ = device;
#line 670 "../src/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp99_, _tmp98_);
#line 5337 "PulseAudioManager.c"
				}
#line 674 "../src/PulseAudioManager.vala"
				if (is_input) {
#line 5341 "PulseAudioManager.c"
					SoundDevice* _tmp101_;
					const gchar* _tmp102_;
					const gchar* _tmp103_;
#line 674 "../src/PulseAudioManager.vala"
					_tmp101_ = device;
#line 674 "../src/PulseAudioManager.vala"
					_tmp102_ = sound_device_get_icon_name (_tmp101_);
#line 674 "../src/PulseAudioManager.vala"
					_tmp103_ = _tmp102_;
#line 674 "../src/PulseAudioManager.vala"
					_tmp100_ = g_str_has_prefix (_tmp103_, "audio-card");
#line 5353 "PulseAudioManager.c"
				} else {
#line 674 "../src/PulseAudioManager.vala"
					_tmp100_ = FALSE;
#line 5357 "PulseAudioManager.c"
				}
#line 674 "../src/PulseAudioManager.vala"
				if (_tmp100_) {
#line 5361 "PulseAudioManager.c"
					SoundDevice* _tmp104_;
#line 675 "../src/PulseAudioManager.vala"
					_tmp104_ = device;
#line 675 "../src/PulseAudioManager.vala"
					sound_device_set_icon_name (_tmp104_, "audio-input-microphone");
#line 5367 "PulseAudioManager.c"
				}
#line 678 "../src/PulseAudioManager.vala"
				_tmp105_ = device;
#line 678 "../src/PulseAudioManager.vala"
				_tmp106_ = port;
#line 678 "../src/PulseAudioManager.vala"
				_tmp107_ = sound_pulse_audio_manager_get_relevant_card_port_profiles (self, _tmp106_);
#line 678 "../src/PulseAudioManager.vala"
				_tmp108_ = _tmp107_;
#line 678 "../src/PulseAudioManager.vala"
				sound_device_set_profiles (_tmp105_, _tmp108_);
#line 678 "../src/PulseAudioManager.vala"
				_g_object_unref0 (_tmp108_);
#line 679 "../src/PulseAudioManager.vala"
				if (sound_pulse_audio_manager_debug_enabled) {
#line 5383 "PulseAudioManager.c"
					{
						GeeArrayList* _profile_list = NULL;
						SoundDevice* _tmp109_;
						GeeArrayList* _tmp110_;
						GeeArrayList* _tmp111_;
						gint _profile_size = 0;
						GeeArrayList* _tmp112_;
						gint _tmp113_;
						gint _tmp114_;
						gint _profile_index = 0;
#line 680 "../src/PulseAudioManager.vala"
						_tmp109_ = device;
#line 680 "../src/PulseAudioManager.vala"
						_tmp110_ = sound_device_get_profiles (_tmp109_);
#line 680 "../src/PulseAudioManager.vala"
						_tmp111_ = _tmp110_;
#line 680 "../src/PulseAudioManager.vala"
						_profile_list = _tmp111_;
#line 680 "../src/PulseAudioManager.vala"
						_tmp112_ = _profile_list;
#line 680 "../src/PulseAudioManager.vala"
						_tmp113_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp112_);
#line 680 "../src/PulseAudioManager.vala"
						_tmp114_ = _tmp113_;
#line 680 "../src/PulseAudioManager.vala"
						_profile_size = _tmp114_;
#line 680 "../src/PulseAudioManager.vala"
						_profile_index = -1;
#line 680 "../src/PulseAudioManager.vala"
						while (TRUE) {
#line 5414 "PulseAudioManager.c"
							gint _tmp115_;
							gint _tmp116_;
							gchar* profile = NULL;
							GeeArrayList* _tmp117_;
							gpointer _tmp118_;
							const gchar* _tmp119_;
#line 680 "../src/PulseAudioManager.vala"
							_profile_index = _profile_index + 1;
#line 680 "../src/PulseAudioManager.vala"
							_tmp115_ = _profile_index;
#line 680 "../src/PulseAudioManager.vala"
							_tmp116_ = _profile_size;
#line 680 "../src/PulseAudioManager.vala"
							if (!(_tmp115_ < _tmp116_)) {
#line 680 "../src/PulseAudioManager.vala"
								break;
#line 5431 "PulseAudioManager.c"
							}
#line 680 "../src/PulseAudioManager.vala"
							_tmp117_ = _profile_list;
#line 680 "../src/PulseAudioManager.vala"
							_tmp118_ = gee_abstract_list_get ((GeeAbstractList*) _tmp117_, _profile_index);
#line 680 "../src/PulseAudioManager.vala"
							profile = (gchar*) _tmp118_;
#line 681 "../src/PulseAudioManager.vala"
							_tmp119_ = profile;
#line 681 "../src/PulseAudioManager.vala"
							g_debug ("PulseAudioManager.vala:681: \t\t\tprofile: %s", _tmp119_);
#line 680 "../src/PulseAudioManager.vala"
							_g_free0 (profile);
#line 5445 "PulseAudioManager.c"
						}
					}
				}
#line 685 "../src/PulseAudioManager.vala"
				if (is_new) {
#line 5451 "PulseAudioManager.c"
					GeeHashMap* _tmp120_;
					const gchar* _tmp121_;
					SoundDevice* _tmp122_;
					SoundDevice* _tmp123_;
#line 686 "../src/PulseAudioManager.vala"
					_tmp120_ = devices;
#line 686 "../src/PulseAudioManager.vala"
					_tmp121_ = id;
#line 686 "../src/PulseAudioManager.vala"
					_tmp122_ = device;
#line 686 "../src/PulseAudioManager.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp120_, _tmp121_, _tmp122_);
#line 687 "../src/PulseAudioManager.vala"
					_tmp123_ = device;
#line 687 "../src/PulseAudioManager.vala"
					g_signal_emit (self, sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL], 0, _tmp123_);
#line 5468 "PulseAudioManager.c"
				}
#line 599 "../src/PulseAudioManager.vala"
				_g_free0 (id);
#line 599 "../src/PulseAudioManager.vala"
				_g_object_unref0 (device);
#line 599 "../src/PulseAudioManager.vala"
				_g_object_unref0 (devices);
#line 5476 "PulseAudioManager.c"
			}
		}
	}
#line 691 "../src/PulseAudioManager.vala"
	_tmp124_ = self->priv->output_devices;
#line 691 "../src/PulseAudioManager.vala"
	_tmp125_ = relevant_ports;
#line 691 "../src/PulseAudioManager.vala"
	_tmp125__length1 = relevant_ports_length1;
#line 691 "../src/PulseAudioManager.vala"
	_tmp126_ = *card;
#line 691 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp124_, &_tmp126_, _tmp125_, (gint) _tmp125__length1);
#line 692 "../src/PulseAudioManager.vala"
	_tmp127_ = self->priv->input_devices;
#line 692 "../src/PulseAudioManager.vala"
	_tmp128_ = relevant_ports;
#line 692 "../src/PulseAudioManager.vala"
	_tmp128__length1 = relevant_ports_length1;
#line 692 "../src/PulseAudioManager.vala"
	_tmp129_ = *card;
#line 692 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_cleanup_devices (self, _tmp127_, &_tmp129_, _tmp128_, (gint) _tmp128__length1);
#line 574 "../src/PulseAudioManager.vala"
	relevant_ports = (g_free (relevant_ports), NULL);
#line 574 "../src/PulseAudioManager.vala"
	_g_free0 (card_active_profile_name);
#line 5504 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_cleanup_devices (SoundPulseAudioManager* self,
                                           GeeHashMap* devices,
                                           pa_card_info* card,
                                           pa_card_port_info** relevant_ports,
                                           gint relevant_ports_length1)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 696 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 696 "../src/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 696 "../src/PulseAudioManager.vala"
	g_return_if_fail (card != NULL);
#line 697 "../src/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 697 "../src/PulseAudioManager.vala"
	iter = _tmp0_;
#line 698 "../src/PulseAudioManager.vala"
	while (TRUE) {
#line 5528 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
		pa_card_info _tmp7_;
		gboolean found = FALSE;
#line 698 "../src/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 698 "../src/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 698 "../src/PulseAudioManager.vala"
			break;
#line 5544 "PulseAudioManager.c"
		}
#line 699 "../src/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 699 "../src/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 699 "../src/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 700 "../src/PulseAudioManager.vala"
		_tmp4_ = device;
#line 700 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 700 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 700 "../src/PulseAudioManager.vala"
		_tmp7_ = *card;
#line 700 "../src/PulseAudioManager.vala"
		if (_tmp6_ != _tmp7_.index) {
#line 701 "../src/PulseAudioManager.vala"
			_g_object_unref0 (device);
#line 701 "../src/PulseAudioManager.vala"
			continue;
#line 5566 "PulseAudioManager.c"
		}
#line 705 "../src/PulseAudioManager.vala"
		found = FALSE;
#line 5570 "PulseAudioManager.c"
		{
			pa_card_port_info** port_collection = NULL;
			gint port_collection_length1 = 0;
			gint _port_collection_size_ = 0;
			gint port_it = 0;
#line 706 "../src/PulseAudioManager.vala"
			port_collection = relevant_ports;
#line 706 "../src/PulseAudioManager.vala"
			port_collection_length1 = relevant_ports_length1;
#line 706 "../src/PulseAudioManager.vala"
			for (port_it = 0; port_it < port_collection_length1; port_it = port_it + 1) {
#line 5582 "PulseAudioManager.c"
				pa_card_port_info* port = NULL;
#line 706 "../src/PulseAudioManager.vala"
				port = port_collection[port_it];
#line 5586 "PulseAudioManager.c"
				{
					SoundDevice* _tmp8_;
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					pa_card_info _tmp11_;
					pa_card_port_info* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gboolean _tmp15_;
#line 707 "../src/PulseAudioManager.vala"
					_tmp8_ = device;
#line 707 "../src/PulseAudioManager.vala"
					_tmp9_ = sound_device_get_id (_tmp8_);
#line 707 "../src/PulseAudioManager.vala"
					_tmp10_ = _tmp9_;
#line 707 "../src/PulseAudioManager.vala"
					_tmp11_ = *card;
#line 707 "../src/PulseAudioManager.vala"
					_tmp12_ = port;
#line 707 "../src/PulseAudioManager.vala"
					_tmp13_ = sound_pulse_audio_manager_get_device_id (&_tmp11_, _tmp12_);
#line 707 "../src/PulseAudioManager.vala"
					_tmp14_ = _tmp13_;
#line 707 "../src/PulseAudioManager.vala"
					_tmp15_ = g_strcmp0 (_tmp10_, _tmp14_) == 0;
#line 707 "../src/PulseAudioManager.vala"
					_g_free0 (_tmp14_);
#line 707 "../src/PulseAudioManager.vala"
					if (_tmp15_) {
#line 708 "../src/PulseAudioManager.vala"
						found = TRUE;
#line 709 "../src/PulseAudioManager.vala"
						break;
#line 5620 "PulseAudioManager.c"
					}
				}
			}
		}
#line 713 "../src/PulseAudioManager.vala"
		if (!found) {
#line 5627 "PulseAudioManager.c"
			SoundDevice* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			SoundDevice* _tmp19_;
			GeeMapIterator* _tmp20_;
#line 714 "../src/PulseAudioManager.vala"
			_tmp16_ = device;
#line 714 "../src/PulseAudioManager.vala"
			_tmp17_ = sound_device_get_id (_tmp16_);
#line 714 "../src/PulseAudioManager.vala"
			_tmp18_ = _tmp17_;
#line 714 "../src/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:714: \t\tremoving device: %s", _tmp18_);
#line 715 "../src/PulseAudioManager.vala"
			_tmp19_ = device;
#line 715 "../src/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp19_, "removed");
#line 716 "../src/PulseAudioManager.vala"
			_tmp20_ = iter;
#line 716 "../src/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp20_);
#line 5649 "PulseAudioManager.c"
		}
#line 698 "../src/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5653 "PulseAudioManager.c"
	}
#line 696 "../src/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5657 "PulseAudioManager.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 5670 "PulseAudioManager.c"
}

static gchar*
sound_pulse_audio_manager_get_device_id (pa_card_info* card,
                                         pa_card_port_info* port)
{
	pa_card_info _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 721 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (card != NULL, NULL);
#line 722 "../src/PulseAudioManager.vala"
	_tmp0_ = *card;
#line 722 "../src/PulseAudioManager.vala"
	_tmp1_ = _tmp0_.name;
#line 722 "../src/PulseAudioManager.vala"
	_tmp2_ = string_to_string (_tmp1_);
#line 722 "../src/PulseAudioManager.vala"
	_tmp3_ = (*port).name;
#line 722 "../src/PulseAudioManager.vala"
	_tmp4_ = string_to_string (_tmp3_);
#line 722 "../src/PulseAudioManager.vala"
	_tmp5_ = g_strconcat (_tmp2_, ":", _tmp4_, NULL);
#line 722 "../src/PulseAudioManager.vala"
	result = _tmp5_;
#line 722 "../src/PulseAudioManager.vala"
	return result;
#line 5702 "PulseAudioManager.c"
}

static pa_card_profile_info2**
_vala_array_dup1 (pa_card_profile_info2** self,
                  gssize length)
{
#line 726 "../src/PulseAudioManager.vala"
	if (length > 0) {
#line 726 "../src/PulseAudioManager.vala"
		return _vala_memdup2 (self, length * sizeof (pa_card_profile_info2*));
#line 5713 "PulseAudioManager.c"
	}
#line 726 "../src/PulseAudioManager.vala"
	return NULL;
#line 5717 "PulseAudioManager.c"
}

static gint
__lambda7_ (SoundPulseAudioManager* self,
            pa_card_profile_info2* a,
            pa_card_profile_info2* b)
{
	gint result;
#line 730 "../src/PulseAudioManager.vala"
	if ((*a).priority > (*b).priority) {
#line 731 "../src/PulseAudioManager.vala"
		result = -1;
#line 731 "../src/PulseAudioManager.vala"
		return result;
#line 5732 "PulseAudioManager.c"
	}
#line 734 "../src/PulseAudioManager.vala"
	if ((*a).priority < (*b).priority) {
#line 735 "../src/PulseAudioManager.vala"
		result = 1;
#line 735 "../src/PulseAudioManager.vala"
		return result;
#line 5740 "PulseAudioManager.c"
	}
#line 738 "../src/PulseAudioManager.vala"
	result = 0;
#line 738 "../src/PulseAudioManager.vala"
	return result;
#line 5746 "PulseAudioManager.c"
}

static gint
___lambda7__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda7_ ((SoundPulseAudioManager*) self, a, b);
#line 729 "../src/PulseAudioManager.vala"
	return result;
#line 5758 "PulseAudioManager.c"
}

static GeeArrayList*
sound_pulse_audio_manager_get_relevant_card_port_profiles (SoundPulseAudioManager* self,
                                                           pa_card_port_info* port)
{
	GeeArrayList* profiles_list = NULL;
	pa_card_profile_info2** _tmp0_;
	gint _tmp0__length1;
	pa_card_profile_info2** _tmp1_;
	gint _tmp1__length1;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* profiles = NULL;
	GeeArrayList* _tmp4_;
	GeeArrayList* result;
#line 725 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 726 "../src/PulseAudioManager.vala"
	_tmp0_ = (*port).profiles2;
#line 726 "../src/PulseAudioManager.vala"
	_tmp0__length1 = (*port).n_profiles;
#line 726 "../src/PulseAudioManager.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 726 "../src/PulseAudioManager.vala"
	_tmp1__length1 = _tmp0__length1;
#line 726 "../src/PulseAudioManager.vala"
	_tmp2_ = gee_array_list_new_wrap (G_TYPE_POINTER, NULL, NULL, _tmp1_, _tmp1__length1, NULL, NULL, NULL);
#line 726 "../src/PulseAudioManager.vala"
	profiles_list = _tmp2_;
#line 729 "../src/PulseAudioManager.vala"
	_tmp3_ = profiles_list;
#line 729 "../src/PulseAudioManager.vala"
	gee_list_sort ((GeeList*) _tmp3_, ___lambda7__gcompare_data_func, g_object_ref (self), g_object_unref);
#line 742 "../src/PulseAudioManager.vala"
	_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 742 "../src/PulseAudioManager.vala"
	profiles = _tmp4_;
#line 5797 "PulseAudioManager.c"
	{
		GeeArrayList* _item_list = NULL;
		GeeArrayList* _tmp5_;
		gint _item_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _item_index = 0;
#line 743 "../src/PulseAudioManager.vala"
		_tmp5_ = profiles_list;
#line 743 "../src/PulseAudioManager.vala"
		_item_list = _tmp5_;
#line 743 "../src/PulseAudioManager.vala"
		_tmp6_ = _item_list;
#line 743 "../src/PulseAudioManager.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 743 "../src/PulseAudioManager.vala"
		_tmp8_ = _tmp7_;
#line 743 "../src/PulseAudioManager.vala"
		_item_size = _tmp8_;
#line 743 "../src/PulseAudioManager.vala"
		_item_index = -1;
#line 743 "../src/PulseAudioManager.vala"
		while (TRUE) {
#line 5822 "PulseAudioManager.c"
			gint _tmp9_;
			gint _tmp10_;
			pa_card_profile_info2* item = NULL;
			GeeArrayList* _tmp11_;
			gpointer _tmp12_;
			GeeArrayList* _tmp13_;
			pa_card_profile_info2* _tmp14_;
			const gchar* _tmp15_;
#line 743 "../src/PulseAudioManager.vala"
			_item_index = _item_index + 1;
#line 743 "../src/PulseAudioManager.vala"
			_tmp9_ = _item_index;
#line 743 "../src/PulseAudioManager.vala"
			_tmp10_ = _item_size;
#line 743 "../src/PulseAudioManager.vala"
			if (!(_tmp9_ < _tmp10_)) {
#line 743 "../src/PulseAudioManager.vala"
				break;
#line 5841 "PulseAudioManager.c"
			}
#line 743 "../src/PulseAudioManager.vala"
			_tmp11_ = _item_list;
#line 743 "../src/PulseAudioManager.vala"
			_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, _item_index);
#line 743 "../src/PulseAudioManager.vala"
			item = _tmp12_;
#line 744 "../src/PulseAudioManager.vala"
			_tmp13_ = profiles;
#line 744 "../src/PulseAudioManager.vala"
			_tmp14_ = item;
#line 744 "../src/PulseAudioManager.vala"
			_tmp15_ = (*_tmp14_).name;
#line 744 "../src/PulseAudioManager.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp15_);
#line 5857 "PulseAudioManager.c"
		}
	}
#line 747 "../src/PulseAudioManager.vala"
	result = profiles;
#line 747 "../src/PulseAudioManager.vala"
	_g_object_unref0 (profiles_list);
#line 747 "../src/PulseAudioManager.vala"
	return result;
#line 5866 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_remove_devices_by_card (SoundPulseAudioManager* self,
                                                  GeeHashMap* devices,
                                                  guint32 card_index)
{
	GeeMapIterator* iter = NULL;
	GeeMapIterator* _tmp0_;
#line 750 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 750 "../src/PulseAudioManager.vala"
	g_return_if_fail (devices != NULL);
#line 751 "../src/PulseAudioManager.vala"
	_tmp0_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) devices);
#line 751 "../src/PulseAudioManager.vala"
	iter = _tmp0_;
#line 752 "../src/PulseAudioManager.vala"
	while (TRUE) {
#line 5886 "PulseAudioManager.c"
		GeeMapIterator* _tmp1_;
		SoundDevice* device = NULL;
		GeeMapIterator* _tmp2_;
		gpointer _tmp3_;
		SoundDevice* _tmp4_;
		guint32 _tmp5_;
		guint32 _tmp6_;
#line 752 "../src/PulseAudioManager.vala"
		_tmp1_ = iter;
#line 752 "../src/PulseAudioManager.vala"
		if (!gee_map_iterator_next (_tmp1_)) {
#line 752 "../src/PulseAudioManager.vala"
			break;
#line 5900 "PulseAudioManager.c"
		}
#line 753 "../src/PulseAudioManager.vala"
		_tmp2_ = iter;
#line 753 "../src/PulseAudioManager.vala"
		_tmp3_ = gee_map_iterator_get_value (_tmp2_);
#line 753 "../src/PulseAudioManager.vala"
		device = (SoundDevice*) _tmp3_;
#line 754 "../src/PulseAudioManager.vala"
		_tmp4_ = device;
#line 754 "../src/PulseAudioManager.vala"
		_tmp5_ = sound_device_get_card_index (_tmp4_);
#line 754 "../src/PulseAudioManager.vala"
		_tmp6_ = _tmp5_;
#line 754 "../src/PulseAudioManager.vala"
		if (_tmp6_ == card_index) {
#line 5916 "PulseAudioManager.c"
			SoundDevice* _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			SoundDevice* _tmp10_;
			GeeMapIterator* _tmp11_;
#line 755 "../src/PulseAudioManager.vala"
			_tmp7_ = device;
#line 755 "../src/PulseAudioManager.vala"
			_tmp8_ = sound_device_get_id (_tmp7_);
#line 755 "../src/PulseAudioManager.vala"
			_tmp9_ = _tmp8_;
#line 755 "../src/PulseAudioManager.vala"
			g_debug ("PulseAudioManager.vala:755: removing device: %s", _tmp9_);
#line 756 "../src/PulseAudioManager.vala"
			_tmp10_ = device;
#line 756 "../src/PulseAudioManager.vala"
			g_signal_emit_by_name (_tmp10_, "removed");
#line 757 "../src/PulseAudioManager.vala"
			_tmp11_ = iter;
#line 757 "../src/PulseAudioManager.vala"
			gee_map_iterator_unset (_tmp11_);
#line 5938 "PulseAudioManager.c"
		}
#line 752 "../src/PulseAudioManager.vala"
		_g_object_unref0 (device);
#line 5942 "PulseAudioManager.c"
	}
#line 750 "../src/PulseAudioManager.vala"
	_g_object_unref0 (iter);
#line 5946 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                         pa_ext_stream_restore_info* info,
                                                                                                         gint eol,
                                                                                                         gpointer self)
{
#line 776 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_sink_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5957 "PulseAudioManager.c"
}

static void
_sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb (pa_context* c,
                                                                                                           pa_ext_stream_restore_info* info,
                                                                                                           gint eol,
                                                                                                           gpointer self)
{
#line 787 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_ext_stream_restore_read_source_callback ((SoundPulseAudioManager*) self, c, info, eol);
#line 5968 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_server_info_callback (SoundPulseAudioManager* self,
                                                pa_context* context,
                                                pa_server_info* server)
{
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp12_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	pa_operation* _tmp24_;
	pa_operation* _tmp25_;
	pa_operation* _tmp26_;
	pa_operation* _tmp27_;
	pa_operation* _tmp28_;
	pa_operation* _tmp29_;
#line 762 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 762 "../src/PulseAudioManager.vala"
	g_return_if_fail (context != NULL);
#line 763 "../src/PulseAudioManager.vala"
	g_debug ("PulseAudioManager.vala:763: server info update");
#line 764 "../src/PulseAudioManager.vala"
	if (server == NULL) {
#line 765 "../src/PulseAudioManager.vala"
		return;
#line 5998 "PulseAudioManager.c"
	}
#line 768 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->default_sink_name;
#line 768 "../src/PulseAudioManager.vala"
	if (_tmp0_ == NULL) {
#line 6004 "PulseAudioManager.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
#line 769 "../src/PulseAudioManager.vala"
		_tmp1_ = (*server).default_sink_name;
#line 769 "../src/PulseAudioManager.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 769 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 769 "../src/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp2_;
#line 770 "../src/PulseAudioManager.vala"
		_tmp3_ = self->priv->default_sink_name;
#line 770 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:770: \tdefault_sink_name: %s", _tmp3_);
#line 6020 "PulseAudioManager.c"
	}
#line 773 "../src/PulseAudioManager.vala"
	_tmp4_ = self->priv->default_sink_name;
#line 773 "../src/PulseAudioManager.vala"
	_tmp5_ = (*server).default_sink_name;
#line 773 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp4_, _tmp5_) != 0) {
#line 6028 "PulseAudioManager.c"
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		pa_operation* _tmp10_;
		pa_operation* _tmp11_;
#line 774 "../src/PulseAudioManager.vala"
		_tmp6_ = self->priv->default_sink_name;
#line 774 "../src/PulseAudioManager.vala"
		_tmp7_ = (*server).default_sink_name;
#line 774 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:774: \tdefault_sink_name: %s > %s", _tmp6_, _tmp7_);
#line 775 "../src/PulseAudioManager.vala"
		_tmp8_ = (*server).default_sink_name;
#line 775 "../src/PulseAudioManager.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 775 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_sink_name);
#line 775 "../src/PulseAudioManager.vala"
		self->priv->default_sink_name = _tmp9_;
#line 776 "../src/PulseAudioManager.vala"
		_tmp10_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_sink_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 776 "../src/PulseAudioManager.vala"
		_tmp11_ = _tmp10_;
#line 776 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp11_);
#line 6055 "PulseAudioManager.c"
	}
#line 779 "../src/PulseAudioManager.vala"
	_tmp12_ = self->priv->default_source_name;
#line 779 "../src/PulseAudioManager.vala"
	if (_tmp12_ == NULL) {
#line 6061 "PulseAudioManager.c"
		const gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
#line 780 "../src/PulseAudioManager.vala"
		_tmp13_ = (*server).default_source_name;
#line 780 "../src/PulseAudioManager.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 780 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 780 "../src/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp14_;
#line 781 "../src/PulseAudioManager.vala"
		_tmp15_ = self->priv->default_source_name;
#line 781 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:781: \tdefault_source_name: %s", _tmp15_);
#line 6077 "PulseAudioManager.c"
	}
#line 784 "../src/PulseAudioManager.vala"
	_tmp16_ = self->priv->default_source_name;
#line 784 "../src/PulseAudioManager.vala"
	_tmp17_ = (*server).default_source_name;
#line 784 "../src/PulseAudioManager.vala"
	if (g_strcmp0 (_tmp16_, _tmp17_) != 0) {
#line 6085 "PulseAudioManager.c"
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		pa_operation* _tmp22_;
		pa_operation* _tmp23_;
#line 785 "../src/PulseAudioManager.vala"
		_tmp18_ = self->priv->default_source_name;
#line 785 "../src/PulseAudioManager.vala"
		_tmp19_ = (*server).default_source_name;
#line 785 "../src/PulseAudioManager.vala"
		g_debug ("PulseAudioManager.vala:785: \tdefault_source_name: %s > %s", _tmp18_, _tmp19_);
#line 786 "../src/PulseAudioManager.vala"
		_tmp20_ = (*server).default_source_name;
#line 786 "../src/PulseAudioManager.vala"
		_tmp21_ = g_strdup (_tmp20_);
#line 786 "../src/PulseAudioManager.vala"
		_g_free0 (self->priv->default_source_name);
#line 786 "../src/PulseAudioManager.vala"
		self->priv->default_source_name = _tmp21_;
#line 787 "../src/PulseAudioManager.vala"
		_tmp22_ = pa_ext_stream_restore_read (context, _sound_pulse_audio_manager_ext_stream_restore_read_source_callback_pulse_audio_ext_stream_restore_read_cb, self);
#line 787 "../src/PulseAudioManager.vala"
		_tmp23_ = _tmp22_;
#line 787 "../src/PulseAudioManager.vala"
		_pa_operation_unref0 (_tmp23_);
#line 6112 "PulseAudioManager.c"
	}
#line 792 "../src/PulseAudioManager.vala"
	_tmp24_ = pa_context_get_card_info_list (context, _sound_pulse_audio_manager_card_info_callback_pa_card_info_cb_t, self);
#line 792 "../src/PulseAudioManager.vala"
	_tmp25_ = _tmp24_;
#line 792 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp25_);
#line 793 "../src/PulseAudioManager.vala"
	_tmp26_ = pa_context_get_source_info_list (context, _sound_pulse_audio_manager_source_info_callback_pa_source_info_cb_t, self);
#line 793 "../src/PulseAudioManager.vala"
	_tmp27_ = _tmp26_;
#line 793 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp27_);
#line 794 "../src/PulseAudioManager.vala"
	_tmp28_ = pa_context_get_sink_info_list (context, _sound_pulse_audio_manager_sink_info_callback_pa_sink_info_cb_t, self);
#line 794 "../src/PulseAudioManager.vala"
	_tmp29_ = _tmp28_;
#line 794 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp29_);
#line 6132 "PulseAudioManager.c"
}

static void
__lambda6_ (SoundPulseAudioManager* self,
            pa_context* c,
            gint success)
{
#line 813 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 814 "../src/PulseAudioManager.vala"
	if (success != 1) {
#line 815 "../src/PulseAudioManager.vala"
		g_warning ("PulseAudioManager.vala:815: Updating source failed");
#line 6146 "PulseAudioManager.c"
	}
}

static void
___lambda6__pa_context_success_cb_t (pa_context* c,
                                     gint success,
                                     gpointer self)
{
#line 813 "../src/PulseAudioManager.vala"
	__lambda6_ ((SoundPulseAudioManager*) self, c, success);
#line 6157 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_sink_callback (SoundPulseAudioManager* self,
                                                                 pa_context* c,
                                                                 pa_ext_stream_restore_info* info,
                                                                 gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 801 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 801 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 802 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 802 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 6186 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 802 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 802 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "sink-input-by");
#line 6193 "PulseAudioManager.c"
	}
#line 802 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 803 "../src/PulseAudioManager.vala"
		return;
#line 6199 "PulseAudioManager.c"
	}
#line 807 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 808 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 808 "../src/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 809 "../src/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 809 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 810 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 810 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 811 "../src/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 812 "../src/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_sink_name;
#line 812 "../src/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 813 "../src/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 813 "../src/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 813 "../src/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 813 "../src/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 813 "../src/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 813 "../src/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, ___lambda6__pa_context_success_cb_t, self);
#line 813 "../src/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 813 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 813 "../src/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 6239 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_ext_stream_restore_read_source_callback (SoundPulseAudioManager* self,
                                                                   pa_context* c,
                                                                   pa_ext_stream_restore_info* info,
                                                                   gint eol)
{
	gboolean _tmp0_ = FALSE;
	pa_ext_stream_restore_info new_info = {0};
	const gchar* _tmp2_;
	pa_channel_map _tmp3_;
	pa_cvolume _tmp4_;
	const gchar* _tmp5_;
	pa_ext_stream_restore_info _tmp6_;
	pa_ext_stream_restore_info* _tmp7_;
	pa_ext_stream_restore_info* _tmp8_;
	gint _tmp8__length1;
	pa_operation* _tmp9_;
	pa_operation* _tmp10_;
#line 820 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 820 "../src/PulseAudioManager.vala"
	g_return_if_fail (c != NULL);
#line 821 "../src/PulseAudioManager.vala"
	if (eol != 0) {
#line 821 "../src/PulseAudioManager.vala"
		_tmp0_ = TRUE;
#line 6268 "PulseAudioManager.c"
	} else {
		const gchar* _tmp1_;
#line 821 "../src/PulseAudioManager.vala"
		_tmp1_ = (*info).name;
#line 821 "../src/PulseAudioManager.vala"
		_tmp0_ = !g_str_has_prefix (_tmp1_, "source-output-by");
#line 6275 "PulseAudioManager.c"
	}
#line 821 "../src/PulseAudioManager.vala"
	if (_tmp0_) {
#line 822 "../src/PulseAudioManager.vala"
		return;
#line 6281 "PulseAudioManager.c"
	}
#line 826 "../src/PulseAudioManager.vala"
	memset (&new_info, 0, sizeof (pa_ext_stream_restore_info));
#line 827 "../src/PulseAudioManager.vala"
	_tmp2_ = (*info).name;
#line 827 "../src/PulseAudioManager.vala"
	new_info.name = _tmp2_;
#line 828 "../src/PulseAudioManager.vala"
	_tmp3_ = (*info).channel_map;
#line 828 "../src/PulseAudioManager.vala"
	new_info.channel_map = _tmp3_;
#line 829 "../src/PulseAudioManager.vala"
	_tmp4_ = (*info).volume;
#line 829 "../src/PulseAudioManager.vala"
	new_info.volume = _tmp4_;
#line 830 "../src/PulseAudioManager.vala"
	new_info.mute = (*info).mute;
#line 831 "../src/PulseAudioManager.vala"
	_tmp5_ = self->priv->default_source_name;
#line 831 "../src/PulseAudioManager.vala"
	new_info.device = _tmp5_;
#line 832 "../src/PulseAudioManager.vala"
	_tmp6_ = new_info;
#line 832 "../src/PulseAudioManager.vala"
	_tmp7_ = g_new0 (pa_ext_stream_restore_info, 1);
#line 832 "../src/PulseAudioManager.vala"
	_tmp7_[0] = _tmp6_;
#line 832 "../src/PulseAudioManager.vala"
	_tmp8_ = _tmp7_;
#line 832 "../src/PulseAudioManager.vala"
	_tmp8__length1 = 1;
#line 832 "../src/PulseAudioManager.vala"
	_tmp9_ = pa_ext_stream_restore_write (c, PA_UPDATE_REPLACE, _tmp8_, (gint) 1, 1, NULL, NULL);
#line 832 "../src/PulseAudioManager.vala"
	_tmp10_ = _tmp9_;
#line 832 "../src/PulseAudioManager.vala"
	_pa_operation_unref0 (_tmp10_);
#line 832 "../src/PulseAudioManager.vala"
	_tmp8_ = (g_free (_tmp8_), NULL);
#line 6321 "PulseAudioManager.c"
}

static gdouble
sound_pulse_audio_manager_volume_to_double (pa_volume_t vol)
{
	gdouble tmp = 0.0;
	gdouble result;
#line 840 "../src/PulseAudioManager.vala"
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
#line 841 "../src/PulseAudioManager.vala"
	result = (100 * tmp) / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
#line 841 "../src/PulseAudioManager.vala"
	return result;
#line 6335 "PulseAudioManager.c"
}

static pa_volume_t
sound_pulse_audio_manager_double_to_volume (gdouble vol)
{
	gdouble tmp = 0.0;
	pa_volume_t result;
#line 845 "../src/PulseAudioManager.vala"
	tmp = (((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol) / 100;
#line 846 "../src/PulseAudioManager.vala"
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
#line 846 "../src/PulseAudioManager.vala"
	return result;
#line 6349 "PulseAudioManager.c"
}

pa_context*
sound_pulse_audio_manager_get_context (SoundPulseAudioManager* self)
{
	pa_context* result;
	pa_context* _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_context;
#line 43 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
	return result;
#line 6365 "PulseAudioManager.c"
}

static gpointer
_pa_context_ref0 (gpointer self)
{
#line 43 "../src/PulseAudioManager.vala"
	return self ? pa_context_ref (self) : NULL;
#line 6373 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_context (SoundPulseAudioManager* self,
                                       pa_context* value)
{
	pa_context* old_value;
#line 43 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/PulseAudioManager.vala"
	old_value = sound_pulse_audio_manager_get_context (self);
#line 43 "../src/PulseAudioManager.vala"
	if (old_value != value) {
#line 6387 "PulseAudioManager.c"
		pa_context* _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
		_tmp0_ = _pa_context_ref0 (value);
#line 43 "../src/PulseAudioManager.vala"
		_pa_context_unref0 (self->priv->_context);
#line 43 "../src/PulseAudioManager.vala"
		self->priv->_context = _tmp0_;
#line 43 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY]);
#line 6397 "PulseAudioManager.c"
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_output (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_output;
#line 49 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
	return result;
#line 6414 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_output (SoundPulseAudioManager* self,
                                              SoundDevice* value)
{
	SoundDevice* old_value;
#line 49 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/PulseAudioManager.vala"
	old_value = sound_pulse_audio_manager_get_default_output (self);
#line 49 "../src/PulseAudioManager.vala"
	if (old_value != value) {
#line 6428 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 49 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_output);
#line 49 "../src/PulseAudioManager.vala"
		self->priv->_default_output = _tmp0_;
#line 49 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY]);
#line 6438 "PulseAudioManager.c"
	}
}

SoundDevice*
sound_pulse_audio_manager_get_default_input (SoundPulseAudioManager* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/PulseAudioManager.vala"
	_tmp0_ = self->priv->_default_input;
#line 50 "../src/PulseAudioManager.vala"
	result = _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
	return result;
#line 6455 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_set_default_input (SoundPulseAudioManager* self,
                                             SoundDevice* value)
{
	SoundDevice* old_value;
#line 50 "../src/PulseAudioManager.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/PulseAudioManager.vala"
	old_value = sound_pulse_audio_manager_get_default_input (self);
#line 50 "../src/PulseAudioManager.vala"
	if (old_value != value) {
#line 6469 "PulseAudioManager.c"
		SoundDevice* _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 50 "../src/PulseAudioManager.vala"
		_g_object_unref0 (self->priv->_default_input);
#line 50 "../src/PulseAudioManager.vala"
		self->priv->_default_input = _tmp0_;
#line 50 "../src/PulseAudioManager.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY]);
#line 6479 "PulseAudioManager.c"
	}
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
#line 68 "../src/PulseAudioManager.vala"
	for (i = 0; i < stack_length; i++) {
#line 68 "../src/PulseAudioManager.vala"
		if (g_strcmp0 (stack[i], needle) == 0) {
#line 68 "../src/PulseAudioManager.vala"
			return TRUE;
#line 6495 "PulseAudioManager.c"
		}
	}
#line 68 "../src/PulseAudioManager.vala"
	return FALSE;
#line 6500 "PulseAudioManager.c"
}

static GObject *
sound_pulse_audio_manager_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundPulseAudioManager * self;
	pa_glib_mainloop* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gchar* messages_debug_raw = NULL;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
#line 59 "../src/PulseAudioManager.vala"
	parent_class = G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class);
#line 59 "../src/PulseAudioManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 59 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 60 "../src/PulseAudioManager.vala"
	_tmp0_ = pa_glib_mainloop_new (NULL);
#line 60 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 60 "../src/PulseAudioManager.vala"
	self->priv->loop = _tmp0_;
#line 61 "../src/PulseAudioManager.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 61 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 61 "../src/PulseAudioManager.vala"
	self->priv->input_devices = _tmp1_;
#line 62 "../src/PulseAudioManager.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, SOUND_TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 62 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 62 "../src/PulseAudioManager.vala"
	self->priv->output_devices = _tmp2_;
#line 63 "../src/PulseAudioManager.vala"
	_tmp3_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 63 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 63 "../src/PulseAudioManager.vala"
	self->priv->volume_operations = _tmp3_;
#line 65 "../src/PulseAudioManager.vala"
	_tmp4_ = g_getenv ("G_MESSAGES_DEBUG");
#line 65 "../src/PulseAudioManager.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 65 "../src/PulseAudioManager.vala"
	messages_debug_raw = _tmp5_;
#line 66 "../src/PulseAudioManager.vala"
	_tmp6_ = messages_debug_raw;
#line 66 "../src/PulseAudioManager.vala"
	if (_tmp6_ != NULL) {
#line 6559 "PulseAudioManager.c"
		gchar** messages_debug = NULL;
		const gchar* _tmp7_;
		gchar** _tmp8_;
		gchar** _tmp9_;
		gint messages_debug_length1;
		gint _messages_debug_size_;
		gboolean _tmp10_ = FALSE;
		gchar** _tmp11_;
		gint _tmp11__length1;
#line 67 "../src/PulseAudioManager.vala"
		_tmp7_ = messages_debug_raw;
#line 67 "../src/PulseAudioManager.vala"
		_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, " ", 0);
#line 67 "../src/PulseAudioManager.vala"
		messages_debug = _tmp9_;
#line 67 "../src/PulseAudioManager.vala"
		messages_debug_length1 = _vala_array_length (_tmp8_);
#line 67 "../src/PulseAudioManager.vala"
		_messages_debug_size_ = messages_debug_length1;
#line 68 "../src/PulseAudioManager.vala"
		_tmp11_ = messages_debug;
#line 68 "../src/PulseAudioManager.vala"
		_tmp11__length1 = messages_debug_length1;
#line 68 "../src/PulseAudioManager.vala"
		if (_vala_string_array_contains (_tmp11_, _tmp11__length1, "all")) {
#line 68 "../src/PulseAudioManager.vala"
			_tmp10_ = TRUE;
#line 6587 "PulseAudioManager.c"
		} else {
			gchar** _tmp12_;
			gint _tmp12__length1;
#line 68 "../src/PulseAudioManager.vala"
			_tmp12_ = messages_debug;
#line 68 "../src/PulseAudioManager.vala"
			_tmp12__length1 = messages_debug_length1;
#line 68 "../src/PulseAudioManager.vala"
			_tmp10_ = _vala_string_array_contains (_tmp12_, _tmp12__length1, "debug");
#line 6597 "PulseAudioManager.c"
		}
#line 68 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_debug_enabled = _tmp10_;
#line 66 "../src/PulseAudioManager.vala"
		messages_debug = (_vala_array_free (messages_debug, messages_debug_length1, (GDestroyNotify) g_free), NULL);
#line 6603 "PulseAudioManager.c"
	}
#line 59 "../src/PulseAudioManager.vala"
	_g_free0 (messages_debug_raw);
#line 59 "../src/PulseAudioManager.vala"
	return obj;
#line 6609 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_class_init (SoundPulseAudioManagerClass * klass,
                                      gpointer klass_data)
{
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/PulseAudioManager.vala"
	g_type_class_adjust_private_offset (klass, &SoundPulseAudioManager_private_offset);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_pulse_audio_manager_get_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_pulse_audio_manager_set_property;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_pulse_audio_manager_constructor;
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_pulse_audio_manager_finalize;
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY] = g_param_spec_pointer ("context", "context", "context", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY] = g_param_spec_object ("default-output", "default-output", "default-output", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY, sound_pulse_audio_manager_properties[SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY] = g_param_spec_object ("default-input", "default-input", "default-input", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/PulseAudioManager.vala"
	sound_pulse_audio_manager_signals[SOUND_PULSE_AUDIO_MANAGER_NEW_DEVICE_SIGNAL] = g_signal_new ("new-device", SOUND_TYPE_PULSE_AUDIO_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, SOUND_TYPE_DEVICE);
#line 6636 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_instance_init (SoundPulseAudioManager * self,
                                         gpointer klass)
{
#line 29 "../src/PulseAudioManager.vala"
	self->priv = sound_pulse_audio_manager_get_instance_private (self);
#line 45 "../src/PulseAudioManager.vala"
	self->priv->is_ready = FALSE;
#line 46 "../src/PulseAudioManager.vala"
	self->priv->reconnect_timer_id = 0U;
#line 6649 "PulseAudioManager.c"
}

static void
sound_pulse_audio_manager_finalize (GObject * obj)
{
	SoundPulseAudioManager * self;
#line 29 "../src/PulseAudioManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 43 "../src/PulseAudioManager.vala"
	_pa_context_unref0 (self->priv->_context);
#line 44 "../src/PulseAudioManager.vala"
	_pa_glib_mainloop_free0 (self->priv->loop);
#line 47 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->input_devices);
#line 48 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->output_devices);
#line 49 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_output);
#line 50 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->_default_input);
#line 51 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_source_name);
#line 52 "../src/PulseAudioManager.vala"
	_g_free0 (self->priv->default_sink_name);
#line 53 "../src/PulseAudioManager.vala"
	_g_object_unref0 (self->priv->volume_operations);
#line 29 "../src/PulseAudioManager.vala"
	G_OBJECT_CLASS (sound_pulse_audio_manager_parent_class)->finalize (obj);
#line 6678 "PulseAudioManager.c"
}

static GType
sound_pulse_audio_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPulseAudioManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_pulse_audio_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPulseAudioManager), 0, (GInstanceInitFunc) sound_pulse_audio_manager_instance_init, NULL };
	GType sound_pulse_audio_manager_type_id;
	sound_pulse_audio_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundPulseAudioManager", &g_define_type_info, 0);
	SoundPulseAudioManager_private_offset = g_type_add_instance_private (sound_pulse_audio_manager_type_id, sizeof (SoundPulseAudioManagerPrivate));
	return sound_pulse_audio_manager_type_id;
}

GType
sound_pulse_audio_manager_get_type (void)
{
	static volatile gsize sound_pulse_audio_manager_type_id__once = 0;
	if (g_once_init_enter (&sound_pulse_audio_manager_type_id__once)) {
		GType sound_pulse_audio_manager_type_id;
		sound_pulse_audio_manager_type_id = sound_pulse_audio_manager_get_type_once ();
		g_once_init_leave (&sound_pulse_audio_manager_type_id__once, sound_pulse_audio_manager_type_id);
	}
	return sound_pulse_audio_manager_type_id__once;
}

static void
_vala_sound_pulse_audio_manager_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_pointer (value, sound_pulse_audio_manager_get_context (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_output (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		g_value_set_object (value, sound_pulse_audio_manager_get_default_input (self));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6731 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6737 "PulseAudioManager.c"
	}
}

static void
_vala_sound_pulse_audio_manager_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SoundPulseAudioManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_PULSE_AUDIO_MANAGER, SoundPulseAudioManager);
#line 29 "../src/PulseAudioManager.vala"
	switch (property_id) {
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_CONTEXT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_context (self, g_value_get_pointer (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_OUTPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_output (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 29 "../src/PulseAudioManager.vala"
		case SOUND_PULSE_AUDIO_MANAGER_DEFAULT_INPUT_PROPERTY:
#line 29 "../src/PulseAudioManager.vala"
		sound_pulse_audio_manager_set_default_input (self, g_value_get_object (value));
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6769 "PulseAudioManager.c"
		default:
#line 29 "../src/PulseAudioManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/PulseAudioManager.vala"
		break;
#line 6775 "PulseAudioManager.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

